2023-07-29  Torbjörn Granlund  <tg@gmplib.org>

	* Version 6.3.0 released.

	* mpn/s390_64/z13/mul_basecase.asm: Rewrite, using new addmul_1.asm.

	* mpn/s390_64/z13/mul_1.asm: Rewrite.
	* mpn/s390_64/z13/addmul_1.asm: Likewise.
	* mpn/s390_64/z13/submul_1.asm: Likewise.

2023-07-27  Niels Möller  <nisse@lysator.liu.se>

	Update DIV_QR_1N_PI1_METHOD to use method 3 or 4.
	* mpn/arm64/applem1/gmp-mparam.h: Update DIV_QR_1N_PI1_METHOD.
	* mpn/arm64/cora57/gmp-mparam.h: Likewise.
	* mpn/arm64/xgene1/gmp-mparam.h: Likewise.
	* mpn/powerpc64/mode64/p7/gmp-mparam.h: Likewise.
	* mpn/powerpc64/mode64/p8/gmp-mparam.h: Likewise.
	* mpn/powerpc64/mode64/p9/gmp-mparam.h: Likewise.
	* mpn/sparc64/ultrasparct45/gmp-mparam.h: Likewise.
	* mpn/x86/coreihwl/gmp-mparam.h: Likewise.
	* mpn/x86/k7/gmp-mparam.h: Likewise.

2023-07-26  Niels Möller  <nisse@lysator.liu.se>

	* tune/speed.h (mpn_hgcd_appr_lehmer): Fix declaration to use
	correct return type.

2023-07-26  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/s390_64/z13/submul_1.asm: New file.
	* mpn/s390_64/z13/popcount.asm: New file.
	* mpn/s390_64/z13/hamdist.asm: New file.

2023-07-25  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/s390_64/z13/addmul_2.asm: New file.
	* mpn/s390_64/z13/addmul_1.asm: New file.
	* mpn/s390_64/z13/addmul_2.asm: New file.
	* mpn/s390_64/z13/mul_1.asm: New file.
	* mpn/s390_64/z13/mul_2.asm: New file.
	* mpn/s390_64/z13/mul_basecase.asm: New file.
	* mpn/s390_64/z13/sqr_basecase.c: New file.

2023-07-20  Torbjörn Granlund  <tg@gmplib.org>

	* config.guess: Generalise sparc patterns.

2023-07-19  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/div_qr_1n_pi2.c, mpn/generic/div_qr_1n_pi1.c,
	mpn/generic/mod_1_1.c, mpn/generic/div_qr_1u_pi2.c,
	mpn/generic/div_qr_2.c: Get arm64 asm contraints right for adcs.

2023-07-18  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Suppress any -flto flags for running GMP_ASM_*.

2023-07-15  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Pass -mcpu= instead of -mtune= consistently for ibm power.

	* mpn/riscv/64: Improve Risc V asm support.
	* mpn/loongarch/64: Provide basic Loongarch asm support.

2023-07-06  Marc Glisse  <marc.glisse@inria.fr>

	* doc/gmp.texi: Mention snapshots in bug report instructions.

	* configfsf.guess: Updated to version 2023-06-23, from gnulib.
	* configfsf.sub: Updated to version 2023-06-26, from gnulib.

2023-06-29  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Make sparc -mptr64 argument optional.

	* configure.ac, config.guess, config.sub, acinclude.m4: Handle power10.

2023-06-23 Marius Hillenbrand <mhillen@linux.ibm.com>
	   Stefan Liebler <stli@linux.ibm.com>

	* mpn/s390_64/z13/addmul_1.c: New file.
	* mpn/s390_64/z13/aormul_2.c: New file.
	* mpn/s390_64/z13/common-vec.h: New file.
	* mpn/s390_64/z13/gmp-mparam.h: New file.
	* mpn/s390_64/z13/mul_1.c: New file.
	* mpn/s390_64/z13/mul_basecase.c: New file.

2022-11-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd1/popcount.asm: Prefer movd to movq for register moves.
	* mpn/x86_64/bd1/hamdist.asm: Likewise.
	* mpn/x86_64/core2/hamdist.asm: Likewise.
	* mpn/x86_64/core2/popcount.asm: Likewise.

2022-10-28 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/nextprime.c (findnext): Use TMP_ALLOC_TYPE to allocate
	composite array (tx: Jiayi Lin)

2022-09-30  Marc Glisse  <marc.glisse@inria.fr>

	* doc/projects.html: Update URL for MPFR.
	* doc/gmp.texi: Likewise.

2022-08-11 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/primorial_ui.c: Rename some variables and add comments.

2022-06-19 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/millerrabin.c: Use mp_bitcnt_t.
	* mpz/stronglucas.c: Skip some impossible values searching for D.

2022-05-14 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/nextprime.c: Smaller operand for mpz_sqrt.
	* tests/mpz/t-nextprime.c: Exit on error.
	* tests/mpz/t-pprime_p.c: More cases to trigger unlikely branches.

	* tests/mpz/t-aorsmul.c: Test the (r,x,x) case.
	* mpz/aorsmul.c: Speed-up the (r,x,x) case (tx:Fredrik Johansson).

2022-04-24  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm/v5/gcd_22.asm: New file.

2022-04-18  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (mpz_class): Do not use mp directly.

2022-03-30  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac, config.guess, config.sub, acinclude.m4: Handle Intel
	tremont separately.

	* longlong.h (loongarch64 umul_ppmm): New #define.

2022-03-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/t-lucm.c: Remove an unused var.
	* tests/mpq/io.c: Use a random size.
	* tests/mpz/t-gcd.c: Do not assume a limb fits for _ui functions.

2022-03-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/mul_fft.c: Use _bknp1. Not when tuning, to avoid "noise".

2022-03-09  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/alderlake/submul_1.asm: New file.

2022-03-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/mulmod_bnm1.c: Use mulmod_bknp1, on the bnp1 side.
	* mpn/generic/sqrmod_bnm1.c: Likewise.

	* mpn/generic/mul_fft.c: Remove a branch and improve carry propagation.

2022-03-03  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/alderlake/mul_basecase.asm: New file.
	* mpn/x86_64/alderlake/addmul_1.asm: New file.

2022-02-21  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Handle alderlake specifically, as it lacks avx512.

2022-02-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/strongfibo.c: Correct condition in #if.

	* mpn/generic/mulmod_bknp1.c: New file, with mpn_{mul,sqr}mod_bknp1.
	* configure.ac (gmp_mpn_functions): Add new file.
	* gmp-impl.h: Declare new functions.
	* gmp-impl.h (MPN_{MUL,SQR}MOD_BKNP1_USABLE): Support new functions.

	* tests/mpn/t-{mul,sqr}mod_bknp1.c: New tests for mpn_{mul,sqr}mod_bknp1.
	* tests/mpn/Makefile.am: Add new tests.

	* tune/speed.c: Recognise new functions: mpn_{mul,sqr}mod_bknp1.
	* tune/speed.h: Declare new speed_ functions to measure them.
	* tune/common.c: Implement speed_ functions.

2022-02-14  Torbjörn Granlund  <tg@gmplib.org>

	* config.guess: Recognize Tremont CPU variants.

2022-02-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/aorsmul_i.c: Use MPZ_NEWALLOC when the operand is overwritten.
	* mpz/import.c: Reorder branches.
	* mpz/{init2.c,realloc.c,realloc2.c}: Remove unneeded #includes.

2022-01-20  Marc Glisse  <marc.glisse@inria.fr>

	* doc/gmp.texi: Clarify C++ includes and library.

2022-01-05 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gen-sieve.c: Generate masks depending on bit size.
	* primesieve.c: Remove fixed size (32 and 64 only) masks.

	* tune/speed.c: Add FLAG_NODATA for gmp_primesieve.

2021-12-11 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/toom3_sqr.c: Use a shorter mul when it's simple.
	* mpn/generic/toom4_sqr.c: Likewise.
	* mpn/generic/toom33_mul.c: Likewise.
	* mpn/generic/toom44_mul.c: Likewise.

	* gmp-h.in (GMP_ERROR_MPZ_OVERFLOW): New enum value.
	* errno.c (__gmp_overflow_in_mpz): New function.
	* gmp-impl.h (MPZ_OVERFLOW): New macro calling it.
	* mpz/init2.c: Use the new macro to rise the overflow error.
	* mpz/realloc.c: Likewise.
	* mpz/realloc2.c: Likewise.

	* mpz/tdiv_r.c: Special code for divisor with low zero limbs.
	* mpz/tdiv_qr.c: Likewise.

2021-11-14  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Adapt to acinclude.m4 change.

	* mpn/riscv/64/aors_n.asm: Accept 4th CMPCY operand, allowing for
	2 c/l mpn_sub_n (mpn_add_n cannot beat 3 c/l with RISC V's ISA).

	* configure.ac (S390_PATTERN): Rewrite to handle path inheritance.

	* acinclude.m4 (GMP_ASM_SPARC_GDOP): Renamed GMP_ASM_SPARC_GOTDATA.

	* mpn/sparc32/sparc-defs.m4 (LEA64): Remove misguided assert.
	* mpn/sparc32/sparc-defs.m4 (LEA64): Allow PIC withot gdop_*.

	* mpn/sparc64/gcd_11.asm: Optimise out annulled shift insn in loop.

2021-11-07  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/sec_tabselect.c: Make recently added code actually work.
	(Thanks Marco!)

	* mpn/s390_32/sec_tabselect.asm: New file.

	* mpn/s390_64/sec_tabselect.asm: Avoid "slfi" for portability.

2021-11-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/s390_64/sec_tabselect.asm: Rewrite.

	* mpn/generic/sec_tabselect.c: Provide alternative function.

2021-10-31  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/riscv/64/sec_tabselect.asm: New file.
	* mpn/s390_64/sec_tabselect.asm: New file.
	* mpn/x86/sec_tabselect.asm: Streamline.

2021-10-31 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/fac_ui.c: Save half the products for small values.

2021-10-29  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/sec_tabselect.c: Rewrite.

2021-10-16  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac, config.guess, config.sub, acinclude.m4: Recognise more
	icelake CPUs, and initial alderlake CPUs.

	* mpn/powerpc64/mode64/p9/addaddmul_1msb0.asm: New file.

	* mpn/arm64/applem1/addaddmul_1msb0.asm: New file.

2021-10-10  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/k8/addaddmul_1msb0.asm: Moved from "..".

2021-10-08  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpn/t-addaddmul.c: Unit test for mpn_addaddmul_1msb0.

2021-10-07  Niels Möller  <nisse@lysator.liu.se>

	* tune/speed.h (SPEED_ROUTINE_MPN_ADDADDMUL1_MSB0): New macro.
	* tune/common.c (speed_mpn_addaddmul_1msb0): New function.
	* tune/speed.c (routine): Add mpn_addaddmul_1msb0 to list.

2021-10-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gen-sieve.c: New file to generate a small presieved array.
	* primesieve.c (first_block_primesieve): Use the presieved array.
	* gmp-impl.h: #include output of gen-sieve.
	* Makefile.am: Add rules for gen-sieve and sieve_table.h.

	* mpn/x86_64/addaddmul_1msb0.asm: Support DOS ABI, reorder branches.

2021-09-26  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (s390): Make sure to always include main asm directory.

	* longlong.h (umul_ppmm): Correct Risc V operand order.

2021-09-25 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/import.c: Use MPN_BSWAP_REVERSE, reorder branches.
	* mpz/inp_raw.c: Avoid bit size overflows.

2021-09-22  Torbjörn Granlund  <tg@gmplib.org>

	* config.sub: Update powerpc pattern.

	* longlong.h: Change tested predef for Risc V.

2021-08-21 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/primorial_ui.c: Simpler loop on sieved primes.
	* mpz/nextprime.c: Likewise.

2021-09-14  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/asm-defs.m4: Remove quotes around PIC_ALWAYS.  Reported by
	George Koehler.

2021-07-01  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/div_qr_1n_pi1.c (mpn_div_qr_1n_pi1): New variants,
	DIV_QR_1N_METHOD 3 and 4.

	* tune/div_qr_1n_pi1_3.c: New file.
	* tune/div_qr_1n_pi1_4.c: New file.
	* tune/Makefile.am (libspeed_la_SOURCES): Add new files.
	* tune/div_qr_1_tune.c (__gmpn_div_qr_1n_pi1): Handle new values
	of div_qr_1n_pi1_method.
	* tune/common.c (speed_mpn_div_qr_1n_pi1_3)
	(speed_mpn_div_qr_1n_pi1_4): New functions.
	* tune/speed.c (routine): Add mpn_div_qr_1n_pi1_3 and
	mpn_div_qr_1n_pi1_3 to list.
	* tune/speed.h: Declare new functions.
	* tune/tuneup.c (tune_div_qr_1): Extend tuning of
	DIV_QR_1N_PI1_METHOD.

2021-06-20  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (mpq_class(mpz_class&&)): New constructor.

2021-06-20  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi: Document foo_ptr and foo_srcptr.

2021-06-06  Paul Eggert  <eggert@cs.ucla.edu>

	* configure.ac (AC_INIT): Avoid comma in BUG-REPORT field.

2021-06-06  Marc Glisse  <marc.glisse@inria.fr>

	* gmp-h.in (gmp_randstate_ptr, gmp_randstate_srcptr): Move declaration
	from gmp-impl.h.
	(gmp_randinit, gmp_randinit_default, gmp_randinit_lc_2exp,
	gmp_randinit_lc_2exp_size, gmp_randinit_mt, gmp_randinit_set,
	gmp_randseed, gmp_randseed_ui, gmp_randclear, gmp_urandomb_ui,
	gmp_urandomm_ui, mpz_rrandomb, mpz_urandomb, mpz_urandomm,
	mpf_urandomb): Replace gmp_randstate_t with gmp_randstate_ptr.
	* gmp-impl.h (gmp_randstate_ptr, gmp_randstate_srcptr): Move
	declaration to gmp-h.in.
	(gmp_randfnptr_t, __gmp_randinit_mt_noseed): Replace gmp_randstate_t
	with gmp_randstate_ptr.
	* mpf/reldiff.c: Replace mpf_t with mpf_ptr.
	* mpf/set_q.c: Likewise.
	* mpf/urandomb.c: Likewise.
	* mpq/canonicalize.c: Replace mpq_t with mpq_ptr.
	* mpq/clear.c: Likewise.
	* mpq/init.c: Likewise.
	* mpq/set_si.c: Likewise.
	* mpq/set_ui.c: Likewise.
	* mpz/rrandomb.c: Replace gmp_randstate_t with gmp_randstate_ptr.
	* mpz/urandomb.c: Likewise.
	* mpz/urandomm.c: Likewise.
	* rand/rand.c: Likewise.
	* rand/randclr.c: Likewise.
	* rand/randdef.c: Likewise.
	* rand/randlc2s.c: Likewise.
	* rand/randlc2x.c: Likewise.
	* rand/randmt.c: Likewise.
	* rand/randmt.h: Likewise.
	* rand/randmts.c: Likewise.
	* rand/randsd.c: Likewise.
	* rand/randsdui.c: Likewise.

	* gmp-impl.h: Include stdint.h even if we have inttypes.h.
	* printf/doprnt.c: Likewise.
	* printf/repl-vsnprintf.c: Likewise.
	* scanf/doscan.c: Likewise.
	* tests/misc/t-printf.c: Likewise.
	* tests/misc/t-scanf.c: Likewise.

2021-06-03  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/div_qr_1n_pi1.c (mpn_div_qr_1n_pi1): Micro-optimize
	method 2, and document the main idea of the algorithm.

2021-05-25 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/sec_powm.c (sec_binvert_limb): New static function.

	* mpn/generic/powm.c (win_size): Remove the unused value from array.
	* mpn/generic/sec_powm.c (win_size): Likewise.

2021-05-08  Marc Glisse  <marc.glisse@inria.fr>

	* doc/gmp.texi: Mention shifts in bit manipulation.

2021-05-02  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac, config.guess, config.sub: Recognise CPUs icelake,
	tigerlake, and rocketlake.

	* configure.ac: Clean up handling of several Intel CPUs.

2021-03-11  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h: Disable s390 patterns which makes clang barf.

2021-03-09  Torbjörn Granlund  <tg@gmplib.org>

	With Marius Hillenbrand:
	* configure.ac, config.guess, config.sub, acinclude.m4:
	Recognise CPUs z13-z15.

2021-03-08  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (68000 umul_ppmm): Add an early-clobber &.

2021-01-18  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen3/sbpi1_bdiv_r.asm: New grabber file.

2021-01-17  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreibwl/sbpi1_bdiv_r.asm: New file.

2021-01-01  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Handle zen3 different from zen2.

	* mpn/x86_64/zen3/addmul_1.asm: New grabber file.
	* mpn/x86_64/zen3/mul_basecase.asm: Likewise.
	* mpn/x86_64/zen3/sqr_basecase.asm: Likewise.

	* mpn/x86_64/zen3/mul_1.asm: New file.

2020-12-25  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/applem1/sqr_basecase.asm: New file, do 2x and limb squaring
	in main loop.

2020-12-21  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/applem1/aorsmul_1.asm: Provide addmul_1c entry point.

2020-12-20  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/copyi.asm: Rewrite to use scalar regs.
	* mpn/arm64/copyd.asm: Likewise.

2020-12-12  Marc Glisse  <marc.glisse@inria.fr>

	* gmp-h.in (_GMP_H_HAVE_FILE): Test also _STDIO (for HPE NonStop).

2020-12-04  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/applem1/gmp-mparam.h: New file.

	* mpn/generic/mod_1_1.c: Provide add_mssaaaa for arm64.
	* mpn/generic/div_qr_1n_pi1.c: Likewise.

	* mpn/arm64/divrem_1.asm: Use sub insn for subtracting constants.

2020-11-29  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/divrem_1.asm: New file.
	* mpn/arm64/applem1/aorsmul_1.asm: New file.

	* configure.ac, config.guess, config.sub: Recognise CPU "applem1".

	* mpn/arm64: Avoid the x18 register since it is reserved on Darwin.

2020-11-28 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/t-pprime_p.c (check_fermat_mersenne): Check return
	value.

	* tests/devel/primes.c: Correctly use n_cto_bit or n_fto_bit.
	* primesieve.c: Differentiate n_to_bit into floor and ceil.

2020-11-23 Seth Troisi <sethtroisi@google.com>

	* mpz/nextprime.c (mpz_prevprime): New function.
	* gmp-h.in: Declare it.
	* doc/gmp.texi: Document it.
	* tests/mpz/t-nextprime.c: Test it.

	* tests/mpz/t-pprime_p.c (check_small): Check return value.

	* tune/common.c (speed_mpz_prevprime{,_1}): New functions.
	* tune/speed.h: Declare them.
	* tune/speed.c (routine): Add mpz_nextprime{,_1}.

2020-11-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* configure.ac (fat_path): Add bd1, goldmont,silvermont for CPUVEC.
	* mpn/x86_64/fat/fat.c: Add more CPUs.
	* mpn/x86/fat/fat.c: Add more CPUs.

2020-11-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* configure.ac: X86_{,64_}PATTERN: GMP_ASM_COFF_TYPE for all ABIs;
	* mpn/x86_64/x86_64-defs.m4 (COFF_TYPE): Copy from mpn/x86/x86-defs.m4
	as suggested by Jeremy Drake.

	* tests/misc/t-locale.c (nl_langinfo): No redefine on __TERMUX__,
	spotted by Sanselme and Glisse.
	* configure.ac: Consider *-*-msys as *-*-mingw* (except on arm* |
	aarch64*), as suggested by Ralph Peterson.
	* Makefile.am (EXTRA_DIST): Add mini-gmp/ChangeLog.

2020-10-30 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpf/t-get_d_2exp.c: Test also the case zero.
	* tests/mpz/t-get_d.c: Likewise.
	* tests/mpf/t-trunc.c: Use mpf_size.

	* tests/mpf/t-conv.c: Some more tests on zero.
	* mpn/generic/mod_1.c (mpn_mod_1_unnorm): Compare r<d before shifting.
	* mpf/mul.c: Use macros.

2020-10-29 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/aors_ui.h: REALLOC with extra limb only when needed.

	* mpz/bin_uiui.c (limb_apprsqrt): Slightly faster formula.
	* mpz/oddfac_1.c (limb_apprsqrt): Likewise.
	* mpz/stronglucas.c (limb_apprsqrt): Likewise.

2020-10-25 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* configfsf.guess: Updated to version 2020-10-22, from gnulib.
	* configfsf.sub: Updated to version 2020-10-13, from gnulib.

2020-10-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* bootstrap.c (mpz_invert_2exp): Simplify.
	* mpz/stronglucas.c (mpz_oddjacobi_ui): New helper function.

	* tests/devel/Makefile.am: Remove redundancies.

	* tests/mpz/io.c: Test out-of-range bases for mpz_out_str.

2020-10-15  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Recognise zen3.
	* config.guess: Recognise zen3.

2020-10-14 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* doc/gmp.texi (Number sequences): Remove redundancy. (spotted: TonyMcC)

2020-10-06  Niels Möller  <nisse@lysator.liu.se>

	* Makefile.am: Better support for make check-mini-gmp on wine or cygwin.

2020-09-22  Torbjörn Granlund  <tg@gmplib.org>

	* tests/mpz/t-mul.c: Print GMP_CHECK_FFT.

	* longlong.h (x86 umul_ppmm): Fix typo.

2020-07-04  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/bdiv_q_1.asm: Use LEA_HI/LEA_LO
	* mpn/arm64/invert_limb.asm: Likewise.

	* mpn/arm64/arm64-defs.m4: New file.
	* mpn/arm64/darwin.m4: New file.
	* configure.ac: Use arm64/arm64-defs.m4 and arm64/darwin.m4.

2020-06-11  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc32/powerpc-defs.m4 (aese,aeselst): New macros.

2020-06-10  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Recognise armcortexa55.

2020-05-25  Torbjörn Granlund  <tg@gmplib.org>

	* tests/cxx/t-assign.cc: Use reference parameter for 'catch'.
	* tests/cxx/t-constr.cc: Likewise.
	* tests/cxx/t-ops2z.cc: Likewise.
	* tests/cxx/t-rand.cc: Likewise.
	* tests/cxx/t-do-exceptions-work-at-all-with-this-compiler.cc: Likewise.

2020-05-21  Torbjörn Granlund  <tg@gmplib.org>

	* tune/time.c (speed_endtime): Cast printf args to right type.

	* tune/speed.c (main): Cast printf args to right type.

	* tests/mpz/reuse.c: Avoid using non-standard function fileno().
	* tests/spinner.c: Likewise.

	* tests/mpz/convert.c (str_casecmp): New function.
	(main): Use it instead of non-standard strcasecmp.

	* mpn/generic/get_d.c: Add clarifying parens.

2020-05-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq/cmp.c: Avoid overflow on int even for huge sizes.

2020-05-12  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/hgcd2-div.h (tabp): Combine several undefined tabp
	variable definitions with a macro.

	* mpn/generic/strongfibo.c: Avoid defining helper function when unused.

	* mpn/generic/dcpi1_bdiv_q.c (mpn_dcpi1_bdiv_q_n_itch): Disable unused
	static function.

	* mpz/mul.c: Add some {} to suppress warning.

	* tests/mpn/t-gcd_11.c: Exit main() properly.
	* tests/mpn/t-gcd_22.c: Likewise.
	* tests/mpn/t-gcdext_1.c: Likewise.

2020-04-28  Torbjörn Granlund  <tg@gmplib.org>

	* tests/mpz/reuse.c (realloc_if_reducing): New function.
	(INVOKE_RRS, etc): Use realloc_if_reducing.

2020-03-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/mulmod_bnm1.c (mpn_bc_mulmod_bnp1):
	Simplify special cases.
	* mpz/bin_ui.c (rek_raising_fac4): Reduce allocations.
	(mpz_bin_ui): Siplify special cases.
	* tests/mpz/t-bin.c: Use divexact.

	* mpn/generic/mul_fft.c (mpn_fft_mul_modF_K):
	Fully handle carry propagation in basecase multiplication.

2020-02-12 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/cmp.c: Avoid overflow on int even for huge sizes.
	* mpz/cmpabs.c: Likewise.

2020-02-09 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/sqrmod_bnm1.c (mpn_bc_sqrmod_bnp1):
	Shorter mpn_sqr.
	* mpn/generic/mulmod_bnm1.c (mpn_bc_mulmod_bnp1):
	Shorter mpn_mul_n.

	* tests/mpn/t-mulmod_bnm1.c: Trigger special cases more often.
	* tests/mpn/t-sqrmod_bnm1.c: Likewise.

2020-02-09 Seth Troisi <sethtroisi@google.com>

	* tests/mpz/t-nextprime.c: Split into sub-tests.

2020-02-02 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/powm.c: Better handling of current window-size.
	* mpn/generic/powlo.c: Likewise.

	* mpn/generic/jacbase.c (mpn_jacobi_base): Optimise _METHOD 4.
	* mpz/aors.h: Branches optimisation.

2020-01-31 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/powm.c (MPN_REDC_0): Subtractive redc
	(mpn_2powm): New, static, function
	* tests/mpz/t-powm.c: More tests for the base=2 case.

2020-01-24  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/hgcd2_jacobi.c (div1, div2): Deleted. Instead,
	include hgcd2-div.h, to reuse the tuned implementations for hgcd2.
	(mpn_hgcd2_jacobi): Adapt to different return value for div1. Also
	other small changes to make it identical to mpn_hgcd2, except for
	the updates of the jacobi-related state.

	* mpn/generic/hgcd2.c (div1, div2): Move inline functions...
	* mpn/generic/hgcd2-div.h: ... to a separate file.

2020-01-17  Torbjörn Granlund  <tg@gmplib.org>

	* Version 6.2.0 released.

	* gmp-h.in (__GNU_MP__): Bump.
	(__GNU_MP_VERSION,__GNU_MP_VERSION_MINOR,__GNU_MP_VERSION_PATCHLEVEL):
	Bump version info.
	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*, LIBMP_LT_*):
	Bump version info.

2020-01-15  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bt1/gcd_11.asm: Add missing FUNC_EXIT.

2020-01-10  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (powerpc): Add clobbers, make formatting cleanups.

	* configure.ac (HAVE_NATIVE): Add mpn_sbpi1_bdiv_r.

	* tune/tune-gcd-p.c (main): Use %zu for size_t printing.

	* configfsf.guess: Update from upstream.

	* mpn/x86/pentium4/sse2/popcount.asm: For simplicity and correctness
	use LEAL directly.

2020-01-03  Niels Möller  <nisse@lysator.liu.se>

	* configure.ac: Delete suggestion to use TESTS_ENVIRONMENT to run
	wine. It worked only with older versions of automake.

2019-12-23  Torbjörn Granlund  <tg@gmplib.org>

	* mpf/mul.c: Rewrite to invoke mpn_sqr when appropriate.

2019-12-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/powm.c: Full normalisation when e=1 & b<0.
	* tests/mpz/t-powm.c: More tests for the e=1 case.

2019-12-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/gcd_11.c: Remove check for NATIVE_ implementation.

2019-11-24  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcdext_1.c [USE_ZEROTAB]: Delete code variant for
	USE_ZEROTAB != 0. Was used in the currently disabled binary
	gcdext.

2019-11-20  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/powm.c (MPN_REDC_1): Prefer mpn_sbpi1_bdiv_r when it is
	provided.
	* mpn/generic/sec_powm.c (MPN_REDC_1_SEC): Likewise.

2019-11-17  Torbjörn Granlund  <tg@gmplib.org>

	* config.guess: Recognise zen2.
	* configure.ac: Likewise.

	* mpn/x86_64/bt1/aorsmul_1.asm: Rewrite.
	* mpn/x86_64/bt1/mul_1.asm: Rewrite.

	* mpn/arm/v6t2/gcd_11.asm: Increase alignment; update x/l table.

2019-11-16 Seth Troisi <sethtroisi@google.com>

	* tune/common.c (speed_mpn_perfect_power_p): New function.
	(speed_mpn_perfect_power_p): New function.
	* tune/speed.h: Declare both.
	* tune/speed.c (routine): Add mpn_perfect_{power,square}_p.

	* tune/common.c (speed_mpz_nextprime): New function.
	* tune/speed.h: Declare it.
	* tune/speed.c (routine): Add mpz_nextprime.

2019-11-09 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tune/speed.c (routine_t): Add R flag to mpz_powm
	* tune/speed.h (SPEED_ROUTINE_MPZ_POWM): Use R flag as the base.

2019-10-02  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Make more path distinctions for the benefit of
	gmp-mparam.h.

2019-10-01  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (arm64): Let cortex-a7x look in a57 folder.

2019-10-01  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcdext_1.c (mpn_gcdext_1) [GCDEXT_1_USE_BINARY]: Fix
	canonicalization condition.

2019-09-30  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpn/t-gcdext_1.c: New test.

2019-09-23  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/hgcd2.c: Mark added div1 variants as static.

	* tune/tuneup.c, tune/speed.c, tune/speed.h, tune/common.c,
	tune/Makefile.am: Add measuring of mpn_hgcd2 method 4 and 5.
	* tune/hgcd2-4.c, tune/hgcd2-5.c: New files.

2019-09-23  Niels Möller  <nisse@lysator.liu.se>

	* gmp-impl.h (hgcd2_func_t) [TUNE_PROGRAM_BUILD]: New typedef.
	(hgcd2_func) [TUNE_PROGRAM_BUILD]: New function pointer.

	* tune/hgcd2.c (mpn_hgcd2): New file, with a redefined function to
	invoke an implementation via the hgcd2_func function pointer.
	Initially points to the default implementation in
	mpn/generic/hgcd2.c.
	* tune/Makefile.am (tuneup_SOURCES): Add hgcd2.c.

	* tune/tuneup.c (one_method): Return index of selected function.
	(tune_hgcd2): Set hgcd2_func to point to selected function. So
	that the later tuning of mpn_hgcd and mpn_gcd uses the right
	implementation of hgcd2.

2019-09-23  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/hgcd2.c: Improve method 4 and 5 by using the division
	free methods optimistically, detecting errors.  Tweak table values.

2019-09-22  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/hgcd2.c: Add a 4th and 5th div1 method.

2019-09-18  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/hgcd2.c (div1, div2): Rearrange things to allow for asm.
	(div2): Avoid out-of-specs shift.
	(div2): Use same variable naming in all variants.

2019-09-16  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/hgcd2.c (HGCD2_DIV2_METHOD): New define.
	(div2): Replaced, since the old implementation had lots of poorly
	predicted and expensive branches. Two new implementaions, selected
	by HGCD2_DIV2_METHOD.
	(div2) [HGCD2_DIV2_METHOD == 1]: Calls div1 on the high limbs,
	with unlikely case handling large quotients.
	(div2) [HGCD2_DIV2_METHOD == 2]: The previously #if:ed out
	version. A bitwise division, relying on fast count_leading_zeros,
	and with fewer branches than the previous code.

2019-09-15  Torbjörn Granlund  <tg@gmplib.org>

	* acinclude.m4 (GMP_ASM_X86_ADX): Remove unused.

	* configure.ac (x86): Amend last change.

2019-09-14  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/hgcd2.c (HGCD2_DIV1_METHOD): Rename, and change
	default to 3. Updated all usage.
	(HGCD2_METHOD): ... the old name, deleted.

2019-09-14  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Remove obsolete path-triggered invocation of
	GMP_ASM_X86_ADX and GMP_ASM_X86_MULX.

	* acinclude.m4 (GMP_ASM_X86_MULX): Set X86_ASM_MULX to config.h.
	* configure.ac (x86): Set x86_have_mulx for relevant CPUs.
	Use if to conditionally invoke GMP_ASM_X86_MULX.
	* longlong.h (x86 umul_ppmm): Test also X86_ASM_MULX for when to use
	mulx variant.

2019-09-13  Niels Möller  <nisse@lysator.liu.se>

	* tune/tuneup.c (one_method): New helper function, to measure
	several functions for a fix size.
	(tune_hgcd2, tune_div_qr_1, tune_mod_1, tune_jacobi_base): Use it.

2019-09-13  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (HAVE_HOST_CPU_1): Add many x86_64 CPU types.
	* longlong.h (x86 umul_ppmm): Fix criterion for when to use mulx.
	(count_leading_zeros): Use lzcnt for appropriate CPUs.
	(count_trailing_zeros): Use tzcnt for appropriate CPUs.

	* mpn/generic/hgcd2.c (HGCD2_METHOD=2 div1): Rewrite.

2019-09-09  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/mul.c: Call mpn_mul_basecase early when in range.  Never
	call mpn_sqr.

	* mpn/generic/gcd.c: Rewrite tail of function, for n <= 2.

2019-09-08  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (arm): Select arch armv7ve for a7, a12, a15, and a17,
	this enables the use of the udiv instruction.

	* mpn/generic/hgcd2.c (disabled div2): Micro-optimise.

2019-09-07  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/hgcd2.c (HGCD2_METHOD=3 div1): Micro-optimise.

2019-09-07  Vincent Lefevre <vincent@vinc17.net>

	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Append EXEEXT for executable.

2019-09-05  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/gcd_22.asm: Rewrite to make better use of Arm conditional
	execution.
	* mpn/arm32/gcd_22.asm: Likewise.

2019-09-05  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/hgcd2.c (div1): Return both r and q as a
	mp_double_limb_t, replacing the DIV1 macro.
	(div1) [HGCD2_METHOD == 3]: New implementation handling q <= 7
	specially and without branches. Based on Torbjörn's mail to the
	gmp-devel list.
	* tune/speed.c, tune/speed.h, tune/common.c, tune/Makefile.am: Add
	corresponding speed support.
	* tune/hgcd2-3.c: New file.
	* tune/tuneup.c (print_define_with_speedup): New function, to
	output a comment with speedup compared to next-best method.
	(tune_hgcd2): Update tuning.

2019-09-04  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/hgcd2.c (HGCD2_METHOD): New parameter.
	(DIV1): New macro, using either the div1 function or plain
	division, depending on the value of HGCD2_METHOD.
	(mpn_hgcd2): Use DIV1.
	* tune/speed.c, tune/speed.h, tune/common.c, tune/Makefile.am: Add
	measuring of mpn_hgcd2 methods.
	* tune/hgcd2-1.c, tune/hgcd2-2.c: New files.
	* tune/tuneup.c: Tune HGCD2_METHOD.

	* tune/speed.h (SPEED_ROUTINE_MPN_HGCD2): New macro.
	* tune/common.c (speed_mpn_hgcd2): New function.
	* tune/speed.c (routine): Add mpn_hgcd2.

2019-09-04  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm/v6t2/gcd_22.asm: New file.
	* mpn/arm64/gcd_22.asm: New file.
	* mpn/ia64/gcd_11.asm: New file.

2019-09-01  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bt1/gcd_11.asm: Replace grabber with bt1 optimised code.

2019-08-30  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd4/gcd_22.asm: New grabber file.

	* mpn/x86_64/zen/gcd_22.asm: Use coreihwl instead of bd2 gcd_22.

	* mpn/x86_64/bd2/gcd_22.asm: Fix typo in FUNC_ENTRY (currently unused).
	Avoid a register copy before return.
	* mpn/x86_64/core2/gcd_22.asm: Likewise.
	* mpn/x86_64/k10/gcd_22.asm: Likewise.
	* mpn/x86_64/gcd_22.asm: Likewise.

	* mpn/x86_64/coreihwl/gcd_22.asm: Optimise, now runs well on more CPUs.

	* mpn/x86_64/gcd_11.asm: Remove PROTECT from symbols as they are
	actually local.
	* mpn/x86_64/gcd_22.asm: Likewise.

2019-08-25  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd2/gcd_22.asm: Repeat tzcnt for exceptional lowz case.
	Remove dead code.

	* mpn/powerpc64/mode64/p7/gcd_22.asm: Make logic for determining ABI
	wrt struct return more robust.
	* mpn/powerpc64/mode64/p9/gcd_22.asm: Likewise.

2019-08-24  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bt1/gcd_11.asm: New grabber.
	* mpn/x86_64/bt1/gcd_22.asm: New grabber.
	* mpn/x86_64/bt2/gcd_22.asm: New grabber.

	* mpn/x86_64/atom/gcd_22.asm: Remove stale grabber file.
	* mpn/x86_64/zen/gcd_22.asm: Grab bd2 instead of hwl code.
	* mpn/x86_64/bd2/gcd_22.asm: New file.
	* mpn/x86_64/k8/gcd_22.asm: Remove, rely on top-level code instead.
	* mpn/x86_64/bt1/gcd_22.asm: Remove.
	* x86_64/gcd_22.asm: New file, improved version of removed bt1 code.

2019-08-22  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreihwl/gcd_11.asm: Remove as it was never beneficial.

	* mpn/x86_64/bd2/gcd_11.asm: Make sure rdx is zero on return to benefit
	gcd_22's private calls. Make gcd_11 files more similar in register use.
	* mpn/x86_64/bd4/gcd_11.asm: Likewise.
	* mpn/x86_64/core2/gcd_11.asm: Likewise.
	* mpn/x86_64/gcd_11.asm:: Likewise.

2019-08-22  Niels Möller  <nisse@lysator.liu.se>

	From Hugh McMaster:
	* gmp.pc.in, gmpxx.pc.in: New files.
	* configure.ac: New output files gmp.pc and gmpxx.pc.
	* Makefile.am (pkgconfigdir, pkgconfig_DATA): New automake
	settings, to install gmp.pc and optionally gmpxx.pc for use with
	pkg-config.

2019-08-21  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/core2/gcd_22.asm: New file.
	* mpn/x86_64/k8/gcd_22.asm: New file.
	* mpn/x86_64/k10/gcd_22.asm: New file.
	* mpn/x86_64/coreihwl/gcd_22.asm: New file.
	* mpn/x86_64/bt1/gcd_22.asm: New file.
	* mpn/x86_64/bd4/gcd_22.asm: New grabber.
	* mpn/x86_64/zen/gcd_22.asm: New grabber.
	* mpn/x86_64/atom/gcd_22.asm: New grabber.

2019-08-19  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Check for ELFv1 ABI on PowerPC.

2019-08-18  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (arm32 sub_ddmmss): Define separately for thumb and
	non-thumb as rsc instruction is missing for thumb.

	* mpn/powerpc64/mode64/p7/gcd_22.asm: New file.
	* mpn/powerpc64/mode64/p9/gcd_22.asm: New file.

2019-08-17  Torbjörn Granlund  <tg@gmplib.org>

	* demos/expr/t-expr.c: #include gmp-impl.h as it includes tests.h.

	* mpn/asm-defs.m4: Add gcd_22.

	* tests/refmpn.c (refmpn_gcd_22): New function.
	* tests/tests.h: Declare it.

	* tests/t-constants.c: #include gmp-impl.h.
	* tests/mpf/t-get_d.c: Likewise.

2019-08-17  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcd_22.c (mpn_gcd_22): New implementation with less
	branches.

2019-08-16 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/brootinv.c: Shorten computations, using even exponent.
	* mpn/generic/powlo.c: Avoid copies with a flipflop.

2019-08-16  Niels Möller  <nisse@lysator.liu.se>

	Speed support for gcd_22. Calls mpn_gcd_22(al, al, bl, bl), so
	that B+1 is a common factor.
	* tune/speed.h (SPEED_ROUTINE_MPN_GCD_22): New macro.
	* tune/speed.c (routine): Add mpn_gcd_22.
	* tune/common.c (speed_mpn_gcd_22): New function.

	* mpn/generic/gcd.c (gcd_2): Moved to gcd_22.c below.
	(mpn_gcd): Adapt for calling gcd_22.
	* mpn/generic/gcd_22.c (mpn_gcd_22): New file and function.
	* gmp-impl.h (mp_double_limb_t): New (typedef) struct.
	* configure.ac (gmp_mpn_functions): Added gcd_22.

	* tests/mpn/t-gcd_22.c: New test.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add t-gcd_22.
	* tests/refmpz.c (refmpz_gcd): New function (plain binary gcd).

2019-08-15  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/gcd_11.asm: Use bd2 instead of bd4 code.

2019-08-13  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64: Add more gcd_11 variants of of x86_64 gcd_11.asm and
	tweak existing ones.

2019-08-13 Marco Bodrato <bodrato@mail.dm.unipi.it>

	From Seth Troisi:
	* doc/gmp.texi: Update mpz_millerrabin documentation.

	* mpn/x86_64/bd2/gcd_11.asm: Micro-optimisation.
	* doc/gmp.texi: Further update in mpz_millerrabin.
	* tests/misc.c: Silence a warning.
	* tests/mpz/t-pprime_p.c (const primes): One more prime in the list.
	* mpz/millerrabin.c: Return 2 for surely prime numbers (BPSW checked).

2019-08-08  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86/gcd_11.asm: New file.

	* config.sub: Make arm cpu types match what config.guess returns.

2019-08-08  Niels Möller  <nisse@lysator.liu.se>

	* tests/refmpn.c (refmpn_gcd_11): New function, based on refmpn_gcd_1.
	(refmpn_gcd_1): Use it.
	* tests/mpn/t-gcd_11.c: New file, test mpn_gcd_11.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add t-gcd_11.

2019-08-07  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/alpha/ev67/gcd_11.asm: New file, mostly extracted from gcd_1.asm.
	* mpn/arm/v5/gcd_11.asm: Likewise.
	* mpn/arm/v6t2/gcd_11.asm: Likewise.
	* mpn/arm64/gcd_11.asm: Likewise.
	* mpn/powerpc64/mode64/gcd_11.asm: Likewise.
	* mpn/powerpc64/mode64/p7/gcd_11.asm: Likewise.
	* mpn/powerpc64/mode64/p9/gcd_11.asm: Likewise.
	* mpn/sparc64/gcd_11.asm: Likewise.
	* mpn/x86/k7/gcd_11.asm: Likewise.
	* mpn/x86/p6/gcd_11.asm: Likewise.
	* mpn/x86_64/bd2/gcd_11.asm: Likewise.
	* mpn/x86_64/core2/gcd_11.asm: Likewise.
	* mpn/x86_64/gcd_11.asm: Likewise.
	* mpn/asm-defs.m4: Add gcd_11.

2019-08-06  Niels Möller  <nisse@lysator.liu.se>

	* tune/common.c (speed_mpn_gcd_11): New function.
	* tune/speed.h (speed_mpn_gcd_11): Declare it.
	(SPEED_ROUTINE_MPN_GCD_11): New macro.
	* tune/speed.c (routine): Add mpn_gcd_11.

	* configure.ac (gmp_mpn_functions): Added gcd_11. Also add
	HAVE_NATIVE_mpn_gcd_11.
	* mpn/generic/gcd_11.c (mpn_gcd_11): New file and function,
	extracted from mpn_gcd_1.
	* gmp-h.in (mpn_gcd_11): Declare it.
	* mpn/generic/gcd_1.c (mpn_gcd_1): Adapted to call mpn_gcd_11.

2019-08-04  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bt2/gcd_1.asm: New grabber file.
	* mpn/x86_64/zen/gcd_1.asm: Grab from "bd2" directory, was "core2".

2019-08-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd2/gcd_1.asm: New file.

2019-08-01  Torbjörn Granlund  <tg@gmplib.org>

	* tests/mpf/t-conv.c: Add several more fixed test cases.

	* mpf/set_str.c: Ignore leading zeros including ones after radix point
	to avoid invalid output formats.

2019-07-30  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/p9/gcd_1.asm: New file.

2019-07-30  Niels Möller  <nisse@lysator.liu.se>

	From Seth Troisi:
	* doc/gmp.texi (Jacobi Symbol): Update algorithm documentation.
	* tests/mpz/t-jac.c: Comment update.

2019-07-13  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (arm): Generalise arm a72 pattern to match a73...a79.

2019-07-08  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm/arm-defs.m4 (ASM_START): Rewrite (fix broken error handling).

2019-07-02  Torbjörn Granlund  <tg@gmplib.org>

	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Compile conftest.c to executable
	in order to trigger final compile in case of LTO.

2019-06-17  Torbjörn Granlund  <tg@gmplib.org>

	* config.guess: Work around upstream configfsf.guess's regression wrt
	mips vs mips64.

2019-06-14  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (mips64): Provide r6 asm code as default expression yields
	libcall.

	* configure.ac (mips64): Use separate paths for r6 and non-r6 as these
	architectures are mutually incompatible.

	* mpn/mips64/{addmul_1,mul_1,sqr_diagonal,submul_1,umul}.asm:
	Move into hilo subdir.

2019-05-28  Torbjörn Granlund  <tg@gmplib.org>

	* config.sub: Fixes to which cpu types end with a "*".

2019-04-20  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (References): Link to paper on subquadratic GCD.

2019-04-19  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd1/hamdist.asm: Really make 2017-06-01 change: Use
	3-operand DEF_OBJECT.

	* mpn/x86_64/invert_limb.asm: Simplify mpn_invert_limb_table ref.

	* mpn/x86_64/x86_64-defs.m4 (LEA): Use rip addressing for non-PIC.

2019-04-17  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/jacobi.c (mpn_jacobi_n): Use JACOBI_DC_THRESHOLD,
	not GCD_DC_THRESHOLD. Inconsistency spotted by Seth Troisi.

2019-04-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init):
	Split out silvermont handling, add handling of goldmont.

	* configure.ac: Setup distinct paths for silvermont and goldmont.
	(fat_path): Add missing x86_64/goldmont.

	* config.guess: Recognise "Goldmont Plus".

2018-12-09  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/mul_fft.c (mpn_fft_add_sub_modF): New function.
	(mpn_fft_fft, mpn_fft_fftinv): Use it.

2018-11-30  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/p9/gmp-mparam.h: New file.

	* mpn/powerpc64/mode64/p9/add_n_sub_n.asm: New file.

2018-11-28  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/p9/sqr_basecase.asm: New file.
	* mpn/powerpc64/mode64/p9/mul_1.asm: New file.

2018-11-18  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/p9/mul_basecase.asm: New file.

	* mpn/powerpc64/mode64/p9/addmul_1.asm: Optimise.

2018-11-12  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/p9/aorsmul_1.asm: New file, providing fast
	submul_1 (and redundant addmul_1).

2018-11-11  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/p9/addmul_1.asm: Tweak for slightly better
	speed.

	* mpn/powerpc32/powerpc-defs.m4: Define addex.
	* mpn/powerpc64/mode64/p9/mul_2.asm: Use it.
	* mpn/powerpc64/mode64/p9/addmul_2.asm: Likewise.

2018-11-08  Torbjörn Granlund  <tg@gmplib.org>

	* tests/devel/cnd_aors_n.c: New file.

	* mpn/arm/neon/lorrshift.asm: Declare use of neon insns.
	* mpn/arm/neon/lshiftc.asm: Likewise + cleanup.

	* tests/devel/Makefile.am (EXTRA_PROGRAMS): Add missing files.

	* mpn/powerpc64/mode64/p9/mul_2.asm: New file.
	* mpn/powerpc64/mode64/p9/addmul_2.asm: New file.

2018-11-07 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/lucnum2_ui.c: Use mpn_rsblsh1_n if available.
	* tests/mpz/t-nextprime.c: Add one more interval.
	* tests/mpz/t-pprime_p.c (check_fermat_mersenne): New tests.
	* mpn/generic/mod_1_3.c: typo in a comment.
	* mpz/nextprime.c: Use tdiv instead of fdiv.

	* mpn/generic/fib2m.c: New file, Fibonacci numbers modulo.
	* configure.ac (gmp_mpn_functions): Add it.
	* gmp-impl.h: Declare mpn_fib2m.
	* tests/mpn/t-fib2m.c: New file, tests for mpn_fib2m.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add t-fib2m.

	* mpn/generic/mod_34lsub1.c: Initialise c[012] once.
	* tests/mpz/t-pprime_p.c (check_primes): Two more primes.
	* tests/mp?: Use TESTS_REPS in many files.

	* mpn/generic/strongfibo.c: New file, Fibonacci primality test.
	* configure.ac (gmp_mpn_functions): Add it.
	* gmp-impl.h: Declare mpn_strongfibo.

	* mpz/stronglucas.c: New file, strong Lucas primality test.
	* Makefile.am (MPZ_OBJECTS): Add it.
	* mpz/Makefile.am (libmpz_la_SOURCES): Add it.
	* gmp-impl.h: Declare mpz_stronglucas.

	* mpz/millerrabin.c: Implement BPSW test for primality.

2018-11-07  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (arm): Support a12 and a17.
	* config.sub: Generalise arm matching.
	* config.guess: Recognise additional arm CPUs.

	* mpn/arm/arm-defs.m4 (ASM_START): Provide local definition.

2018-10-30  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm/v7a/cora17/mod_34lsub1.asm: New file.
	* mpn/arm/v7a/cora17/gmp-mparam.h: New file.
	* mpn/arm/v7a/cora17/mul_1.asm: New grabber file.
	* mpn/arm/v7a/cora17/addmul_1.asm: Likewise.
	* mpn/arm/v7a/cora17/submul_1.asm: Likewise.

2018-10-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/fib2_ui.c: Simplify the possible -2 case.

2018-07-19 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/millerrabin.c (mod_eq_m1): New function, equality with -1.
	* mpz/powm_ui.c: Small optimisations.

2018-07-03  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/lshift.asm: Remove cnt = 1 special code.

	* mpn/x86_64/silvermont/popcount.asm: Add missing ABI_SUPPORT decls.
	* mpn/x86_64/silvermont/hamdist.asm: Likewise.
	* mpn/x86_64/zen/mul_1.asm: Likewise.

	* mpn/x86_64/fastsse/lshift.asm: Support DOS64.
	* mpn/x86_64/fastsse/lshiftc.asm: Likewise.

	* mpn/x86_64/pentium4/gmp-mparam.h: Retune.

2018-07-01  Torbjörn Granlund  <tg@gmplib.org>

	* lshift.asm: Replace with grabber file.
	* lshiftc.asm: Replace with grabber file.
	* x86_64/pentium4/addmul_2.asm: New grabber file.
	* x86_64/pentium4/aorsmul_1.asm: New grabber file.
	* x86_64/pentium4/mul_1.asm: New grabber file.
	* x86_64/pentium4/mul_2.asm: New grabber file.
	* x86_64/pentium4/mul_basecase.asm: New grabber file.
	* x86_64/pentium4/mullo_basecase.asm: New grabber file.
	* x86_64/pentium4/redc_1.asm: New grabber file.
	* x86_64/pentium4/sqr_basecase.asm: New grabber file.

2018-06-13  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcd_1.c (mpn_gcd_1): Delete unused code variant for
	GCD_1_METHOD == 1, and delete GCD_1_METHOD macro. Simplify the
	structure of the remaining code variant, without gotos to the
	mid-loop strip_u_maybe label.

2018-05-30  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (x86): Provide goldmont specific path.

	* mpn/x86_64/goldmont/gmp-mparam.h: New file.

2018-05-29  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (x86): Pass more exact arch/tune options for nehalem.

2018-05-28  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcd_1.c (mpn_gcd_1) [USE_ZEROTAB]: Delete unused code
	variant for USE_ZEROTAB != 0.

2018-05-20 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* bootstrap.c: Define DONT_USE_FLOAT_H before including mini-gmp.

2018-05-14 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/dcpi1_bdiv_q.c (mpn_dcpi1_bdiv_q_n): Decl. static.
	(mpn_dcpi1_bdiv_q_n_itch): Declare static.
	* mpn/generic/dcpi1_divappr_q.c (mpn_dcpi1_divappr_q_n): static.
	* mpn/generic/matrix22_mul.c (mpn_matrix22_mul_strassen): static.
	* mpn/generic/mu_div_qr.c (mpn_mu_div_qr_choose_in): static.
	* mpn/generic/mu_divappr_q.c (mpn_preinv_mu_divappr_q): static.
	(mpn_mu_divappr_q_choose_in): static.
	* gmp-impl.h: Remove declaration of previous functions.

	* mpn/generic/get_d.c: Enhance generic code using DBL_MANT_DIG.

	* printf/repl-vsnprintf.c: Better handling floating-point
	specifiers "EeGgFf" (Thanks Vincent Lefevre).

2018-05-04 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* doc/gmp.texi (mpq_*_str): Document the full base allowed range.
	* mpq/get_str.c: Make all bases either work or return an error.

	* doc/gmp.texi (Integer Internals): Lazy allocation and read-only.

2018-04-27  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/div_q.c (mpn_div_q): Replace dead code with ASSERT.
	Spotted by Paul Zimmermann and Raphaël Rieu-Hleft.

	* tests/mpn/t-div.c (main): Fill quotient area with junk before
	calling mpn_div_q.

2018-04-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* Makefile.am (EXTRA_DIST): Add mini-gmp/mini-mpq.[ch].

2018-04-23 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/toom2_sqr.c: Handle the cy=-1 branch slightly faster.
	* mpn/generic/toom22_mul.c: Likewise. (Thanks Paul and Raphaël!)

2018-04-22  Niels Möller  <nisse@lysator.liu.se>

	From Martin Storsjö:
	* configure.ac (aarch64): Just as on windows/x86_64, "long" still
	is 32 bit on aarch64. To distinguish between 32-bit and 64-bit
	ABI, test sizeof(void*) instead of sizeof(long). Use long long for
	mp_limb_t for mingw targets.
	* acinclude.m4 (GMP_C_TEST_SIZEOF): Allow '*' in the type name,
	e.g., void*.

2018-04-18  Marc Glisse  <marc.glisse@inria.fr>

	* mpq/clear.c: Handle lazy numerator.
	* mpq/clears.c: Likewise.
	* mpq/init.c: Likewise.
	* mpq/set_si.c: Likewise.
	* mpq/set_ui.c: Likewise.

	* tests/cxx/t-ops2z.cc: Add parentheses to quiet a warning.

2018-03-28  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (mips): Recognise "mipsisa64*".

2018-03-23  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/sec_powm.c: Remove unused macros.
	Simplify code for choosing between redc_1 and redc_2.
	Compute power table with squaring for even powers.

2018-02-28 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmpxx.h (__gmp_binary_plus): Special case for mpq + 1.
	(__gmp_binary_minus): Special case for mpq - 1.
	(__gmp_binary_equal): Optimised comparison mpq == integer.
	* tests/cxx/t-ops2qf.cc (checkqf): Some check for +/- 1, +/- 0.

2018-02-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tune/Makefile.am: Disallow parallel make (thanks Vincent Lefevre).
	* mpq/swap.c: Use *_SWAP_* macros.
	* mpq/cmp_ui.c: One more little shortcut, comparing fractions to 1.
	* mpq/get_d.c: Compare (zeros > 0) once, replace tdiv_qr with div_q.
	* mpq/equal.c: Check size early.

	* printf/obprintf.c: Adda dummy typedef to avoid empty unit.
	* printf/obvprintf.c: Likewise.
	* printf/obprntffuns.c: Likewise.
	* printf/repl-vsnprintf.c: Move #ifdef after #include gmp-impl.h .

2018-02-09  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm: Really revert 2018-01-04 changes.

2018-02-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* printf/snprntffuns.c: Report -1 as an error.
	* acinclude.m4 (GMP_FUNC_VSNPRINTF): Refuse -1 as return value.

	* mpz/bin_uiui.c (mpz_smallk_bin_uiui): One more shortcut for small k.
	* gmp-impl.h (popc_limb): Use fewer constants (GMP_LIMB_BITS == 16).
	* mpz/divegcd.c (mpz_divexact_limb): Use MPN_DIVREM_OR_DIVEXACT_1.
	* primesieve.c (fill_bitpattern): Use MPN_FILL.

2018-02-01  Marc Glisse  <marc.glisse@inria.fr>

	* longlong.h (i586): Remove assert.

2018-01-30 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/and.c: Rearrange the 3 cases, both <0, both >=0, one and one.
	* mpz/ior.c: Likewise.
	* mpz/xor.c: Likewise.

	* mpz/bin_uiui.c (mul[4-8]): Reduce the number of multiplications.

	* printf/doprnt.c: Use __GMP_FREE_FUNC_TYPE.
	* printf/doprntf.c: Likewise.
	* printf/snprntffuns.c: Likewise, and use size_t instead of int.

2018-01-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/t-bin.c: Extended tests for bin_ui and uint border cases.

2018-01-10  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86/fat/fat.c (__gmpn_cpuvec_init): Fix old pentium recog.
	* config.guess: Likewise.

	* mpn/x86/fat/fat.c (__gmpn_cpuvec_init): Add many 64-bit CPUs.

2018-01-07  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm: Revert last change, it hides a symbol needed for testing.

2018-01-04  Torbjörn Granlund  <tg@gmplib.org>

	* bdiv_q_1.asm (binvert_limb_table): Declare as ".hidden".
	* v7a/cora8/bdiv_q_1.asm: Likewise.
	* dive_1.asm: Likewise.
	* v6/dive_1.asm: Likewise.

	* mode1o.asm (binvert_limb_table): Remove ".protected", add ".hidden".
	* v6/mode1o.asm: Likewise.

2018-01-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/divrem_2.asm: Use different rlwinm variant (to
	appease clang).

2018-01-01  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc32/powerpc-defs.m4: Define maddld, maddhdu, popcntd, and
	divdeu.
	* mpn/powerpc64/mode64/p8/invert_limb.asm: Use new insn defs.
	* mpn/powerpc64/mode64/p9/addmul_1.asm: Use new insn defs.
	* mpn/powerpc64/p7/hamdist.asm: Use new insn defs.
	* mpn/powerpc64/p7/popcount.asm: Use new insn defs.

2017-12-31  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/p9/addmul_1.asm: Moved from
	mpn/powerpc64/p9/addmul_1.asm.

2017-12-30 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/bin_ui.c: Rewrite, using Fredrik Johansson's suggestions.

2017-12-27  Niels Möller  <nisse@lysator.liu.se>

	* longlong.h (arm32/arm64): Leave COUNT_LEADING_ZEROS_0 undefined,
	since we use gcc's __builtin_clzl, which doesn't allow zero inputs.

2017-12-27  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/mode64/bdiv_q_1.asm: Use 64-bit cmp for sizes.

	* mpn/powerpc64/p9/addmul_1.asm: New file.

	* configure.ac: Separate handling of POWER8 and POWER9.

	* config.guess: Recognise POWER9 and more variants of POWER8.
	Reorder recog code to favour PVR over proc/cpuinfo.

2017-12-14  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/fastsse/com.asm: Adhere to DOS64 xmm callee-saves rules.
	* mpn/x86_64/fastsse/com-palignr.asm: Likewise.
	* mpn/x86_64/fastsse/copyd.asm: Likewise.
	* mpn/x86_64/fastsse/copyi.asm: Likewise.
	* mpn/x86_64/fastsse/lshiftc.asm: Likewise.
	* mpn/x86_64/fastsse/sec_tabselect.asm: Likewise.

2017-12-11  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd1/aorrlsh_n.asm: New grabber file.

2017-12-10  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd1/aors_n.asm: New grabber file.

	* mpn/x86_64/bd4/aorrlsh_n.asm: New grabber file.

2017-08-31  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/sparc32/sparc-defs.m4 (LEA64): Rewrite for both PIC and non-PIC.

	* mpn/sparc64/ultrasparct3/cnd_aors_n.asm: Allow arbitrary cnd arg.

2017-08-29  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/silvermont/gmp-mparam.h: Disable mul_2 and addmul_2.

2017-08-28  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/sparc64: Revert 2017-07-23 PIC changes.

	* mpn/powerpc32/divrem_2.asm: Avoid bc+ insn form to accommodate clang.

	* mpn/generic/sbpi1_bdiv_qr.c: Correct ASSERT.
	* mpn/generic/sbpi1_bdiv_q.c: Likewise.
	* mpn/generic/sbpi1_bdiv_r.c: Likewise.

2017-08-18  Torbjörn Granlund  <tg@gmplib.org>

	* acinclude.m4 (X86_64_PATTERN): Match zen*.

	* configure.ac (x86): Support AVX challenged systems for Zen.

2017-07-24  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/sbpi1_bdiv_q.c: Add ASSERT for inverse correctness.
	* mpn/generic/sbpi1_bdiv_qr.c: Likewise.

	* tests/mpn/t-bdiv.c (main): Amend last change.

	* tests/devel/try.c (choice_array): Amend 2013-05-03 change to include
	more functions.

2017-07-23  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/sparc64/gcd_1.asm: Enforce PIC as GNU/Linux toolchain workaround.
	* mpn/sparc64/ultrasparct3/bdiv_q_1.asm: Likewise.
	* mpn/sparc64/ultrasparct3/dive_1.asm: Likewise.
	* mpn/sparc64/ultrasparct3/invert_limb.asm: Likewise.
	* mpn/sparc64/ultrasparct3/mode1o.asm: Likewise.

	* gmp-impl.h: Reorganise foolshC_ip1 -> foolshC -> foolsh chain to make
	it transitive.

2017-07-23  Niels Möller  <nisse@lysator.liu.se>

	* longlong.h: Purge definitions of obsolete UMUL_TIME and
	UDIV_TIME constants. Also mentioned (but unused) in
	mpn/cray/gmp-mparam.h and tune/common.c.

2017-07-21  Torbjörn Granlund  <tg@gmplib.org>

	* tests/mpn/t-bdiv.c (main): Test mpn_sbpi1_bdiv_r.

	* tune/common.c (speed_mpn_sbpi1_bdiv_r): New function.
	* tune/speed.h: Declare it.
	(SPEED_ROUTINE_MPN_PI1_BDIV_R): New macro.
	* tune/speed.c (routine): Add mpn_sbpi1_bdiv_r.

2017-07-20  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (gmp_mpn_functions): Add sbpi1_bdiv_r.

	* gmp-impl.h (mpn_sbpi1_bdiv_r): Declare.

	* mpn/asm-defs.m4 (define_mpn): Add sbpi1_bdiv_q, sbpi1_bdiv_qr,
	sbpi1_bdiv_r.

	* mpn/generic/sbpi1_bdiv_r.c: New file.
	* mpn/x86_64/zen/sbpi1_bdiv_r.asm: New file.

2017-07-19  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86/p6/sse2/submul_1.asm: Get pentium4 code instead of k6 code
	for better speed on modern Intel P6 cores.

2017-07-02  Torbjörn Granlund  <tg@gmplib.org>

	* tune/tuneup.c (tune_mullo): For MULLO_BASECASE_THRESHOLD start at 2.
	(tune_sqrlo): Likewise.

2017-06-28  Torbjörn Granlund  <tg@gmplib.org>

	* tests/Makefile.am tests/*/Makefile.am tune/Makefile.am (AM_LDFLAGS):
	Define.  (Thanks to Emmanuel Thomé and Vincent Lefevre.)

2017-06-27  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/sqr_basecase.asm: Expand to use 4 addmul_1 loops.

	* mpn/x86_64/x86_64-defs.m4 (sarx): New macro.

2017-06-26  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreibwl/sqr_basecase.asm: Rewrite to do 2x and limb
	squaring in main loop.

2017-06-20  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/atom/cnd_add_n.asm: New grabber file.
	* mpn/x86_64/atom/cnd_sub_n.asm: Likewise.

	* mpn/x86_64/coreihwl/aorrlsh_n.asm: New grabber file.

2017-06-16  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/mul_basecase.asm: Do overlapped software pipelining.

	* mpn/x86_64/silvermont/mul_basecase.asm: New grabber file.
	* mpn/x86_64/silvermont/sqr_basecase.asm: Likewise.
	* mpn/x86_64/silvermont/mullo_basecase.asm: Likewise.

2017-06-14  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/mullo_basecase.asm: New file.
	* mpn/x86_64/coreibwl/mullo_basecase.asm: New file.

2017-06-11  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/popham.asm: Crossjump for code size and mix lead-in insns
	for lower overhead.

2017-06-09  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Set GMP_NONSTD_ABI protecting against dots in the abi.
	(hppa): Remove old GNU/Linux restriction to 32-bit ABI.

2017-06-07  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd1/addmul_2.asm: New file.

2017-06-06  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreihwl/aors_n.asm: New file.

	* mpn/x86_64/x86_64-defs.m4 (c4_helper): New macro.
	(mulx, shlx, shrx): Use c4_helper.

	* mpn/x86_64/zen/mul_basecase.asm: Use 8-bit imm operands for "test".

	* mpn/x86_64/zen/aorrlsh1_n.asm: New grabber file.
	* mpn/x86_64/zen/sublsh1_n.asm: Likewise.
	* mpn/x86_64/zen/aorrlsh_n.asm: New file

2017-06-04  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Use bt1/bt2 for bobcat and jaguar dirs.
	(fat_path): Add x86_64/bt2.

	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init): Adapt to bt1/bt2 changes.
	Make zen path correspond to non-fat path.
	* mpn/x86/fat/fat.c (__gmpn_cpuvec_init): Adapt to bt1/bt2 changes.

	* mpn/x86_64/bt2/copyi.asm: New grabber file.
	* mpn/x86_64/bt2/copyd.asm: New grabber file.
	* mpn/x86_64/bt2/com.asm: New grabber file.

2017-06-03  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd1/popcount.asm: Expand some instructions as .byte
	sequences.
	* mpn/x86_64/bd1/hamdist.asm: Likewise.

2017-06-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/x86_64-defs.m4 (DEF_OBJECT): Fix quoting (amends recent
	change).
	(JUMPTABSECT): Get rid of spurious "w".

2017-06-02  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (mpf_class::operator bool): Use mpf_sgn to access _mp_size.

2017-06-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/bd1/popcount.asm: Use both SSE and XOP trickery, and
	plain popcnt insn.
	* mpn/x86_64/bd1/hamdist.asm: Likewise.

2017-06-01  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/x86_64-defs.m4 (DEF_OBJECT): Allow 3rd argument defining
	section, while making alignment argument non-optional.

	* mpn/x86_64/core2/popcount.asm: Use 3-operand DEF_OBJECT.
	* mpn/x86_64/core2/hamdist.asm: Likewise.
	* mpn/x86_64/bd1/popcount.asm: Likewise.
	* mpn/x86_64/bd1/hamdist.asm: Likewise.

	* configure.ac (GMP_AVX_NOT_REALLY_AVAILABLE): New m4 define.
	* mpn/x86_64/bd1/popcount.asm: Use GMP_AVX_NOT_REALLY_AVAILABLE.
	* mpn/x86_64/bd1/hamdist.asm: Likewise.

	* mpn/x86_64/silvermont/popcount.asm: Reinstate, grabbing nehalem code.
	* mpn/x86_64/silvermont/hamdist.asm: Replace with grabber.

2017-05-31  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/silvermont/popcount.asm: Remove.

	* mpn/x86_64/core2/logops_n.asm: New file.

2017-05-30  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreisbr/popcount.asm: Remove.

2017-05-29  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreinhm/popcount.asm: Replace grabber code with
	implementation proper.
	* mpn/x86_64/coreinhm/hamdist.asm: Likewise.
	* mpn/x86_64/bd1/popcount.asm: Likewise.
	* mpn/x86_64/bd1/hamdist.asm: Likewise.
	* mpn/x86_64/core2/popcount.asm: Likewise.
	* mpn/x86_64/core2/hamdist.asm: New file.

2017-05-22  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/core2/com.asm: New grabber file.

	* mpn/x86_64/core2/lshift.asm: Rewrite.
	* mpn/x86_64/core2/rshift.asm: Rewrite.
	* mpn/x86_64/core2/lshiftc.asm: Rewrite.

2017-05-16  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/mul_1.asm: Port to DOS64.
	* mpn/x86_64/zen/aorsmul_1.asm: Likewise.
	* mpn/x86_64/coreibwl/addmul_1.asm: Likewise.

2017-05-16  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/divis.c (mpn_divisible_p): Updated the divisibility
	test; bdiv now returns R = D rather than R = 0 when D divides a
	non-zero U.

	* mpn/generic/binvert.c (mpn_binvert): Negate bdiv quotient.
	* mpn/generic/divexact.c (mpn_divexact): Likewise.
	* mpn/generic/remove.c (mpn_remove): Likewise.
	* mpz/bin_uiui.c (mpz_bdiv_bin_uiui): Likewise.

	* tests/mpn/t-bdiv.c (check_one): Updated to new convention,
	B^{qn} R = U + QD.

	* mpn/generic/sbpi1_bdiv_qr.c (mpn_sbpi1_bdiv_qr): Reimplemented,
	for new bdiv convention.
	* mpn/generic/sbpi1_bdiv_q.c (mpn_sbpi1_bdiv_q): Likewise.
	* mpn/generic/dcpi1_bdiv_q.c (mpn_dcpi1_bdiv_q_n)
	(mpn_dcpi1_bdiv_q): Adapted to new bdiv convention.
	* mpn/generic/dcpi1_bdiv_qr.c (mpn_dcpi1_bdiv_qr_n)
	(mpn_dcpi1_bdiv_qr): Likewise.
	* mpn/generic/mu_bdiv_qr.c (mpn_mu_bdiv_qr): Adapted to new bdiv
	convention, using a wrapper calling the old function.
	* mpn/generic/mu_bdiv_q.c (mpn_mu_bdiv_q): Likewise.

2017-05-03  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreisbr/cnd_aors_n.asm: New file.
	* mpn/x86_64/coreisbr/cnd_add_n.asm: New file.

	* mpn/x86_64/core2/aorsmul_1.asm: Tune.

	* mpn/x86_64/silvermont/mul_1.asm: New file, grabbing another asm file.
	* mpn/x86_64/silvermont/aorsmul_1.asm: Likewise.
	* mpn/x86_64/silvermont/aorrlsh1_n.asm: Likewise.
	* mpn/x86_64/silvermont/aorrlsh2_n.asm: Likewise.
	* mpn/x86_64/silvermont/lshift.asm: Likewise.
	* mpn/x86_64/silvermont/rshift.asm: Likewise.
	* mpn/x86_64/silvermont/lshiftc.asm: Likewise.

	* mpn/x86_64/zen/mul_basecase.asm: Split outer loop into 4 loops.

2017-05-02  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/sqr_basecase.asm: Use .byte for encoding all mulx.
	Misc tuning.

2017-04-27  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/sqr_basecase.asm: Rewrite to do 2x and limb squaring
	in main loop.

2017-04-25  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/fat/fat_entry.asm: Allocate correct DOS64 frame.
	* mpn/x86_64/divrem_2.asm: Likewise.
	* mpn/x86_64/mod_1_2.asm: Likewise.
	* mpn/x86_64/mod_1_4.asm: Likewise.
	* mpn/x86_64/mod_1_1.asm: Likewise.

2017-04-23  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/coreisbr/mul_1.asm: Rewrite feed-in code and add mul_1c
	entry point.

2017-04-17  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init): Amend last change.

	* mpn/x86_64/zen/mul_basecase.asm: New file.
	* mpn/x86_64/zen/sqr_basecase.asm: New file.

2017-04-16  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/sqr_basecase.c (addmul_1 variant): Rewrite to compute
	in-place and to avoid a re-computation.

	* configure.ac: Remove k8, k10 from zen path.

2017-04-15  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/zen/gmp-mparam.h: New file.

	* mpn/x86_64/zen/com.asm: New file, grabbing another asm file.
	* mpn/x86_64/zen/copyd.asm: Likewise.
	* mpn/x86_64/zen/copyi.asm: Likewise.
	* mpn/x86_64/zen/gcd_1.asm: Likewise.
	* mpn/x86_64/zen/hamdist.asm: Likewise.
	* mpn/x86_64/zen/lshift.asm: Likewise.
	* mpn/x86_64/zen/lshiftc.asm: Likewise.
	* mpn/x86_64/zen/popcount.asm: Likewise.
	* mpn/x86_64/zen/rshift.asm: Likewise.

	* config.guess: Recognise AMD zen.
	* acinclude.m4 (X86_64_PATTERN): Add zen.
	* config.sub: Corresponding changes.
	* configure.ac: Corresponding changes.
	* mpn/x86_64/fat/fat.c: Corresponding changes.

2017-03-27 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/oddfac_1.c (limb_apprsqrt): Better approximation.
	* mpz/bin_uiui.c (limb_apprsqrt): Likewise.

2017-03-12  Torbjörn Granlund  <tg@gmplib.org>

	* tests/mpf/t-get_d_2exp.c (check_data): Rewrite of check_onebit.

2017-03-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/sqrtrem.c: Direct use of sqrtrem2 when n==2.
	* mpn/generic/div_qr_2.c (udiv_qr_4by2): Replace add_csaac with add_sssaaaa.

2017-03-07  Torbjörn Granlund  <tg@gmplib.org>

	* mpf/get_d_2exp.c: Return negative value for negative input.

2017-03-06  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (aarch64): Provide asm-free umul_ppmm.
	* longlong.h (powerpc64): Enable asm-free umul_ppmm.

2017-03-04  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/sqr_diag_addlsh1.asm: Complete rewrite.

2017-02-27  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (arm32/arm64): Remove useless comparison to 0 introduced
	in last change (spotted by Marco).

2017-02-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/pow_1.c: Use umul_ppmm for a single limb.

2017-02-25  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Allow MP_SIZE_T_MAX for thresholds exported to
	config.m4.

	* mpn/x86_64/gcd_1.asm: Handle BMOD_1_TO_MOD_1_THRESHOLD=MP_SIZE_T_MAX.
	Streamline non-reduction path.
	* mpn/x86_64/core2/gcd_1.asm: Streamline small operands cases similarly
	to top-level code.

2017-02-24  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (arm32/arm64 add_ssaaaa): Use "subs" for some immediates.
	* longlong.h (arm32/arm64 sub_ddmmss): Use "adds" for some immediates.

	* mpn/arm64/copyi.asm: Avoid branching on flags.
	* mpn/arm64/copyd.asm: Likewise.

	* mpn/generic/div_qr_2.c (aarch64 add_sssaaaa): New.
	* mpn/generic/div_qr_1n_pi2.c: Same.
	* mpn/generic/div_qr_1u_pi2.c: Same.

	* mpn/generic/div_qr_2.c (powerpc add_sssaaaa): Fix typo.
	* mpn/generic/div_qr_1n_pi2.c: Same.
	* mpn/generic/div_qr_1u_pi2.c: Same.

2017-02-23 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/devel/sqrtrem_1_2.c: New exhaustive test for sqrtrem_[12].
	* tests/devel/Makefile.am (EXTRA_PROGRAMS): add it.

2017-02-23  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/silvermont/gmp-mparam.h: New file.

2017-02-22  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/aorsmul_1.asm: Rewrite.

	* mpn/arm64/lshiftc.asm: New file.

2017-02-21  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/lshift.asm: Rewrite.
	* mpn/arm64/rshift.asm: Rewrite.

	* mpn/arm64/rsh1aors_n.asm: New file.

2017-02-19  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/mul_1.asm: Rewrite.
	* mpn/arm64/xgene1/mul_1.asm: Remove.

2017-02-17  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/cora53/cnd_aors_n.asm: Moved from "..".

	* mpn/arm64/xgene1/cnd_aors_n.asm: Remove file since default code
	performs better.

	* mpn/arm64/cnd_aors_n.asm: Rewrite.

	* mpn/arm64/logops_n.asm: Rewrite based on new aors_n.asm.

2017-02-16  Pedro Gimeno  <pggimeno@wanadoo.es>

	* rand/randmt.c (__gmp_randiset_mt): Set generator functions from
	source.

2017-02-16  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm64/aorsorrlshC_n.asm: New file.
	* mpn/arm64/aorsorrlsh2_n.asm: New file.
	* mpn/arm64/aorsorrlsh1_n.asm: New file.

	* mpn/arm64/xgene1/aors_n.asm: Remove file since default code now
	performs similarly.

	* mpn/arm64/aors_n.asm: Rewrite to use 4x unrolling.

2017-02-15  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/silvermont/hamdist.asm: New file, based on k10 code.

	* mpn/x86_64/silvermont/popcount.asm: Grab coreisbr/popcount.asm.

2017-02-14  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/x86_64/silvermont/aors_n.asm: New file, grabbing coreisbr code.

	* mpn/x86_64/atom/aors_n.asm: Replace coreisbr grabbing code with
	code based on Marco's x64/atom/aors_n.asm.

2017-02-12  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/powerpc64/aix.m4 (AIX): New define.

	* mpn/powerpc64/mode64/bdiv_q_1.asm: For AIX, don't jump from
	mpn_bdiv_q_1 to middle of mpn_pi1_bdiv_q_1.  Streamline.

	* mpn/powerpc64/darwin.m4 (LEA): Put code in lea_list instead of in
	EPILOGUE_cpu.
	(EPILOGUE_cpu): Output lea_list, the zap it.

	* mpn/sparc64/ultrasparct3/bdiv_q_1.asm: New file, based on dive_1.asm.

2017-02-11  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm/v7a/cora8/bdiv_q_1.asm: New file, based on v6/dive_1.asm.
	* mpn/arm/v7a/cora9/bdiv_q_1.asm: New file, grabbing cora8 code.
	* mpn/arm/v7a/cora15/bdiv_q_1.asm: Likewise.

	* mpn/arm64/aors_n.asm: (SETCY, RETVAL): Shorten insn sequences.
	* mpn/arm64/cnd_aors_n.asm: Likewise.
	* mpn/arm64/xgene1/aors_n.asm: Likewise.
	* mpn/arm64/xgene1/cnd_aors_n.asm: Likewise.

	* mpn/arm/bdiv_q_1.asm: New file, based on dive_1.asm.

	* mpn/generic/bdiv_q_1.c (mpn_bdiv_q_1): Remove odd d special case.

	* mpn/powerpc64/mode64/bdiv_q_1.asm: New file.

	* mpn/arm64/bdiv_q_1.asm: New file.

2017-02-10  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/arm/arm-defs.m4 (EPILOGUE_cpu): Zap lea_list to avoid repetition.

	* mpn/x86_64/bdiv_q_1.asm: Rewrite, base on atom/dive_1.asm.

2017-02-08  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/compute_powtab.c: Choose mpn_pi1_bdiv_q_1 vs
	mpn_divexact_1 more wisely (spotted by Marco).

2017-02-07  Torbjörn Granlund  <tg@gmplib.org>

	* tune/tuneup.c (relspeed_div_1_vs_mul_1): Prefer mpn_pi1_bdiv_q_1.

	* mpn/generic/compute_powtab.c: Use mpn_pi1_bdiv_q_1/mpn_bdiv_q_1
	instead of mpn_divexact_1.

	* gen-bases.c (binvert): New function, computing modular inverse and
	low zero count.
	(header): Print MP_BASES_BIG_BASE_CTZ_10 and
	MP_BASES_BIG_BASE_BINVERTED_10.

2017-02-06  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/bdiv_q_1.c: Make return value consistent.

	* mpn/x86/p6/mmx/gmp-mparam.h (SQR_TOOM2_THRESHOLD): Revert to bogus
	value to accommodate p6/sqr_basecase.asm fragility.

2017-01-29 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/and.c: Simplify branches.
	* mpz/ior.c: Likewise.
	* mpz/xor.c: Likewise.

	* gen-bases.c: In generated file, include just gmp-impl.h, not gmp.h

2017-01-29  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac: Don't check if we got a C99 compiler for now (partially
	revert 2017-01-24 change as C++ compilers become rejected).

2017-01-24  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/compute_powtab.c: New file, providing mpn_compute_powtab
	for both get_str and set_str.

	* gmp-impl.h (mpn_str_powtab_alloc): New macro.
	(mpn_dc_set_str_powtab_alloc, mpn_dc_get_str_powtab_alloc): Remove.
	(mpn_compute_powtab): Declare.

	* mpn/generic/set_str.c: Use mpn_compute_powtab.
	(mpn_set_str_compute_powtab): Remove.

	* mpn/generic/get_str.c: Use mpn_compute_powtab.
	(mpn_get_str_compute_powtab): Remove.
	(mpn_bc_get_str): New name for mpn_sb_get_str.

	* configure.ac (gmp_mpn_functions): Add compute_powtab.

	* tune/tuneup.c (speed_mpn_pre_set_str): Call mpn_compute_powtab.
	* tune/set_strb.c: Remove mpn_set_str_compute_powtab name mangling.
	* tune/set_strs.c: Likewise.

	* configure.ac: Invoke AC_PROG_CC_C99 instead of AC_PROG_CC_STDC.

2017-01-03  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (arm*-*-*): Properly point to cortex-a5 subdir.

2016-12-31  Torbjörn Granlund  <tg@gmplib.org>

	* tune/tuneup.c (relspeed_div_1_vs_mul_1): New function.

2016-12-28 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tune/common.c (speed_mpz_mfac_uiui, speed_mpz_invert): New
	functions.
	* tune/speed.h: Declare them.
	* tune/speed.c (routine): Add mpz_mfac_uiui, mpz_invert.

	* tests/mpz/t-primorial_ui.c: Add randomization to the test.
	* mpz/tdiv_r.c: Reduce allocation in some corner-case conditions.
	* mpz/tdiv_r_2exp.c: Rearrange counting non-zero limbs.
	* mpz/tdiv_q.c: Move common code out of some branches.
	* mpz/and.c: Alloc only when needed.
	* mpz/xor.c: Reorder branches.
	* mpz/gcd.c: Reorder branches.
	* mpz/pprime_p.c: Save the initial branch of a loop.
	* mpn/generic/divrem.c: Save an allocation.

2016-12-26  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (x86_64 umul_ppmm): Add mulx variant (not automatically
	used).

2016-12-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/gcdext.c: Save an allocation if both cofactors are needed.
	* mpz/oddfac_1.c: Revision of all ASSERTs.
	* tests/mpz/t-invert.c: All elements are invertible in the zero ring.

2016-12-13  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h: Test LONGLONG_STANDALONE in two more places.

2016-12-07  Torbjörn Granlund  <tg@gmplib.org>

	* gmp-h.in: Check yet another symbol for FILE.

2016-12-04  Torbjörn Granlund  <tg@gmplib.org>

	* tests/mpz/reuse.c: Use mpz_clobber.  Split mpz_gcdext macros to avoid
	spurious res3 dependency.

	* tests/misc.c (mpz_clobber): New function.

2016-12-03  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Number Theoretic Functions): Tweak mpz_gcdext
	documentation. The first and third argument may be NULL, but not
	the second.

2016-12-02  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpz/reuse.c (main): Test additional cases of reuse for
	mpz_gcd and mpz_gcdext.

2016-12-01  Torbjörn Granlund  <tg@gmplib.org>

	* tests/misc.c (seed_from_tod): Make shift well-defined.

2016-11-29  Torbjörn Granlund  <tg@gmplib.org>

	* gmp-h.in (__GNU_MP__): Bump.

	* mpz/inp_raw.c: Rewrite size computation to avoid overflow.

	* mpz/kronsz.c: Use ABS_CAST to avoid undefined code.

2016-11-27 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/gcd.c, mpz/gcdext.c: Use NEWALLOC.
	* mpz/oddfac_1.c: Disable an ASSERT that needs a revision.

2016-11-27  Torbjörn Granlund  <tg@gmplib.org>

	* tests/mpz/reuse.c: Rewrite operand randomisation to use fixed ranges.

	* tune/time.c (cgt_works_p): Add a missing verbosity check.

	* configure.ac: Make udiv_w_sdiv use conditional on enable_assembly.

2016-11-25  Marc Glisse  <marc.glisse@inria.fr>

	* mpz/gcdext.c (mpz_gcdext): Allow a first argument of NULL.
	* doc/gmp.texi (Number Theoretic Functions): Document it.
	* tests/mpz/t-gcd.c (main): Test it.

2016-11-25  Marc Glisse  <marc.glisse@inria.fr>

	* tests/cxx/t-ops2z.cc (checkz): Avoid left shift of negative number.

2016-11-22  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (x86): Define LINUX for GNU/Linux systems.
	* mpn/x86_64/fat/fat_entry.asm: Set PRETEND_PIC for GNU/Linux.

2016-11-21  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (powerpc): Never use -O3.

	* acinclude.m4 (mpn_lshift_com optimization 2): Make it well-defined
	also for 32-bit systems.
	(mpn_lshift_com optimization 2): Free allocated memory.

2016-11-19  Niels Möller  <nisse@lysator.liu.se>

	* Makefile.am (check-mini-gmp): Override CFLAGS and CPPFLAGS
	instead of the deleted EXTRA_CFLAGS. Set TEST_LIBRARY_PATH,
	instead of LD_LIBRARY_PATH and DYLD_LIBRARY_PATH, to avoid getting
	gcc linked with an unexpected version of gmp.

2016-11-18  Niels Möller  <nisse@lysator.liu.se>

	* Makefile.am (check-mini-gmp): Get CC and EXTRA_CFLAGS right.

2016-11-17  Torbjörn Granlund  <tg@gmplib.org>

	* asl.h: Initial support for artificially small limbs.

2016-11-09 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* pz/iset_str.c: Lazy allocation.

2016-11-01  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/generic/dive_1.c: Remove a forgotten dummy while-loop.  (Spotted
	by Peter Barfuss.)

2016-10-31   Oleg Oshmyan  <chortos@inbox.lv>

	* gmp-impl.h (x86_64 MPN_IORD_U): Use proper asm constraint.

2016-10-30  Torbjörn Granlund  <tg@gmplib.org>

	* mpn/Makefile.am (TARG_DIST): Add riscv.

2016-10-28  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_binary_divides): Let 1/q call mpq_inv.
	* tests/cxx/t-ops.cc (check_mpq): Test it.

2016-10-24  Torbjörn Granlund  <tg@gmplib.org>

	* config.guess: Recognise Itanium Poulson.

2016-10-15  Torbjörn Granlund  <tg@gmplib.org>

	* configure.ac (arm*-*-*): Amend last change.

2016-10-14  Torbjörn Granlund  <tg@gmplib.org>

	* longlong.h (riscv umul_ppmm): New.

	* mpn/riscv/64/aors_n.asm: New file.
	* mpn/riscv/64/mul_1.asm: New file.
	* mpn/riscv/64/aorsmul_1.asm: New file.

	* mpn/generic/addmul_1.c: Rewrite for shallower recurrency.
	* mpn/generic/submul_1.c: Likewise.

	* configure.ac (riscv-*-*): New.
	(arm*-*-*): Rewrite arm support to handle armv8 CPUs in 32-bit mode.

2016-08-29  Torbjörn Granlund  <tg@gmplib.org>

	* All C files: Include just gmp-impl.h, make gmp-impl.h grab gmp.h.

	* mpf/get_str.c: Use __GMP_ALLOCATE_FUNC_TYPE and friends.
	* mpf/inp_str.c: Likewise.
	* mpq/get_str.c: Likewise.
	* mpz/get_str.c: Likewise.
	* mpz/inp_str.c: Likewise.
	* scanf/vsscanf.c: Likewise.
	* tal-reent.c: Likewise.

2016-08-24  Vlad Zakharov <vzakhar@synopsys.com>

	* longlong.h (arc add_ssaaaa, sub_ddmmss): Replace obsolete 'J'
	constraint with 'Cal'.

2016-08-22  Marc Glisse  <marc.glisse@inria.fr>

	* longlong.h (umul_ppmm from __umulsidi3): Protect with do ...
	while (0).

2016-06-02  Torbjörn Granlund  <tg@gmplib.org>
	    Vincent Lefevre <vincent@vinc17.net>

	* doc/gmp.texi: Various clarifications about variable conventions.

2016-04-07  Marc Glisse  <marc.glisse@inria.fr>

	* gmp-h.in (__GMP_NOTHROW): Prefer noexcept to throw().
	(mpz_init, mpz_inits): Mark as __GMP_NOTHROW.
	* mpz/init.c, mpz/inits.c: Likewise.
	* gmpxx.h (mpz_class): Mark default and move constructors noexcept.
	* tests/cxx/t-cxx11.cc: Check noexcept.

2016-04-02  Torbjörn Granlund  <torbjorng@google.com>

	* mpf/set_q.c: Rewrite, mainly to use mpn_div_q.

2016-03-29  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/fat/addmul_2.c: New file.

2016-03-28  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/addmul_2.asm: Move from here...
	* mpn/x86_64/k8/addmul_2.asm: ...to here.

2016-03-26  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/arm64/sqr_diag_addlsh1.asm: New file.

2016-03-25  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/arm64/xgene1/aors_n.asm: New file.
	* mpn/arm64/xgene1/aorsmul_1.asm: New file.
	* mpn/arm64/xgene1/cnd_aors_n.asm: New file.
	* mpn/arm64/xgene1/gmp-mparam.h: New file.
	* mpn/arm64/xgene1/mul_1.asm: New file.

	* config.guess: Prefix all arm CPUs with "arm" to accommodate our
	matchers.
	* configure.ac (arm): Match arm CPUs consistently.

2016-03-21  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac: Support many arm64 processors.

2016-03-20  Marc Glisse  <marc.glisse@inria.fr>

	* configure.ac (WANT_ASSEMBLY): Remove.
	(NO_ASM): Remove from CFLAGS, add to AC_DEFINE.
	* tests/misc.c: Test NO_ASM instead of WANT_ASSEMBLY.

2016-03-20  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess (arm*): Handle big.LITTLE CPUs by extracting the
	lexically largest id.
	* config.guess (arm*): Add many aarch64 CPUs.
	* config.guess (main): Corresponding changes.

	* mpn/arm/v7a/cora5/gmp-mparam.h: New file.

	* configure.ac (arm*): Support cortex-a5 better.

2016-02-25  Pavel Kopyl  <p.kopyl@samsung.com>

	* acinclude.m4 (GMP_ASM_UNDERSCORE): Tighten gurkmacka detection.

2016-01-27  Niels Möller  <nisse@lysator.liu.se>

	* errno.c (__gmp_exception): Use raise(SIGFPE) when available.

2016-01-15  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess (s390): Don't assume /proc/cpuinfo exists.

2016-01-13  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess: Reorder and generalise ppc code.

2016-01-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/cxx/clocale.c: Do not re-define localeconv for mingw.
	* tests/misc/t-locale.c: Likewise (Thanks Alexander).

	* primesieve.c: Heal a speed regression on small values.
	* mpz/bin_uiui.c (mpz_bdiv_bin_uiui): 2 factors all at once.
	  (mpz_goetgheluck_bin_uiui): Use STOP/CONT for loops on primesieve.
	* mpz/oddfac_1.c: Likewise.
	* mpz/primorial_ui.c (LOOP_ON_SIEVE_CONTINUE): Define prime locally.

	* gen-fac.c: Use unsigned types for sizes.

	* mpn/generic/invert.c: Use MPN_FILL macro.
	* mpn/generic/invertappr.c: Likewise.
	* mpn/generic/toom53_mul.c: Use _ip1 when available.

2015-12-28 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq/set_str.c: Use __GMP_FREE_FUNC_TYPE.
	* tests/mpz/t-nextprime.c: Speedup using swap, and correct type.

2015-12-26  Torbjörn Granlund  <torbjorng@google.com>

	* tests/misc.c (tests_start): Assert library version.

2015-12-19  Marc Glisse  <marc.glisse@inria.fr>

	* gmp-impl.h (fft_table_nk): Use gmp_uint_least32_t.
	* mpn/generic/trialdiv.c (gmp_primes_ptab): Likewise.

2015-12-14  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/fat/fat.c (gmp_workaround_skylake_cpuid_bug):
	New function.
	(__gmpn_cpuvec_init): Handle more BMI2 crippled CPUs.

2015-12-13 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/clears.c, mpf/inits.c, mpq/clears.c, mpq/inits.c,
	* mpz/clears.c, mpz/inits.c: Stop supporting empty list.
	* tests/arm32call.asm: bx->ret to support thumb-less chips
	  (thanks Martin Husemann).

2015-12-13  Torbjörn Granlund  <torbjorng@google.com>

	* config.sub: Fix spelling of kabylake.
	* acinclude.m4: Likewise.
	* mpn/x86_64/fat/fat.c: Likewise.

2015-12-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/misc/t-printf.c: Test a sequence of '%'.
	* printf/doprnt.c: Avoid buffer overread with long long limbs.

	* mpn/generic/toom_interpolate_7.c: Use the rsh1 functions,
	  when available, also for negatives (clearing the carry).
	* mpn/generic/toom_interpolate_12.c: Likewise.
	* mpn/generic/toom_interpolate_16.c: Likewise.

2015-12-06  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (arm*): Conditionally define NOTHUMB.
	Simplify and generalise.
	* mpn/arm/arm-defs.m4 (ret): New macro, conditional on NOTHUMB.
	* mpn/arm/*.asm: Use ret.

2015-12-03  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess: Work around skylake cpuid bug.
	Fix spelling of kabylake.

2015-12-01  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/coreibwl/mul_basecase.asm: Add FUNC_EXITs.

2015-11-21 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h (MPN_TOOM22_MUL_MINSIZE): Consider ToomX2 limits
	  (thanks Paul).
	* tests/mpn/t-toom22.c: Keep on testing small sizes.
	* tests/mpz/t-primorial_ui.c: Test a single "large" number.

	* tune/common.c (speed_mpz_primorial_ui): New function.
	* tune/speed.h: Declare it.
	* tune/speed.c (routine): Add mpz_primorial_ui.

	* primesieve.c: Use two presieved patterns on 64-bits CPUs.

2015-11-13 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq/init.c: Remove conditional code for __CHECKER__.
	* mpq/set.c: Shorten scope of local variables.
	* mpq/set_den.c: Likewise.
	* mpq/set_num.c: Likewise.
	* mpq/set_z.c: Likewise.

	* primesieve.c: Fill sieve with a presieved 70bits pattern.

2015-11-12  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_fibonacci_function): New class.
	(fibonacci, mpz_class::fibonacci): New functions.
	(__gmp_fac_function, __gmp_primorial_function): Add braces.
	* tests/cxx/t-ops2z.cc: Test fibonacci.
	* doc/gmp.texi (C++ Interface Integers): Document fibonacci.
	Warn about factorial and primorial of negative numbers.

2015-11-10  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_primorial_function): Throw on negative operands.
	* tests/cxx/t-ops2z.cc: Test it.

2015-11-09 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz: Experimental, lazy allocation.

2015-11-09  Marc Glisse  <marc.glisse@inria.fr>

	* tests/cxx/Makefile.am: Move EXTRA_DIST out of WANT_CXX.

2015-11-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/urandomm.c: Use mpn_zero_p to shorten code.

2015-11-08  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_fac_function, __gmp_primorial_function): New classes.
	(__GMPP_DECLARE_UNARY_STATIC_MEMFUN,
	__GMPNN_DECLARE_UNARY_STATIC_MEMFUN,
	__GMPNS_DECLARE_UNARY_STATIC_MEMFUN,
	__GMPNU_DECLARE_UNARY_STATIC_MEMFUN,
	__GMPND_DECLARE_UNARY_STATIC_MEMFUN,
	__GMPN_DECLARE_UNARY_STATIC_MEMFUN,
	__GMP_DECLARE_UNARY_STATIC_MEMFUN, __GMPP_DEFINE_UNARY_STATIC_MEMFUN,
	__GMPNN_DEFINE_UNARY_STATIC_MEMFUN,
	__GMPNS_DEFINE_UNARY_STATIC_MEMFUN,
	__GMPNU_DEFINE_UNARY_STATIC_MEMFUN,
	__GMPND_DEFINE_UNARY_STATIC_MEMFUN, __GMPN_DEFINE_UNARY_STATIC_MEMFUN,
	__GMP_DEFINE_UNARY_STATIC_MEMFUN): New macros.
	(factorial, mpz_class::factorial, primorial, mpz_class::primorial):
	New functions.
	* tests/cxx/t-ops2.cc: Test factorial and primorial.
	* tests/cxx/Makefile.am: Move t-ops2 after
	t-do-exceptions-work-at-all-with-this-compiler.
	* doc/gmp.texi: Document factorial and primorial.
	* NEWS: Likewise.

	* tests/cxx/t-ops2.cc: Remove and split into ...
	* tests/cxx/t-ops2z.cc, tests/cxx/t-ops2qf.cc, tests/cxx/t-ops2f.cc,
	tests/cxx/t-ops2.h: New files.
	* tests/cxx/Makefile.am: Update for the split.

2015-11-07  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__GMP_DEFINE_UNARY_FUNCTION_1,
	__GMPP_DEFINE_BINARY_FUNCTION_1, __GMPNN_DEFINE_BINARY_FUNCTION_1,
	__GMPNS_DEFINE_BINARY_FUNCTION_1, __GMPNU_DEFINE_BINARY_FUNCTION_1,
	__GMPND_DEFINE_BINARY_FUNCTION_1, __GMPNLD_DEFINE_BINARY_FUNCTION_1,
	__GMPN_DEFINE_BINARY_FUNCTION_1, __GMP_DEFINE_BINARY_FUNCTION_1):
	New macros.
	(operator~, trunc, floor, ceil, sqrt, operator%, operator&, operator|,
	operator^, hypot, gcd, lcm): Use them.

2015-11-06 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/and.c: Use MPZ_NEWALLOC.
	* mpz/ior.c: Remove duplicated branches, add branch hints.
	* mpz/xor.c: Likewise, and use NORMALIZE_NOT_ZERO.

	* mpz/init.c: Remove conditional code for __CHECKER__.
	* mpz/init2.c: Likewise.
	* mpz/inits.c: Likewise.
	* mpz/iset.c: Likewise.
	* mpz/iset_str.c: Likewise.

2015-11-04  Torbjörn Granlund  <torbjorng@google.com>

	* mpz/xor.c: Use MPZ_REALLOC.
	* mpz/ior.c: Likewise

2015-11-03 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/xor.c: Use the return value of _mpz_realloc.
	* mpz/ior.c: Likewise.
	* mpn/generic/sec_div.c: Remove unused var.

2015-11-01  Torbjörn Granlund  <torbjorng@google.com>

	* tests/misc.c (seed_from_tod, seed_from_urandom): New functions.
	(tests_rand_start): Use them.

2015-11-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* Version 6.1.0 released.

	* mpz/inits.c [__CHECKER__]: Init limb, not pointer.
	* mpz/init.c [__CHECKER__]: Likewise (spotted by Vicente Benjumea).
	* tests/mpf/t-pow_ui.c: Use another mpf for the size limit.

2015-10-30  Torbjörn Granlund  <torbjorng@google.com>

	* mpf/pow_ui.c: Add log(e) precision bits.

	* doc/gmp.texi (Floating-point): Rewrite mpf introduction.

2015-10-29 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* demos/factorize.c: mpz_div_2exp => mpz_tdiv_q_2exp.
	* demos/perl/GMP.xs: Likewise.
	* tests/mpf/t-pow_ui.c: Use reference value to check the size.

	* doc/gmp.texi (Floating-point): Remove "infinite precision" claim.

	* gmp-h.in: Update version.

2015-10-28  Torbjörn Granlund  <torbjorng@google.com>

	* tests/mpf/t-pow_ui.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Compile it.

	* mpf/pow_ui.c: Rewrite for accuracy and performance.

2015-10-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* configfsf.guess: Updated to version 2015-10-21, for a typo.

	* tests/cxx/t-ops.cc (check_mpq): Compare also with mpz.
	(check_mpf): Compare also with mpz and mpq.

2015-10-25  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac: Avoid passing ambiguous -march=skylake.

2015-10-21 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* Version 6.1.0-rc1 published.

	* gmp-h.in: Revert version for RC.

2015-10-20  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86/pentium4/sse2/popcount.asm: Use LEAL.
	* mpn/x86/k7/invert_limb.asm: Likewise.

2015-10-18  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/arm64/gmp-mparam.h: New file.

2015-10-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*): Bump version info.
	* gmp-h.in: Bump version.

2015-10-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpf/t-cmp_si.c: Initialise a variable (only when error arise)
	* mpn/generic/toom43_mul.c: Insert parentheses around & expressions.
	* mpn/generic/toom52_mul.c: Likewise.
	* tests/mpn/t-minvert.c: Remove an unused var.
	* tests/mpz/t-cong_2exp.c: Likewise.

2015-10-16  Hans Wennborg <hwennborg at google.com>

	* mpn/generic/div_qr_2.c: Insert parentheses around & expressions.
	* mpn/generic/toom44_mul.c: Likewise.
	* mpn/generic/toom53_mul.c: Likewise.
	* mpn/generic/toom62_mul.c: Likewise.
	* tests/mpn/t-bdiv.c: Simplify conditional printing of whitespace.
	* tests/mpn/t-div.c: Likewise.

2015-10-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* configfsf.sub: Updated to version 2015-08-20, from gnulib.
	* configfsf.guess: Updated to version 2015-09-14, from gnulib.

2015-10-14  Torbjörn Granlund  <torbjorng@google.com>

	* demos/pexpr.c (main): Clear out a variable.

	* mpn/generic/sqrlo_basecase.c: Move things before addmul_1 to reduce
	register pressure.

	* .hgignore: Add 'compile' and 'test-driver'.

	* mpn/generic/mu_bdiv_qr.c (mpn_mu_bdiv_qr_itch): Simplify, add ASSERT.
	* mpn/generic/mu_bdiv_q.c (mpn_mu_bdiv_q_itch): Likewise.

	* tune/tuneup.c (tune_mu_bdiv): Start at measured BDIV_DC_ thresholds.

2015-10-13 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/clears.c, mpf/inits.c, mpq/clears.c, mpq/inits.c,
	* mpz/clears.c, mpz/inits.c: Keep on supporting empty list.

2015-10-13  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__GMPP_DEFINE_BINARY_TYPE_FUNCTION): Allow mixed operations.
	(__gmp_cmp_function, __gmp_binary_equal, __gmp_binary_less):
	Handle mixed operations.
	(__gmp_cmp_function): Move before __gmp_binary_equal.

2015-10-13 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/pow_ui.c: Increased precision of partial results.

2015-10-12  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac: Reject AVX for NetBSD.

2015-10-11  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (fat_path): Add skylake.

2015-10-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gen-fib.c: Correct the name of the program in error message.
	* gen-fac.c: Likewise.

	* mpf/get_str.c: Increase precision of base^e computation.

2015-10-09  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess: Recognise cabylake and goldmont and more versions of
	skylake and silvermont.
	* acinclude.m4 (X86_64_PATTERN): Add cabylake and goldmont.
	* config.sub: Corresponding changes.
	* configure.ac: Corresponding changes.
	* mpn/x86_64/fat/fat.c: Corresponding changes.

2015-09-12  Torbjörn Granlund  <torbjorng@google.com>

	* mpf/clear.c, mpf/clears.c, mpf/inits.c, mpq/clear.c, mpq/clears.c
	* mpq/inits.c, mpz/clear.c, mpz/clears.c, mpz/inits.c:
	Streamline, use macros.

2015-09-27 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/cfdiv_r_2exp.c: Use mpn_neg and MPZ_NEWALLOC.
	* mpz/cfdiv_q_2exp.c: Use MPZ_REALLOC return value.

2015-09-12  Torbjörn Granlund  <torbjorng@google.com>

	* tests/mpf/t-cmp_si.c (check_data): Set precision reflecting data.

2015-09-11 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/cmp_z.c: New file implementing mpf_cmp_z.
	* mpf/Makefile.am (libmpf_la_SOURCES): Add it.
	* Makefile.am (MPF_OBJECTS): Add generate object to libs.
	* gmp-h.in: Declare new function.
	* tests/mpf/t-cmp_si.c: Test also the new function.
	* doc/gmp.texi: Document it.

2015-09-06  Torbjörn Granlund  <torbjorng@google.com>

	* Wrap remaining limb allocations in __GMP_ALLOCATE_FUNC_LIMBS.

	* mpn/x86/fat/fat.c (fake_cpuid_table): Add missing commas.
	* mpn/x86_64/fat/fat.c: Likewise.

	* mpn/x86/fat/fat.c (fake_cpuid_table): Improve struct type.
	* mpn/x86/fat/fat.c: Likewise.

2015-09-03 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpq/t-cmp_z.c (sizes_test): New function, tests sizes.

2015-09-03  Torbjörn Granlund  <torbjorng@google.com>

	* acinclude.m4 (GMP_C_HIDDEN_ALIAS): New.
	* configure.ac (GMP_C_HIDDEN_ALIAS): Invoke.

2015-09-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq/cmp.c (mpq_cmp_numden): Cast to avoid over/underflow.
	* tests/mpn/t-toom22.c (MIN_AN): Use defined value.
	* tests/mpz/t-fac_ui.c: Check big factorial modulo a larger prime.
	* mpn/generic/bsqrtinv.c: Use sqrlo+mullo_n instead of powlo(,,3,,).
	* mpq/div.c: Move a branch out of the normal flow.

2015-08-31  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86/fat/fat.c (fake_cpuid_table): Update similarly to
	corresponding x86_64 code.

2015-08-31 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq/cmp.c (mpq_cmp_z): New function to compare mpq with mpz,
	asked by Vincent Delecroix for the SageMath project.
	* gmp-h.in: Declare it.
	* doc/gmp.texi: Document it.
	* tests/mpq/t-cmp_z.c: New file to test mpq_cmp_z (from t-cmp.c).
	* tests/mpq/Makefile.am (check_PROGRAMS): Add t-cmp_z.

	* mpn/generic/powlo.c: Use mpn_sqrlo.

2015-08-29  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/fat/fat.c (fake_cpuid_table): Add CPU aliases.

2015-08-25 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* configure.ac (AH_VERBATIM): Add HAVE_NATIVE_mpn_mullo_basecase.
	* mpn/generic/sqrlo.c (mpn_sqrlo): Use mullo_basecase when faster.
	* mpn/generic/sqrlo_basecase.c: More readable #defines.

	* tune/tuneup.c (tune_sqrlo): New function to tune sqrlo thresholds.
	(all): Call it, after multiplication and FFT.
	* tune/Makefile.am (TUNE_MPN_SRCS_BASIC): Add sqrlo{,_basecase}.c .
	* gmp-impl.h: Add all SQRLO_*_THRESHOLD* defs, for tuning and default.
	* mpn/generic/sqrlo.c: Remove default threshold definitions.
	* mpn/generic/sqrlo_basecase.c: Use SQRLO_DC_THRESHOLD_LIMIT.
	* mpn/minithres/gmp-mparam.h: New SQRLO_*_THRESHOLDs.

	* tune/tuneup.c (tune_mullo): Set MULLO_MUL_N_THRESHOLD to never
	whenever the FFT threshold does not exist.

	* mpf/cmp.c: Remove some branches.

2015-08-25  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/x86_64-defs.m4: Output computed numbers in base-10 instead
	of base-16 to avoid bugs on Solaris, FreeBSD, and old NetBSD.

2015-08-23  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/fat/fat.c (fake_cpuid_table): Add more entries, handle
	Broadwell separately.

	* configure.ac (fat_path): Add coreibwl.

2015-08-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/rootrem.c (logbased_root): New function.
	(mpn_rootrem_internal): Use it to estimate highest 9 bits of the root.

	* gmp-impl.h (MPQ_PTR_SWAP, MPQ_SRCPTR_SWAP): New macros.

2015-08-17  Torbjörn Granlund  <torbjorng@google.com>

	* acinclude.m4 (X86_64_PATTERN): Add skylake.
	* config.guess: Corresponding changes.
	* config.sub: Corresponding changes.
	* configure.ac: Corresponding changes.
	* mpn/x86_64/skylake/gmp-mparam.h: New file.

2015-08-15  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/generic/mullo_basecase.c: Provide alternative code, make default.

2015-08-04 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/refmpn.c (refmpn_sqrlo): New function.
	* tests/tests.h: Define it.

	* mpn/generic/sqrlo.c: New file, new function.
	* mpn/generic/sqrlo_basecase.c: New file, new function.
	* gmp-impl.h (mpn_sqrlo, mpn_sqrlo_basecase): Declare them.
	* configure.ac (gmp_mpn_functions): Add new files.

	* tests/mpn/t-sqrlo.c: New file, new test.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add new test.
	* tests/devel/try.c: Support mpn_sqrlo and mpn_sqrlo_basecase.

	* tune/common.c (speed_mpn_sqrlo{,_basecase}): New functions.
	* tune/speed.c: Support new functions.
	* tune/speed.h (SPEED_ROUTINE_MPN_MULLO_BASECASE): Update.
	(SPEED_ROUTINE_MPN_SQRLO): New macro.

	* mpn/generic/rootrem.c: Avoid divisions if not needed.

	* tests/mpn/t-broot.c: Test also k=1.
	* mpz/aorsmul_i.c: Move branches out of main line.

2015-07-28 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/sqrtrem.c (mpn_dc_sqrt): Support odd sizes.

2015-07-16  Torbjörn Granlund  <torbjorng@google.com>

	* tune/speed.c: Remove now redundant MPN_FILL.

	* configure.ac (hppa-hpux): Never use O3 optimisation.

2015-07-09  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/ia64/add_n_sub_n.asm: Make it work for HP-UX.
	* mpn/ia64/addmul_2.asm: Likewise.
	* mpn/ia64/aors_n.asm: Likewise.
	* mpn/ia64/aorsorrlshC_n.asm: Likewise.
	* mpn/ia64/cnd_aors_n.asm: Likewise.
	* mpn/ia64/gcd_1.asm: Likewise.
	* mpn/ia64/lshiftc.asm: Likewise.
	* mpn/ia64/mod_34lsub1.asm: Likewise.
	* mpn/ia64/mul_2.asm: Likewise.
	* mpn/ia64/sec_tabselect.asm: Likewise.
	* mpn/ia64/sqr_diag_addlsh1.asm: Likewise.

2015-07-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h (MPN_FILL): New macro, generalise MPN_ZERO.

	* mpn/generic/sqrtrem.c (mpn_dc_sqrt): New function not computing remainder.
	(mpn_dc_sqrtrem): Use tdiv_q instead of divrem, use given scratch space.
	(mpn_sqrtrem): Use mpn_dc_sqrt for both even and odd sizes.

2015-06-24  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/fastsse/com.asm: Disallow zero size operands.

	* mpn/x86_64/fastsse/copyi.asm: Suppress looping in basecase code.

2015-06-23 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/sqrtrem.c (mpn_sqrtrem2): Simplify branches.
	(mpn_dc_sqrtrem): Don't compute remainder if not needed.

2015-06-23  Torbjörn Granlund  <torbjorng@google.com>

	* gmp-impl.h: Remove K&R stringize support.
	* tests/devel/try.c: Likewise.
	* tests/t-constants.c: Likewise.
	* tests/mpf/t-fits.c: Likewise.
	* tests/mpz/t-fits.c: Likewise.

	* configure.ac (AC_C_STRINGIZE): Remove.

2015-06-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/devel/try.c: Support mpn_sqrt (sqrtrem with remainder = NULL).
	* mpn/generic/sqrtrem.c: Reorder branches for single limb operands.

2015-06-15  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess: Rewrite code for AVX handling to deal with broken cpuid
	states.

2015-06-11  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86/k7/gcd_1.asm: Align stack for calls.
	* mpn/x86/p6/gcd_1.asm: Amend last change: align for PIC and non-PIC.

2015-06-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/sqrtrem.c: Use sqrtrem1 for single limb operands.

	* tests/mpz/t-root.c: Check also mpz_root return value.
	* mpn/generic/rootrem.c: Shorten first and last loop.

	* mpn/generic/toom2_sqr.c: Add some ASSERTs.
	* mpn/generic/toom22_mul.c: Likewise.
	* tests/mpn/t-toom22.c: stop testing some unsafe (unused) corner cases.

2015-06-08  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86/p6/gcd_1.asm: Align stack for calls.

2015-06-06  Torbjörn Granlund  <torbjorng@google.com>

	* config.sub: Recognise any arm*neon CPU.
	* configure.ac (powerpc): Add p8 directory for power8 and later.
	* mpn/powerpc64/mode64/p8/invert_limb.asm: New file.

2015-06-01  Torbjörn Granlund  <torbjorng@google.com>

	* tune/speed.c (routine): Measure "mpn_sqrt" and "mpn_root", which are
	really the corresponding "rem" functions with NULL remainder argument.

	* tune/speed.h (SPEED_ROUTINE_MPN_SQRTROOT_CALL): New.
	(SPEED_ROUTINE_MPN_SQRTREM, SPEED_ROUTINE_MPN_ROOTREM):	Remove.

	* tune/common.c (speed_mpn_sqrt, speed_mpn_root): New functions.
	(speed_mpn_sqrtrem): Use SPEED_ROUTINE_MPN_SQRTROOT_CALL
	(speed_mpn_rootrem): Likewise.

2015-05-30 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/cmp_ui.c: Use macros, remove branches, correct nails.
	* mpf/cmp_si.c: Likewise.
	* mpf/int_p.c: Use a simpler loop to ignore zero limbs.

	* mpf/sqrt_ui.c: Special case for sqrt(1).
	* tests/mpf/t-sqrt_ui.c: Test special cases.

	* gmp-h.in: Declare (and inline) mpn_zero_p.
	* gmp-impl.h: Remove mpn_zero_p.
	* mpn/generic/zero_p: New file to include the function in the library.
	* configure.ac (gmp_mpn_functions): Add it.
	* doc/gmp.texi: Document it.

	* mpz/combit.c: Call mpn_zero_p only if size is not zero.
	* mpz/scan1.c: Likewise.
	* tests/mpn/t-brootinv.c: Likewise.
	* tests/mpn/t-div.c: Likewise.
	* tests/mpn/t-minvert.c: Likewise.

2015-05-28  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Low-level Functions): Document mpn_divexact_1 and
	mpn_cnd_swap (the latter was forgotten for the 2015-02-08 change).

2015-05-28  Linus Nordberg  <linus@nordberg.se>

	* configure.ac: Remove double quotes in help strings, make some
	clarifications.

2015-05-24 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq/div.c: Reduce memory use.
	* tests/mpq/reuse.c: Test also mpq_FUNCTION (x,x,x).
	* mpz/swap.c: Use _SWAP macros.

2015-05-18  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (arm): Let compiler decide about arm vs thumb encoding.

2015-05-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-h.in (mpn_neg): Niels' code using mpn_neg.
	* gmp-h.in (mpn_com): Unconditionally declare prototype.

2015-05-17  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/arm/v6/sqr_basecase.asm: Rewrite for speed.

2015-05-16  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/arm/v6/addmul_2.asm: Rewrite for speed and size.

2015-05-15  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/arm/v7a/cora7/gmp-mparam.h: New file.
	* mpn/arm/v7a/cora8/gmp-mparam.h: New file.
	* configure.ac (arm): Point to new directories.

2015-05-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/invertappr.c: Reduce memory usage.
	* gmp-impl.h (mpn_invertappr_itch): Update accordingly.
	* tune/tuneup.c (tune_invertappr, tune_invert): Update min_size.

	* mpn/generic/mu_div_qr.c: Pass scratch memory to mpn_invertappr.
	* mpn/generic/mu_divappr_q.c: Likewise.

2015-05-12  Felix Janda  <felix.janda@posteo.de>

	* mpn/powerpc32/elf.m4 (LEA): Adopt to new ABI.

2015-05-09 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/invertappr.c: Reduce memory usage.
	* gmp-impl.h (mpn_invertappr_itch): Update accordingly.

2015-05-01  Torbjörn Granlund  <torbjorng@google.com>

	* tune/tuneup.c (all): Make GCD tuning last since it is not robust.

2015-04-27  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/coreibwl/gmp-mparam.h: New file.

2015-04-26  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/coreibwl/mul_basecase.asm: New file.
	* mpn/x86_64/coreibwl/sqr_basecase.asm: New file.

2015-04-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tune/common.c (speed_mpn_neg, speed_mpz_2fac_ui): New functions.
	(speed_mpn_add_1, speed_mpn_add_1_inplace): New functions.
	(speed_mpn_sub_1, speed_mpn_sub_1_inplace): New functions.
	* tune/speed.h: Declare them all.
	* tune/speed.c (routine): Added mpn_neg, mpn_add_1, mpn_sub_1,
	mpn_add_1_inplace, mpn_sub_1_inplace, and mpz_2fac_ui.

2015-04-25 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/invert.c: Split add in the correction test.
	* mpn/generic/invertappr.c: Cleanup of loops and branches.

	* mpn/generic/hgcd_reduce.c: Use TMP_ALLOC_LIMBS_3.
	* mpn/generic/powm.c: Use TMP_ALLOC_LIMBS_2.
	* mpn/generic/rootrem.c: Likewise.
	* mpn/generic/remove.c: Remove redundant #ifdef.
	* mpn/generic/perfpow.c: Likewise.

2015-04-21  Torbjörn Granlund  <torbjorng@google.com>

	* printf/sprintffuns.c (gmp_sprintf_final): Remove extra parameters.

	* mpn/arm/v6/popham.asm: Add MULFUNC_PROLOGUE.
	* mpn/powerpc64/mode64/rsh1aors_n.asm: Likewise.
	* mpn/powerpc64/mode64/p6/aorsmul_1.asm: Likewise.

2015-04-19  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86_64/x86_64-defs.m4 (oplist): Fix typo.
	(mulx): Simplify.
	(adcx, adox): New defines, using helper function adx.
	* mpn/x86_64/coreibwl/mul_1.asm: New file.
	* mpn/x86_64/coreibwl/addmul_1.asm: New file.
	* configure.ac (x86_64): Put coreibwl in appropriate code path.

	* configure.ac (x86_64): Pass more exact Intel CPU options.

2015-04-13  Torbjörn Granlund  <torbjorng@google.com>

	* longlong.h (arm): Rewrite.  Support thumb2; use gcc builtins for
	count_leading_zeros, use accurate code selection critera.

2015-04-13  Marc Glisse  <marc.glisse@inria.fr>

	* configure.ac (x86_64): Extend noavx to ABI=64.

2015-04-10  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/alpha/ev6/mod_1_4.asm: Use LDGP.

2015-04-01  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (sparc): Don't use use -xO4, it miscompiles by design.

2015-03-24  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/generic/mul_fft.c (mpn_fft_best_k): Don't make pointers `static'
	just because they point to static (i.e., file-local) data.

2015-03-15  Torbjörn Granlund  <torbjorng@google.com>

	* acinclude.m4 (X86_64_PATTERN): Add CPU code names.

	* config.guess: Add more CPUs, use CPU code names.
	* config.sub: Corresponding changes.
	* configure.ac: Corresponding changes.

2015-02-21  Niels Möller  <nisse@lysator.liu.se>

	* gmp-h.in (mpn_divexact_1): New public declaration.
	* gmp-impl.h: Moved from here.

2015-02-08  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Low-level Functions): Document mpn_cnd_swap.

	* mpn/generic/cnd_swap.c (mpn_cnd_swap): New file, moved function
	here. Also changed cnd argument type from int to mp_limb_t.
	* mpn/generic/sec_invert.c (mpn_cnd_swap): Old location.
	* configure.ac: Added cnd_swap.
	* gmp-h.in (mpn_cnd_swap): Added prototype.

2015-01-19  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (arm): Provide architecture specific configs in addition
	to implementation specific configs.

	* config.guess (arm): Use configfsf.guess's guess as default before
	conditionally appending "neon".

2015-01-08  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess: Match POWER8 for AIX.

	* longlong.h: Add many casts inside assembly input operands, this
	insures proper zero extension.

2014-12-27  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_unary_expr): Use __gmp_resolve_ref.
	(__gmp_expr): New specialization for unary expressions with
	a builtin argument.

2014-12-26  Marc Glisse  <marc.glisse@inria.fr>

	* gmp-impl.h (tmp_debug_entry_t): Change block to type void*.

2014-12-22  Torbjörn Granlund  <torbjorng@google.com>

	* longlong.h (mips64, mips32): Work around one clang bug.

2014-12-18  Torbjörn Granlund  <torbjorng@google.com>

	* longlong.h (umul_ppmm): Use input temps in more places.

2014-12-10  Marc Glisse  <marc.glisse@inria.fr>

	* tests/cxx/clocale.c (localeconv, nl_langinfo): Match glibc's
	prototype in C++.

2014-12-09  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (powerpc): Remove hardwired -mpowerpc, causes clang
	problems.  Optionally pass -m32.

2014-12-08  Marc Glisse  <marc.glisse@inria.fr>

	* config.guess (ultrasparc*-*-*): Update for T4 and T5.
	* config.sub (ultrasparc*-*-*): Update for T5.
	* configure.ac (ultrasparc*-*-*): Update for T5.

	* longlong.h (sparc64): Define COUNT_LEADING_ZEROS_NEED_CLZ_TAB
	with VIS3.

	* tests/misc/t-locale.c (localeconv, nl_langinfo): Match glibc's
	prototype in C++.
	* tests/mpf/t-get_si.c (check_limbdata): Avoid narrowing conversion
	from -1 to unsigned inside {}.

2014-12-02  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess (arm*-*-*): Redirect stderr.

2014-11-26  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (arm*-*-*): Optionally pass redundant fpu mode options
	in order to placate clang.

	* mpn/arm/neon/lshiftc.asm: Avoid insn form missing from clang.

2014-11-24  Torbjörn Granlund  <torbjorng@google.com>

	* configure.ac (mips*-*-*): Provide ABI synonyms (for clang pretending
	to be gcc).

2014-11-18  Torbjörn Granlund  <torbjorng@google.com>

	From Hannes Mehnert:
	* config.guess (arm*-*-*): Base guesses on first matching /proc/cpuinfo
	line.

2014-11-17  Torbjörn Granlund  <torbjorng@google.com>

	* longlong.h (__longlong_h_C): New macro.
	(mpn_umul_ppmm, etc): Use it for C++ support.

2014-11-15  Torbjörn Granlund  <torbjorng@google.com>

	* tests/mpz/reuse.c: Make function vectors 'static'.

	* tests/mpn/logic.c (check_one): Make string variable 'const'.

	* tests/mpz/t-perfpow.c (tests): Make 'static'.

	* tune/tuneup.c (fftmes): Remove an unused variable.

2014-11-15  Marc Glisse  <marc.glisse@inria.fr>

	* tests/amd64check.c (calling_conventions_fenv): Mark as extern "C".
	* tests/x86check.c (calling_conventions_fenv): Likewise.

2014-11-13  Hans Wennborg  <hwennborg@google.com>

	* mpn/generic/toom_interpolate_8pts.c: Fix operator precedence in
	ASSERT.

2014-11-13  Torbjörn Granlund  <torbjorng@google.com>

	* tune/speed.h: Add casts for C++ compatibility.
	(speed_cyclecounter): Mark as extern "C".
	(mpn_mod_1_1p_1, mpn_mod_1_1p_2): Correct prototype.

	* tune/tune-gcd-p.c: Add casts for C++ compatibility.

	* tune/tuneup.c: Add casts for C++ compatibility.
	(mpn_divrem_1_tune, mpn_mod_1_tune): Mark as extern "C".
	(INSERT_FFTTAB): Produce sentinels differently to silence compiler.

2014-11-12  Torbjörn Granlund  <torbjorng@google.com>

	* gen-psqr.c: Add casts for C++ compatibility.

	* tests/misc/t-scanf.c: Include config.h early for HAVE_xxx.

2014-11-08  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/x86/x86-defs.m4 (LEA, LEAL): Make sure to put eip stub code in
	text segment.
	* mpn/x86/darwin.m4: Likewise.

	* tune/speed.h (i386 speed_cyclecounter): Remove inline asm code, rely
	on external version.

2014-11-06  Torbjörn Granlund  <torbjorng@google.com>

	* config.guess: Ignore appended letters such E in POWER8E.
	* configure.ac: Supply cflags for power8, power9.

2014-11-03  Torbjörn Granlund  <torbjorng@google.com>

	* mpn/powerpc32/addmul_1.asm: Avoid negative stack pointer references.
	* mpn/powerpc32/lshift.asm: Likewise.
	* mpn/powerpc32/lshiftc.asm: Likewise.
	* mpn/powerpc32/p3-p7/aors_n.asm: Likewise.
	* mpn/powerpc32/rshift.asm: Likewise.
	* mpn/powerpc32/sec_tabselect.asm: Likewise.
	* mpn/powerpc32/submul_1.asm: Likewise.
	* mpn/powerpc32/vmx/mod_34lsub1.asm: Likewise.

2014-10-13  Torbjörn Granlund  <torbjorng@google.com>

	* acinclude.m4 (freebsd hacked gcc): Test for crash-prone FreeBSD gcc.

2014-10-03  Peter Breitenlohner <peb@mppmu.mpg.de>

	* mpn/generic/sec_tabselect.c: Adjust type to silence compiler.

2014-10-01  Torbjörn Granlund  <torbjorng@google.com>

	* All Makefile.am: INCLUDES => AM_CPPFLAGS.

	* configure.ac (arm64): Set gcc_cflags_maybe to enable Neon (for clang
	pretending to be gcc).

2014-09-24  Marc Glisse  <marc.glisse@inria.fr>

	* longlong.h (arm64 count_trailing_zeros, count_leading_zeros): Use
	gcc's builtins.
	(arm64 umul_ppmm): Use macro arguments only once.

2014-09-22  Marc Glisse  <marc.glisse@inria.fr>

	* mpn/arm64/lshift.asm: Avoid negative immediates.
	* mpn/arm64/rshift.asm: Likewise.

2014-09-13  Marc Glisse  <marc.glisse@inria.fr>

	* mpn/generic/div_qr_1n_pi1.c: Honor NO_ASM.
	* mpn/generic/div_qr_1n_pi2.c: Likewise.
	* mpn/generic/div_qr_1u_pi2.c: Likewise.
	* mpn/generic/div_qr_2.c: Likewise.
	* mpn/generic/mod_1_1.c: Likewise.
	* mpn/generic/redc_2.c: Likewise.

2014-08-31  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/arm64/lshift.asm: New file.
	* mpn/arm64/rshift.asm: New file.

2014-09-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h (TMP_ALLOC_LIMBS_3): New macro to allocate 3 blocks.
	(mpn_remove): Update declaration with mp_srcptr arguments.
	* mpn/generic/remove.c: Use TMP_ALLOC_LIMBS_3. mp_srcptr for args.

	* mpn/generic/perfpow.c (pow_equals): TMP_DECL only where needed.
	(perfpow): Use TMP_ALLOC_LIMBS_3.
	(mpn_perfect_power_p): Skip useless allocations. Use mpn_remove.
	* tests/mpz/t-perfpow.c (check_random): Check more perfect powers.

	* mpn/generic/divis.c: Use TMP_ALLOC_LIMBS_2. Share a count.

2014-08-30  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/arm64/mod_34lsub1.asm: New file.

2014-08-23  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/arm64/bdiv_dbm1c.asm: New file.

	* mpn/arm64/com.asm: New file.

	* mpn/arm64/sec_tabselect.asm: New file.

	* mpn/arm64/popcount.asm: New file.
	* mpn/arm64/hamdist.asm: New file.

	* configure.ac: Put generic arm/neon earlier in path.

2014-08-14 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq/canonicalize.c: Earlier check for negative denominator.
	* mpq/set_d.c: Stricter allocation.

2014-08-03  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bobcat/mul_1.asm: Fix typo in offset affecting DOS64.

2014-07-28 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/fib2_ui.c: remove #if HAVE_NATIVE_mpn_rsblsh_n.
	* mpz/fib2_ui.c: Use tabulated values, when available.
	* mpz/fib_ui.c: #if HAVE_NATIVE_mpn_addlsh1_n, use it.

	* mpq/cmp_ui.c: Remove a branch.
	* mpq/cmp_si.c: Likewise.

	* mpn/generic/toom_interpolate_7pts.c: Replace an in-place add
	with add_n + INCR_U.

	* tests/mpf/t-fits.c: use ui_sub instead of sub_ui+neg.

2014-07-27  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/x86/k7/gcd_1.asm: Use LEAL.

	* mpn/x86/x86-defs.m4 (LEAL): New.
	(LEA): Append to `load_eip' instead of ASM_END, like darwin.m4.
	* mpn/x86/darwin.m4 (LEAL): New.

2014-07-26  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/x86/pentium/mode1o.asm: Add Darwin PIC code.
	* mpn/x86/pentium/bdiv_q_1.asm: Likewise.
	* mpn/x86/pentium/dive_1.asm: Likewise.
	* mpn/x86/pentium/popcount.asm: Likewise.
	* mpn/x86/pentium/hamdist.asm: Likewise.
	* mpn/x86/k6/gcd_1.asm: Likewise.

	* mpn/x86: Append ASM_END to many files.
	* tests/x86call.asm: Append ASM_END.

	* mpn/x86/fat/fat_entry.asm (FAT_ENTRY, FAT_INIT):
	Support Darwin.

	* mpn/x86/darwin.m4 (ASM_END): New, body from EPILOGUE_cpu.
	(EPILOGUE_cpu): Remove.

	* mpn/x86/x86-defs.m4 (LEA): Put `mov_eip_' thunks in ASM_END instead
	of EPILOGUE_cpu.

2014-07-05  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Low-level Functions): Document that scratch need
	for mpn_sec_add_1 and mpn_sec_sub_1 are at most n limbs.
	(Low-level Functions): Document allowed overlap for mpn_addmul_1
	and mpn_submul_1.

2014-07-02  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/x86_64/x86_64-defs.m4: Fix quoting.

	* mpn/x86_64/atom/redc_1.asm: Enforce proper stack allocation.
	* mpn/x86_64/bobcat/redc_1.asm: Likewise.
	* mpn/x86_64/core2/divrem_1.asm: Likewise.
	* mpn/x86_64/core2/gcd_1.asm: Likewise.
	* mpn/x86_64/core2/redc_1.asm: Likewise.
	* mpn/x86_64/coreihwl/redc_1.asm: Likewise.
	* mpn/x86_64/coreinhm/redc_1.asm: Likewise.
	* mpn/x86_64/coreisbr/redc_1.asm: Likewise.
	* mpn/x86_64/divrem_1.asm: Likewise.
	* mpn/x86_64/divrem_2.asm: Likewise.
	* mpn/x86_64/gcd_1.asm: Likewise.
	* mpn/x86_64/mod_1_1.asm: Likewise.
	* mpn/x86_64/mod_1_2.asm: Likewise.
	* mpn/x86_64/mod_1_4.asm: Likewise.

2014-06-30  Torbjörn Granlund  <tege@gmplib.org>

	* config.sub: Generalise x86 patterns.

2014-06-17  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_gcd_function, __gmp_lcm_function): New classes.
	(gcd, lcm): New functions.
	* doc/gmp.texi (C++ Interface Integers): Document them.
	* tests/cxx/t-ops2.cc (checkz): Test them.

2014-06-16  Torbjörn Granlund  <tege@gmplib.org>

	* mpf/mul.c: Postpone TMP_MARK.

	* mpn/generic/perfpow.c (perfpow): Combine TMP_ALLOCs.

2014-06-15  Torbjörn Granlund  <tege@gmplib.org>

	* tests/refmpn.c (refmpn_mul): Rewrite to avoid O(n) recursion depth.

2014-06-09  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/generic/mullo_n.c: Remove default THRESHOLDs.
	* gmp-impl.h: Put MULLO THRESHOLDs here.  Improve various THRESHOLD
	defaults.

2014-06-08  Torbjörn Granlund  <tege@gmplib.org>

	* gmp-impl.h (TMP_ALLOC): Decrease limit to about half.

	* mpn/generic/toom53_mul.c: Replace many TMP_SALLOC invocations
	by a single TMP_ALLOC.
	* mpn/generic/toom42_mul.c: Likewise.

	* mpn/generic/sec_sqr.c: Don't unconditionally call mpn_sqr_basecase
	since it fails for non-cryptographic sizes for some obsolete CPUs.

	* mpn/generic/sec_powm.c: Remove own squaring code, instead use
	mpn_mul_basecase.

	* tests/mpn/logic.c (main): Don't use TMP_SALLOC_LIMBS.

	* mpn/generic/dcpi1_div_q.c: Avoid TMP_SALLOC_LIMBS.
	* mpn/generic/dcpi1_div_qr.c: Likewise.

2014-06-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/mul.c: Tighter allocation in Toom{2,3}X branches.

2014-06-06  Torbjörn Granlund  <tege@gmplib.org>

	* mpn/generic/mul.c: Swap some TMP_SALLOC_LIMBS for TMP_ALLOC_LIMBS
	and some TMP_ALLOC_LIMBS for TMP_SALLOC_LIMBS.

2014-05-31 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/ui_sub.c: Remove buggy code, use a wrapper to mpf_sub.
	* tests/mpf/t-sub.c: More corner cases and strict checking.
	* mpf/sub.c: Use more mpn_ primitives and macros.

	* tests/mpf/t-int_p.c: Test numbers with both integer and
	fractionary parts.

	* mpf/int_p.c: Delay zero branch and use mpn_zero_p.
	* mpf/fits_s.h: No special case for SIZ == 0.
	* mpf/fits_u.h: Likewise.

2014-05-29  Marc Glisse  <marc.glisse@inria.fr>

	* gmp-h.in: Include <limits.h>.
	(__GMP_UINT_MAX, __GMP_ULONG_MAX, __GMP_USHRT_MAX): Remove.
	* gmp-impl.h (ULONG_MAX, UINT_MAX, USHRT_MAX, LONG_MAX, INT_MAX,
	SHRT_MAX): Remove unnecessary redefinition.
	* tests/t-gmpmax.c: Remove file.
	* tests/Makefile.am: Remove t-gmpmax.

2014-05-22 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpf/t-sub.c (check_data): Test also ui_sub and sub_ui.

2014-05-20 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gen-fac.c: +1 in the init2 argument before setbit.
	* gen-fib.c: Likewise. (Thanks Niels)
	* rand/randmts.c: Likewise.

	* mpn/generic/invert.c: Remove unused TMP_MARK.
	* mpn/generic/invertappr.c: Avoid a branch.
	* mpz/millerrabin.c (millerrabin): Consider the rare case n is a power.

2014-05-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gen-fib.c: Use mpz_setbit.
	* gen-psqr.c: Skip even numbers when looking for primes.

	* mpn/generic/invert.c: Avoid a branch.
	* mpn/generic/toom2_sqr.c: Avoid a few branches in the odd case.
	* mpn/generic/toom22_mul.c: Likewise.

2014-05-08  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (std::common_type): Remove partial specialization for two
	identical expressions. New partial specialization for a single type.
	* tests/cxx/t-cxx11.cc: Test it.

2014-04-14  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (mpz_invert): Clarify behavior in the zero ring.

2014-04-04  Marc Glisse  <marc.glisse@inria.fr>

	* longlong.h (i386): Add comment about "cc" clobber.

2014-04-04  Torbjorn Granlund  <tege@gmplib.org>

	* acinclude.m4 (X86_64_PATTERN): Generalise patterns to allow "noavx"
	suffix.

	* mpn/generic/div_qr_1n_pi1.c: Conditionalise ARM asm on !__thumb__.

2014-04-03  Marc Glisse  <marc.glisse@inria.fr>

	* mpn/arm64/mul_1.asm, mpn/arm64/gcd_1.asm: Use official b.cond syntax.
	* mpn/arm64/invert_limb.asm, mpn/arm64/aorsmul_1.asm: Prefix
	immediates with #.

2014-04-03  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Append "noavx" for CPUs which have AVX but where the
	kernel does not support it.
	* configure.ac: Accept "noavx" cpu name suffixes.  Conditionally pass
	-mno-avx.

2014-04-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/k8/redc_1.asm: Workaround for Darwin assembler quirk.

2014-03-28  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/mod_1_1.c: Conditionalise ARM asm on !__thumb__.

2014-03-31  Marc Glisse  <marc.glisse@inria.fr>

	* mpn/arm/dive_1.asm, mpn/arm/invert_limb.asm: Use RODATA.
	* acinclude.m4 ([long long reliability tests]): Declare functions.
	(GMP_PROG_CC_FOR_BUILD_WORKS, GMP_PROG_EXEEXT_FOR_BUILD,
	GMP_C_FOR_BUILD_ANSI, GMP_CHECK_LIBM_FOR_BUILD): Replace exit(0) with
	return 0, no declaration needed.
	(GMP_CHECK_LIBM_FOR_BUILD): Include <math.h> to declare log.

2014-03-30  Marc Glisse  <marc.glisse@inria.fr>

	* README: Remove mention to Berkeley MP compatibility.

2014-03-26  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/mode64/gcd_1.asm: Provide default for
	BMOD_1_TO_MOD_1_THRESHOLD.

2014-03-24  Torbjorn Granlund  <tege@gmplib.org>

	* Version 6.0.0 released.

	* mpn: Update countless gmp-mparam.h files.

2014-03-22  Torbjorn Granlund  <tege@gmplib.org>

	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*): Bump version info.
	* gmp-h.in: Bump version.

2014-03-17  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Remove clipper, i960, ns32k, pyr, a29k, z8000.
	* mpn/clipper: Remove directory and all its files.
	* mpn/i960: Likewise.
	* mpn/ns32k: Likewise.
	* mpn/pyr: Likewise.
	* mpn/a29k: Likewise.
	* mpn/z8000: Likewise.
	* mpn/Makefile.am (TARG_DIST): Purge removed directories.
	* doc/gmp.texi: Remove special mentions of removed architectures.

2014-03-12  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86/bd2/gmp-mparam.h: New file.
	* mpn/x86_64/bd2/gmp-mparam.h: New file.

2014-03-06  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpz/t-pprime_p.c (check_composites): New function.
	(check_primes): New function.
	(main): Call them. Also use TESTS_REPS.

2014-03-01  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/sec_powm.c (mpn_sec_powm): Clarify comment and
	asserts.

2014-02-28  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fat/fat.c (fake_cpuid): Handle id 7, make bold claims.

2014-02-27  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fat/fat_entry.asm: Zero ecx for the benefit of new BMI2
	feature test.

	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init): Run CPUVEC_SETUP_coreihwl
	conditionally on BMI2 availability.

	* config.guess: Revert "coreihwl" to "coreisbr" if cpuid indicates that
	BMI2 is missing.
	(x86 cpuid, 2 variants): Zero ecx for the benefit of new BMI2 feature
	test.

2014-02-17  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/div_qr_1.c (mpn_div_qr_1): Revert yesterday's fix.
	Hopefully no longer needed.

	* mpn/s390_64/gmp-mparam.h (DIV_QR_1_NORM_THRESHOLD): Up to 1.
	* mpn/s390_64/z10/gmp-mparam.h (DIV_QR_1_NORM_THRESHOLD): Up to 1.

	* tune/tuneup.c (tune_div_qr_1): Ensure DIV_QR_1_NORM_THRESHOLD,
	DIV_QR_1_UNNORM_THRESHOLD >= 1.

2014-02-16 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/div_qr_1.c: Disallow DIV_QR_1_NORM_THRESHOLD==0.

2014-02-15  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpn/t-div.c: Fix typo.

2014-02-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* doc/gmp.texi (mpz_roinit_n, MPZ_ROINIT_N): Document that
	at least a readable limb is required.

2014-02-14  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Low-level Functions): Update docs for
	mpn_sec_powm, to specify that left-over exponent bits must be
	zero.

2014-02-11  Niels Möller  <nisse@lysator.liu.se>

	* Makefile.am (EXTRA_DIST): Distribute COPYING.LESSERv3,
	COPYINGv2, and COPYINGv3.

	* doc/gmp.texi (Low-level Functions): Updated mpn_sec_powm docs.

	* mpn/generic/sec_powm.c (mpn_sec_powm): Replaced exponent limb
	count argument by bit count. Don't leak high exponent bits, and
	drop the requirement that the most significant exponent limb is
	non-zero.
	(mpn_sec_powm_itch): Analogous interface change.
	* gmp-h.in: Updated prototypes.
	* mpz/powm_sec.c (mpz_powm_sec): Update mpn_sec_powm* calls.
	* tune/tuneup.c (tune_powm_sec): Likewise. Also deleted code
	fiddling with the high exponent bits.

2014-02-09  Niels Möller  <nisse@lysator.liu.se>

	* tune/tuneup.c (tune_powm_sec): Avoid timing of the nonsensical
	parameters nbits = 1, winsize = 2. Decrement tabulated values, to
	better match the > comparison when the table is used.

	* mpn/generic/sec_powm.c (win_size): Comment why we always get
	win_size(eb) <= eb. Make the table const.
	(mpn_sec_powm): Deleted handling of winsize > initial ebi. For
	now, replaced with an ASSERT_ALWAYS.

2014-02-08  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/sec_invert.c (mpn_cnd_neg_itch): #if:ed out unused
	function.

	* mpn/generic/sec_div.c: Simplified code for the normalized case.

	* tests/mpn/t-div.c (main): Test mpn_sec_div_qr and mpn_sec_div_r
	with normalized d.

2014-02-04  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Low-level Functions): Document mpn_sec_add_1 and
	mpn_sec_sub_1.

2014-01-29  Torbjorn Granlund  <tege@gmplib.org>

	* doc/gmp.texi (Floating-point Functions): Revise.

2014-01-29  Niels Möller  <nisse@lysator.liu.se>

	* README: Don't refer to specific COPYING* files, instead refer to
	manual for details.

	* COPYING.LIB: Renamed, to...
	* COPYING.LESSERv3: ... new name.
	* COPYING: Renamed, to...
	* COPYINGv3: ... new name.
	* COPYINGv2: New file, GPLv2.

	* doc/gmp.texi (Copying): Document dual licensing.

2014-01-27  Torbjorn Granlund  <tege@gmplib.org>

	* Update library files license to use LGPL3+ and GPL2+.

2014-01-27 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpn/t-aors_1.c: Check sec_aors_1 red zones (not smart).

	* mpn/generic/sec_aors_1.c: Mark the 2nd argument as const.
	* gmp-h.in (mpn_sec_add_1, mpn_sec_sub_1): Likewise.

2014-01-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fat/fat.c (fake_cpuid_table): Use proper steamroller and
	excavator values.

	* config.guess: Amend last AMD change.

	* mpn/s390_64/lshift.asm: Align loop.
	* mpn/s390_64/rshift.asm: Likewise.
	* mpn/s390_64/lshiftc.asm: Likewise.
	* mpn/s390_64: Add z10 cycle numbers.

2014-01-23 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* printf/repl-vsnprintf.c: Feed case 'z' in switch (type) with case 'z'
	in switch (fchar).

2014-01-21 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* acinclude.m4 (GMP_FUNC_VSNPRINTF): Get rid of varargs.

2014-01-20  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init): Fix duplicate entries for
	AMD "jaguar".

	* demos/expr: Get rid of varargs code and references.

2014-01-19  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Add new AMD CPUs (piledriver, steamroller, excavator,
	jaguar).
	* config.sub: Corresponding updates.
	* configure.ac: Likewise.
	* acinclude.m4 (X86_64_PATTERN): Likewise.
	* mpn/x86_64/fat/fat.c: Likewise.

	* Rename mpn_sec_minvert => mpn_sec_invert, many files affected.
	* mpn/generic/sec_invert.c: New name for sec_minvert.c.

	* doc/gmp.texi: Undocument mpz_array_init.

	* acinclude.m4 (GMP_C_STDARG): Comment out.
	* configure.ac: Suppress GMP_C_STDARG invocation.

	* Get rid of varargs code and references, many file affected.

	* Use mpq_t in favour of MP_RAT, many mpq files affected.

	* Get rid of BYTES_PER_MP_LIMB, most files affected.

	* mpz/iset.c: Avoid overflow in allocation computation.
	* mpz/mul.c: Likewise.
	* mpf/init.c: Likewise.
	* mpf/init2.c: Likewise.
	* mpf/iset.c: Likewise.
	* mpf/iset_d.c: Likewise.
	* mpf/iset_si.c: Likewise.
	* mpf/iset_str.c: Likewise.
	* mpf/iset_ui.c: Likewise.

	* mpz/array_init.c: Avoid two overflow scenarios in allocation
	computation.

	* mpn/s390_64/z10/gmp-mparam.h: New file.

	* mpz/clears.c: Call __gmp_free_func ourselves instead of via
	mpz_clears.
	* mpf/clears.c: Analogous change.
	* mpq/clears.c: Analogous change.

	* mpz/clear.c: Add cast to avoid overflow of (later ignored) argument.
	* mpf/clear.c: Likewise.

2014-01-18  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpn/t-aors_1.c: Test also mpn_sec_add_1 and mpn_sec_sub_1.

	* tests/mpn/t-minvert.c (main): Pass smallest allowed bit_size
	argument to mpn_sec_minvert.

2014-01-18  Marc Glisse  <marc.glisse@inria.fr>

	* doc/gmp.texi (C++ Interface Limitations): Warn against C++11 auto.

2014-01-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/t-parity.c: Use 1UL to generate unsigned constants.
	* tests/t-constants.c: Disable a non portable (unneeded) check.

2014-01-18  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/sec_aors_1.c (mpn_sec_add_1, mpn_sec_sub_1): New
	file.

	* mpn/generic/sec_minvert.c (mpn_sec_add_1_itch, mpn_sec_add_1):
	Deleted static definitions.
	(mpn_cnd_swap): Use volatile.

	* configure.ac (gmp_mpn_functions): sec_add_1 and sec_sub_1.
	(GMP_MULFUNC_CHOICES): Set up for sec_aors_1.

2014-01-16  Niels Möller  <nisse@lysator.liu.se>

	* tune/common.c (speed_mpn_sec_minvert): New function.
	* tune/speed.h: Declare it.
	(SPEED_ROUTINE_MPN_SEC_MINVERT): New macro.
	* tune/speed.c (routine): Added mpn_sec_minvert.

2014-01-12  Marc Glisse  <marc.glisse@inria.fr>

	* demos/expr/expr.h: Add extern "C" for C++.

2014-01-11  Torbjorn Granlund  <tege@gmplib.org>

	* doc/gmp.texi (Notes for Particular Systems): Add items about old
	NetBSD and current FreeBSD m4 problems.  Add item about FreeBSD's
	broken limits.h.

2014-01-05 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h: Declare all _itch functions using ATTRIBUTE_CONST.

2014-01-05  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac (alpha): Set extra_functions conditionally.

	* gmp-h.in (mpn_sec_minvert): Remove formal parameters.

	* doc/gmp.texi: Improve doc for several functions.

	* mpn/generic/sec_tabselect.c: Declare input arg using 'const'.
	* gmp-h.in: Analogous change.

	* gmp-h.in: Declare all itch functions using __GMP_ATTRIBUTE_PURE.
	* gmp-impl.h: Likewise.

2014-01-05 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpn/t-minvert.c: Always compare with mpz_invert results,
	add red zone to scratch.
	* tests/mpn/t-sizeinbase.c: New test.
	* tests/mpn/Makefile.am (check_PROGRAMS): Added t-sizeinbase.c .
	* tests/mpn/t-div.c: Use mpn_sec_div_*_itch().

	* mpn/generic/pow_1.c: Micro-optimisation.

2014-01-04  Torbjorn Granlund  <tege@gmplib.org>

	* acinclude.m4 (GMP_PROG_M4): Avoid hex output, since case varies.

2014-01-03  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Support newer haswell, broadwell, silvermont.
	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init): Likewise.

	* acinclude.m4 (GMP_PROG_M4): Check that eval's radix argument work.

	* mpz/invert.c: Rely on gcdext for all operands, removing faulty
	special case.
	* tests/mpz/t-invert.c: Enforce correct behaviour for |mod| = 1.

2014-01-02  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Low-level Functions): Document mpn_sizeinbase.

	Enable previously unused mpn_sizeinbase function.
	* configure.ac (gmp_mpn_functions): Added sizeinbase.
	* gmp-h.in (mpn_sizeinbase): New prototype.

2014-01-02  Marc Glisse  <marc.glisse@inria.fr>

	* gmp-impl.h: Always include <limits.h>.
	* tests/mpn/t-get_d.c: Remove comment about <limits.h>

	* gmp-h.in (__GMP_USHRT_MAX): Use the promoted type.
	* gmp-impl.h (USHRT_HIGHBIT, SHRT_MIN, SHRT_MAX): Likewise.
	* tests/t-constants.c: Adapt printf strings.
	* tests/t-gmpmax.c: Likewise.

	* tests/mpn/t-hgcd_appr.c (hgcd_appr_valid_p): Add parentheses.

2014-01-01  Torbjorn Granlund  <tege@gmplib.org>

	* doc/gmp.texi (Low-level Functions for cryptography): Update interface
	for mpn_sec_div_qr and fix typos in mpn_sec_minvert text.

	* mpn/generic/sec_div.c: Rewrite to make mpn_sec_div_qr return high
	quotient limb.
	* gmp-h.in (mpn_sec_div_qr): Update declaration.
	* tests/mpn/t-div.c: Adapt.

2013-12-31  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Low-level Functions for cryptography): Document
	mpn_sec_minvert.

2013-12-30  Marc Glisse  <marc.glisse@inria.fr>

	* doc/gmp.texi (C++ interface internals): Break long line.

2013-12-30  Torbjorn Granlund  <tege@gmplib.org>

	* doc/gmp.texi (Low-level Functions for cryptography): New section.

2013-12-29  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpn/Makefile.am (check_PROGRAMS): Added t-minvert.
	* tests/mpn/t-minvert.c: New file.

	* configure.ac (gmp_mpn_functions): Added sec_minvert.
	* gmp-h.in (mpn_sec_minvert, mpn_sec_minvert_itch): New
	declarations.
	* mpn/generic/sec_minvert.c (mpn_sec_minvert)
	(mpn_sec_minvert_itch): New functions.
	(mpn_sec_add_1, mpn_cnd_neg, mpn_cnd_swap, mpn_sec_eq_ui): New
	helper functions.

2013-12-28  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/sec_powm.c: Fix an ASSERT.

	* gmp-h.in (mpn_sec_mul, mpn_sec_mul_itch): New declarations.
	* gmp-h.in (mpn_sec_sqr, mpn_sec_sqr_itch): Likewise.
	* mpn/generic/sec_mul.c: New file.
	* mpn/generic/sec_sqr.c: New file.

	* gmp-h.in (mpn_sec_powm, mpn_sec_powm_itch): New declarations.
	* gmp-h.in (mpn_sec_div_qr, mpn_sec_div_qr_itch): Likewise.
	* gmp-h.in (mpn_sec_div_r, mpn_sec_div_r_itch): Likewise.
	* gmp-impl: Remove declarations of above functions.

	* configure.ac (gmp_mpn_functions): Add sec_mul and sec_sqr.

2013-12-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* Update many file's encoding to UTF-8.
	* doc/tasks.html: Update <meta content> accordingly.
	* doc/projects.html: Likewise.

2013-12-26  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Rename mpn_blah_sec to mpn_sec_blah.
	* gmp-impl.h: Corresponding changes.
	* mpn/asm-defs.m4: Corresponding changes.
	* tune/Makefile.am: Corresponding changes.
	* tune/common.c: Corresponding changes.
	* tune/speed.c: Corresponding changes.
	* tune/speed.h: Corresponding changes.
	* tune/tuneup.c: Corresponding changes.
	* mpz/powm_sec.c: Update calls.
	* tests/mpn/t-div.c: Likewise.

	* mpn/generic/sec_powm.c: New name for mpn/generic/powm_sec.c.
	* mpn/generic/sec_div.c: New name for mpn/generic/sb_div_sec.c.
	* mpn/generic/sec_pi1_div.c: New name for mpn/generic/sbpi1_div_sec.c.
	* mpn/generic/sec_tabselect.c: New name for mpn/generic/tabselect.c.

	* mpn/alpha/sec_tabselect.asm: New name for tabselect.asm.
	* mpn/arm/neon/sec_tabselect.asm: New name for tabselect.asm.
	* mpn/arm/sec_tabselect.asm: New name for tabselect.asm.
	* mpn/ia64/sec_tabselect.asm: New name for tabselect.asm
	* mpn/powerpc32/sec_tabselect.asm: New name for tabselect.asm
	* mpn/powerpc64/sec_tabselect.asm: New name for tabselect.asm
	* mpn/sparc64/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86/mmx/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/bd1/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/core2/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/coreinhm/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/coreisbr/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/fastsse/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/k10/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/pentium4/sec_tabselect.asm: New name for tabselect.asm
	* mpn/x86_64/sec_tabselect.asm: New name for tabselect.asm

2013-12-25  Torbjorn Granlund  <tege@gmplib.org>

	* mpz/powm_sec.c: Handle 0^e mod m specially.
	* mpn/generic/powm_sec.c: ASSERT that the base is non-zero.

2013-12-23  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/powm_sec.c (redcify): Use passed scratch instead of
	locally allocated.
	(mpn_powm_sec_itch): Accommodate mpn_sb_div_r_sec's scratch needs.

2013-12-20  Mark Sofroniou  <marks@wolfram.com>

	* mpn/generic/mul_fft.c: Major overhaul of types.

2013-12-18  Torbjorn Granlund  <tege@gmplib.org>

	* doc/gmp.texi (Low-level Functions): Rewrite mpn_set_str docs.

2013-12-14  Ulrich Weigand  <Ulrich.Weigand@de.ibm.com>

	* mpn/powerpc32/darwin.m4: Allow (and ignore) optional
	'toc' parameter to PROLOGUE_cpu.
	* mpn/powerpc32/elf.m4: Likewise.

2013-12-09  Ulrich Weigand  <Ulrich.Weigand@de.ibm.com>

	* configure.ac: Check for ELFv2 ABI on PowerPC.
	* mpn/powerpc64/elf.m4: Set assembler ABI version for ELFv2
	and use appropriate PROLOGUE_cpu/EPILOGUE_cpu sequences.
	Support optional 'toc' parameter to PROLOGUE_cpu.
	* mpn/powerpc64/aix.m4: Allow (and ignore) optional
	'toc' parameter to PROLOGUE_cpu.
	* mpn/powerpc64/darwin.m4: Likewise.

	* mpn/powerpc64/mode64/dive_1.asm (mpn_divexact_1): Add 'toc'
	parameter to PROLOGUE.
	* mpn/powerpc64/mode64/divrem_1.asm (mpn_divrem_1): Likewise.
	* mpn/powerpc64/mode64/divrem_2.asm (mpn_divrem_2): Likewise.
	* mpn/powerpc64/mode64/gcd_1.asm (mpn_gcd_1): Likewise.
	* mpn/powerpc64/mode64/invert_limb.asm (mpn_invert_limb): Likewise.
	* mpn/powerpc64/mode64/mod_1_1.asm (mpn_mod_1_1p_cps): Likewise.
	* mpn/powerpc64/mode64/mod_1_4.asm (mpn_mod_1s_4p_cps): Likewise.
	* mpn/powerpc64/mode64/mode1o.asm (mpn_modexact_1c_odd): Likewise.
	* mpn/powerpc64/mode64/p7/gcd_1.asm (mpn_gcd_1): Likewise.
	* mpn/powerpc64/p6/lshift.asm (mpn_lshift): Likewise.
	* mpn/powerpc64/p6/lshiftc.asm (mpn_lshiftc): Likewise.
	* mpn/powerpc64/p6/rshift.asm (mpn_rshift): Likewise.
	* mpn/powerpc64/vmx/popcount.asm (mpn_popcount): Likewise.

2013-12-07  Niels Möller  <nisse@lysator.liu.se>

	* configfsf.sub: Updated to version 2013-10-01, from gnulib.
	* configfsf.guess: Updated to version 2013-11-29, from gnulib.

2013-12-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/div_qr_1.c: Make constant args asm inlines become limbs.
	* mpn/generic/div_qr_1n_pi1.c: Likewise.
	* mpn/generic/div_qr_2.c: Likewise.
	* mpn/generic/div_qr_2.c: Likewise.
	* mpn/generic/mod_1_1.c: Likewise.
	* mpn/generic/mod_1_2.c: Likewise.
	* mpn/generic/mod_1_3.c: Likewise.
	* mpn/generic/mod_1_4.c: Likewise.
	* mpn/generic/mulmid_basecase.c: Likewise.
	* mpn/generic/mulmod_bnm1.c: Likewise.
	* mpn/generic/sqrmod_bnm1.c: Likewise.
	* mpn/sparc64/divrem_1.c: Likewise.
	* mpn/sparc64/mod_1_4.c: Likewise.

	* mpn/generic/toom_interpolate_7pts.c (BINVERT_15): Fix typo.

2013-11-11  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/dos64.m4 (CALL): Provide to override default.

2013-11-08  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/x86_64-defs.m4 (CALL): Swap PIC test and macro defn.

	* mpn/generic/div_qr_2.c: Test HAVE_HOST_CPU_FAMILY_x86, not i386.

	* doc/gmp.texi: Update many URLs.

2013-11-04  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Set symbol OPENBSD for x86-openbsd hosts.
	* mpn/x86_64/fat/fat_entry.asm (PRETEND_PIC): New name for
	PIC_OR_DARWIN.
	(PRETEND_PIC): Set also for OPENBSD.

2013-10-29  Torbjorn Granlund  <tege@gmplib.org>

	* printf/doprnt.c (__gmp_doprnt): Use memcpy instead of strcpy.

2013-10-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/div_qr_1u_pi2.c: New file.
	* mpn/generic/div_qr_1n_pi2.c: New file.

2013-10-24  Niels Möller  <nisse@lysator.liu.se>

	* mpn/x86_64/div_qr_1n_pi1.asm: Bugfixes, for case n == 1 and
	in-place operation.
	* mpn/x86_64/k8/div_qr_1n_pi1.asm: Likewise.

	* mpn/generic/div_qr_1n_pi1.c (mpn_div_qr_1n_pi1): Bug fixes,
	off-by-one MPN_INCR_U, and support for in-place operation.

2013-10-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86/fat/fat.c (fake_cpuid_table): Add Haswell.

2013-10-23  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/x86_64-defs.m4 (oplist): New define, data from `regnum'.
	(regnum): Use x86_lookup, feed oplist.

2013-10-22  Niels Möller  <nisse@lysator.liu.se>

	* tests/devel/try.c: Support mpn_div_qr_1n_pi1.

	* mpn/x86_64/k8/div_qr_1n_pi1.asm: Moved the below k10 file here.
	Applied tweak from Torbjörn to get it to run well on k8.

	* mpn/x86_64/k10/div_qr_1n_pi1.asm: New file (renamed above).
	Differs from generic x86_64 version by using cmov.

	* mpn/x86_64/div_qr_1n_pi1.asm: Reordered arguments to second mul.
	Deleted misleading cycle annotations.

2013-10-21  Niels Möller  <nisse@lysator.liu.se>

	* configure.ac: Add HAVE_NATIVE_mpn_div_qr_1n_pi1 to config.in.

	* mpn/generic/div_qr_1n_pi1.c (mpn_div_qr_1n_pi1): Fix typos
	affecting ASSERT.

2013-10-20  Niels Möller  <nisse@lysator.liu.se>

	* mpn/x86_64/div_qr_1n_pi1.asm: New file.

	* tune/div_qr_1_tune.c (__gmpn_div_qr_1n_pi1): Check
	div_qr_1n_pi1_method only when !HAVE_NATIVE_mpn_div_qr_1n_pi1.

	* mpn/asm-defs.m4 (define_mpn): Add div_qr_1n_pi1.

	* tune/common.c (speed_mpn_div_qr_1): New function, replacing...
	(speed_mpn_div_qr_1n, speed_mpn_div_qr_1u): ... deleted functions
	(speed_mpn_div_qr_1n_pi1, speed_mpn_div_qr_1n_pi1_1)
	(speed_mpn_div_qr_1n_pi1_2): New functions.
	* gmp-impl.h [TUNE_PROGRAM_BUILD]: Declare div_qr_1-related tuning
	variables.
	* tune/tuneup.c (speed_mpn_div_qr_1_tune, tune_div_qr_1): New
	functions.
	(div_qr_1n_pi1_method, div_qr_1_norm_threshold)
	(div_qr_1_unnorm_threshold): New globals.
	* tune/speed.c (routine): Replaced mpn_div_qr_1n and mpn_div_qr_1u
	by mpn_div_qr_1, requiring ".r" parameter. Added mpn_div_qr_1n_pi1
	and variants.
	* tune/speed.h (SPEED_ROUTINE_MPN_DIV_QR_1): Use the "r" parameter
	as divisor.
	* tune/div_qr_1n_pi1_2.c: New file.
	* tune/div_qr_1n_pi1_1.c: New file.
	* tune/div_qr_1_tune.c: New file.
	* tune/Makefile.am (libspeed_la_SOURCES): Added div_qr_1n_pi1_1.c,
	div_qr_1n_pi1_2.c, and div_qr_1_tune.c.

	* tune/speed.c (routine): Added mpn_div_qr_1n and mpn_div_qr_1u.
	* tune/speed.h (SPEED_ROUTINE_MPN_DIV_QR_1): New macro.
	(speed_mpn_div_qr_1n, speed_mpn_div_qr_1u): Declare.
	* tune/common.c (speed_mpn_div_qr_1n, speed_mpn_div_qr_1u): New
	functions.

	* gmp-impl.h (mpn_div_qr_1n_pi1): Declare function.
	* gmp-h.in (mpn_div_qr_1): Declare function.
	* configure.ac (gmp_mpn_functions): Added div_qr_1 and
	div_qr_1n_pi1.
	* mpn/generic/div_qr_1.c (mpn_div_qr_1): New file and function.
	* mpn/generic/div_qr_1n_pi1.c (mpn_div_qr_1n_pi1): New file and
	function.
	* tests/mpn/t-div.c (main): Test mpn_div_qr_1.

2013-10-17  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac (alpha): Pass -mieee via gcc_cflags_maybe.

2013-10-16  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Let AMD64 cpuid bit override pessimistic cpu guesses.

	* mpn/alpha/unicos.m4 (DATASTART): Accept optional align parameter.
	* mpn/alpha/divrem_2.asm: Use provided gp mechanisms.
	* mpn/alpha/default.m4 (PROLOGUE): Provide "..ng" post-gp label.
	* mpn/alpha/invert_limb.asm: Align table to 8-byte boundary.  Make code
	work if table is not fully aligned.  Properly test for BWX.

2013-10-15  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/alpha/default.m4 (DATASTART): Use RODATA instead of DATA;
	accept optional align parameter.
	* mpn/alpha/invert_limb.asm: Align table.
	* mpn/alpha/ev5/diveby3.asm: Likewise.

2013-10-11  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86/k7/mod_1_1.asm: Use 'subl' form to avoid ambiguity.
	* mpn/x86/k7/mod_1_4.asm: Likewise.

	* configure.ac (X86_64_PATTERN): Append "cc" to cclist_64 and
	cclist_x32.

2013-10-08  Torbjorn Granlund  <tege@gmplib.org>
	    Marc Glisse  <marc.glisse@inria.fr>

	* tests/mpf/reuse.c (main): Compare addresses instead of names.
	Use larger numbers for exponents.

2013-10-08  Marc Glisse  <marc.glisse@inria.fr>

	* doc/mdate-sh, doc/texinfo.tex, install-sh, missing, ylwrap: Remove.
	* .bootstrap: Use autoreconf (and in particular automake -a).

	* gmp-h.in: Remove __need_size_t. Include <stddef.h>, not <cstddef>.

	* tests/mpf/reuse.c (main): Use small numbers as exponents.

2013-10-05  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/atom/aorsmul_1.asm: Slight tweak.

	* doc/gmp.texi (ABI and ISA): Document x32.

	* mpn/sparc64/ultrasparct3/dive_1.asm: Use our register names.

2013-09-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/atom/redc_1.asm: New file.

2013-09-23  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bobcat/redc_1.asm: Make the code for 1 <= n <= 3 work.

2013-09-22  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/redc_1.asm: Slightly tweak basecase code.

	* mpn/x86_64/core2/redc_1.asm: New file.

	* mpn/x86_64/bobcat/redc_1.asm: New file.

2013-09-21  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreinhm/redc_1.asm: New file.

2013-09-21  Marc Glisse  <marc.glisse@inria.fr>

	* tests/mpn/t-mulmid.c: Cast arguments of printf to int to match %d.
	* tests/rand/t-urbui.c: Use 1UL for unsigned constant.
	* mpn/generic/get_str.c: Avoid temporarily pointing outside an array.

2013-09-20  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/redc_1.asm: New file.

	* mpn/x86_64/k8/redc_1.asm: Complete rewrite.

	* mpn/x86_64/coreisbr/mullo_basecase.asm: Postpone pushes, short-
	circuit a branch.
	* mpn/x86_64/coreihwl/mullo_basecase.asm: Short-circuit a branch.

	* mpn/x86_64/core2/mullo_basecase.asm: New file.

2013-09-19  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/copyi-palignr.asm: Allocate more stack under DOS.

2013-09-18  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/core2/mul_basecase.asm: New file.
	* mpn/x86_64/core2/sqr_basecase.asm: New file.

	* mpn/x86_64/coreihwl/mullo_basecase.asm: New file.
	* mpn/x86_64/coreisbr/mullo_basecase.asm: New file.

2013-09-16  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/copyi-palignr.asm: Preserve xmm6-xmm8 under DOS.

2013-09-15  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/tabselect.asm: Use R8 for bit testing.

	* mpn/x86_64/coreihwl/mul_basecase.asm: Replace mul_1 code.

	* mpn/x86_64/coreisbr/aorsmul_1.asm: Rewrite.

2013-09-12  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/ia64/gcd_1.asm: Use dep for combining table base and low bits.

	* mpn/x86_64/fastsse/com-palignr.asm: Implement temp fix to properly
	handle overlap.

2013-09-10  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/copyi-palignr.asm: Rewrite rp != up (mod 16) code
	to make it handle any allowed overlap.

2013-09-09  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/atom/com.asm: New file, grabbing fastsse code.

	* mpn/x86_64/bd1/copyi.asm: New file, grabbing fastsse code.
	* mpn/x86_64/bd1/copyd.asm: Likewise.
	* mpn/x86_64/bd1/com.asm: Likewise.

	* mpn/x86_64/fastavx/copyi.asm: New file.
	* mpn/x86_64/fastavx/copyd.asm: New file.

2013-09-05  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreihwl/aorsmul_1.asm: Streamline.

2013-09-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreihwl/sqr_basecase.asm: Implement larger "corner".
	Misc tuning.

2013-09-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreihwl/redc_1.asm: New file.

	* mpn/x86_64/x86_64-defs.m4 (mulx): Handle negative offsets.

2013-08-31  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/sqr_basecase.asm: New file.

	* mpn/x86_64/sqr_diag_addlsh1.asm: New file.

2013-08-30  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fat/mul_basecase.c: New file.
	* mpn/x86_64/fat/sqr_basecase.c: New file.
	* mpn/x86_64/fat/mullo_basecase.c: New file.
	* mpn/x86_64/fat/redc_1.c: New file.

2013-08-29  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/k8/mul_basecase.asm: Move top-level basecase file to k8
	subdir.
	* mpn/x86_64/k8/sqr_basecase.asm: Likewise.
	* mpn/x86_64/k8/redc_1.asm: Likewise.
	* mpn/x86_64/k8/mullo_basecase.asm: Likewise.
	* mpn/x86_64/k8/mulmid_basecase.asm: Likewise.

	* mpn/ia64/aors_n.asm: Clean up some bundlings.

	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init): Support Haswell.
	(fake_cpuid_table): Likewise.

	* configure.ac (x86): Remove any mulx paths.  Let bwl path = hwl path.
	(fat_path): Add coreihwl.

	* mpn/x86_64/coreihwl/aorsmul_1.asm: Move from `mulx' directory, use
	mulx() macro.
	* mpn/x86_64/coreihwl/mul_1.asm: Likewise.
	* mpn/x86_64/coreihwl/mul_2.asm: Likewise.
	* mpn/x86_64/coreihwl/mul_basecase.asm: Likewise.
	* mpn/x86_64/coreihwl/sqr_basecase.asm: Likewise.

	* mpn/x86_64/x86_64-defs.m4 (mulx): New macro.
	(regnum, regnumh, ix): Supporting macros.

2013-08-28  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/divrem_1.asm: New file.

2013-08-23  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/com-palignr.asm: New file, closely based on
	copyi-palignr.asm.

	* mpn/x86_64/fastsse/copyi.asm Use "test R8(reg)" instead of "bt".
	* mpn/x86_64/fastsse/copyd-palignr.asm: Likewise.
	* mpn/x86_64/fastsse/copyi-palignr.asm: Likewise.
	* mpn/x86_64/fastsse/lshift-movdqu2.asm: Likewise.
	* mpn/x86_64/fastsse/lshiftc-movdqu2.asm: Likewise.
	* mpn/x86_64/fastsse/rshift-movdqu2.asm: Likewise.
	* mpn/x86_64/fastsse/tabselect.asm: Likewise.

	* mpn/sparc64/ultrasparct3/sqr_diag_addlsh1.asm: New file.

	* mpn/alpha/aorslsh2_n.asm: New file.
	* mpn/alpha/aorslsh1_n.asm: Rewrite.
	* mpn/alpha/ev6/aorslsh1_n.asm: New file.

2013-08-21  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/alpha/sqr_diag_addlsh1.asm: New file.
	* mpn/alpha/sqr_diagonal.asm: Remove.
	* mpn/alpha/ev6/sqr_diagonal.asm: Remove.

2013-08-20  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc32/sqr_diag_addlsh1.asm: New file.
	* mpn/powerpc32/sqr_diagonal.asm: Remove.

2013-08-15  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreihwl/mulx/sqr_basecase.asm: New file.

2013-08-05  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/aors_n.asm: Complete rewrite.

2013-08-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreihwl/mulx/mul_basecase.asm: New file.

	* mpn/x86_64/bd1/mul_2.asm: New file.

	* mpn/x86_64/coreihwl/gmp-mparam.h: New file.

2013-08-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreihwl/mulx/mul_2.asm: New file.
	* mpn/x86_64/coreihwl/mulx/addmul_2.asm: New file.

	* mpn/x86_64/coreinhm/aorsmul_1.asm: New file.

	* mpn/x86_64/coreisbr/mul_basecase.asm: Save some O(n) and O(1) cycles.

	* mpn/x86_64/coreisbr/mul_2.asm: New file.

2013-08-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/addmul_2.asm: Complete rewrite.

2013-08-01  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bd1/mul_basecase.asm: New file.

	* mpn/x86_64/coreisbr/mul_basecase.asm: New file.

	* mpn/x86_64/coreihwl/aorsmul_1.asm: New file.

2013-07-31  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/atom/mul_2.asm: New file.
	* mpn/x86_64/atom/addmul_2.asm: New file.
	* mpn/x86_64/atom/mul_1.asm: New file.
	* mpn/x86_64/atom/aorsmul_1.asm: New file.

	* mpn/x86_64/coreihwl/mul_1.asm: New file.

	* configure.ac (x86): Add Haswell-specific path.

	* configure.in (fat_functions): Add cnd_add_n, cnd_sub_n..
	* gmp-impl.h (struct cpuvec_t): Add fields for new fat functions.
	* gmp-impl.h: Adjust corresponding declarations.

	* mpn/x86_64/x86_64-defs.m4 (CPUVEC_FUNCS_LIST): Add new fat functions.
	* mpn/x86/x86-defs.m4 (CPUVEC_FUNCS_LIST): Likewise.
	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec): Likewise.
	* mpn/x86/fat/fat.c (__gmpn_cpuvec): Likewise.

2013-07-30  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/popcount.asm: New file.

2013-07-23  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bobcat/aors_n.asm: New file.

	* mpn/x86_64/pentium4/aorslshC_n.asm: Remove a spurious emms insn.

	* mpn/x86_64/bd1/aorrlsh1_n.asm: New file.
	* mpn/x86_64/bd1/sublsh1_n.asm: New file.

2013-07-22  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/mode64/mod_1_1.asm: Handle little-endian mode.
	* mpn/powerpc64/mode64/mod_1_4.asm: Likewise.

2013-07-16  Torbjorn Granlund  <tege@gmplib.org>

	* doc/gmp.texi: Declare countless of function arguments as 'const'.

2013-07-15  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/core2/aors_n.asm: Rewrite.

	* mpn/generic/sb_div_sec.c: Compute inverse as floor(B^2/(dh+1)), per
	Niels' suggestion.
	* mpn/generic/sbpi1_div_sec.c: Remove inverse rounding-up code.

2013-07-14  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/mode64/divrem_1.asm: Remove explicit nop after CALL.
	* mpn/powerpc64/mode64/divrem_2.asm: Likewise.
	* mpn/powerpc64/mode64/mod_1_1.asm: Likewise.
	* mpn/powerpc64/mode64/mod_1_4.asm: Likewise.

2013-07-13  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86/atom/cnd_add_n.asm: New file.
	* mpn/x86/atom/cnd_sub_n.asm: New file.o

2013-07-12  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/sbpi1_div_sec.c: Partial rewrite.

2013-07-11  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/cnd_aors_n.asm: Tweak for better speed on K8, bobcat, bd1,
	NHM, Atom.

2013-07-05  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/p7/copyi.asm: Handle n = 0.
	* mpn/powerpc64/p7/copyd.asm: Likewise.

2013-07-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/mode64/p7/aormul_2.asm: New file.

	* mpn/powerpc64/darwin.m4 (EXTRA_REGISTER): New define.
	* mpn/powerpc64/aix.m4: New define (actually undefine).
	* mpn/powerpc64/elf.m4: Likewise.

2013-07-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/com.asm: Rewrite.

	* mpn/powerpc64/p7/copyi.asm: New file.
	* mpn/powerpc64/p7/copyd.asm: New file.

2013-07-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/mode64/gcd_1.asm: New file.
	* mpn/powerpc64/mode64/p7/gcd_1.asm: New file.

2013-07-01  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Comment out AC_PROG_F77.

	* mpn/powerpc64/mode64/rsh1add_n.asm: Remove.
	* mpn/powerpc64/mode64/rsh1sub_n.asm: Remove.
	* mpn/powerpc64/mode64/rsh1aors_n.asm: New file, code not based on
	removed files.

2013-06-28  Marc Glisse  <marc.glisse@inria.fr>

	* cxx/ismpf.cc: Use GMP_DECIMAL_POINT.
	* cxx/osmpf.cc: Likewise.
	* tests/cxx/t-locale.cc: Likewise.

2013-06-28  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/mode64/p7/aorsorrlshC_n.asm: New file.
	* mpn/powerpc64/mode64/p7/aorsorrlsh1_n.asm: New file.
	* mpn/powerpc64/mode64/p7/aorsorrlsh2_n.asm: New file.

	* mpn/powerpc64/mode64/aorsorrlshC_n.asm: Use alias regname.

2013-06-27  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/mode64/p7/aors_n.asm: New file.

2013-06-22  Torbjorn Granlund  <tege@gmplib.org>

	* aorslshC_n.asm, aorslsh2_n.asm, aorslsh1_n.asm: Remove.
	* aorsorrlshC_n.asm, aorsorrlsh1_n.asm, aorsorrlsh2_n.asm: New files.

2013-06-19  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/p6/lshift.asm: Rewrite switching-into-loop code.
	* mpn/powerpc64/p6/rshift.asm: Likewise.
	* mpn/powerpc64/p6/lshiftc.asm: Likewise.

2013-06-17  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/p6/lshift.asm: Fix typo in label reference.
	For 32-bit mode, zero extend `n' argument and split retval.
	* mpn/powerpc64/p6/rshift.asm: Likewise.
	* mpn/powerpc64/p6/lshiftc.asm: Likewise.

2013-06-10  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/mu_div_q.c: Remove obsolete comment.

2013-06-09  Marc Glisse  <marc.glisse@inria.fr>

	* mpn/generic/get_d.c (mpn_get_d): Avoid signed overflow.
	* mpz/kronzs.c (mpz_kronecker_si): Use ABS_CAST.

2013-05-31  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/mu_div_q.c: Call mpn_mu_divappr_q for entire division,
	never just for tail.  (This fixes performance issues at the expense of
	memory needs.)

2013-05-26  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac (*sparc*-*-*): Major overhaul.

2013-05-22  Torbjorn Granlund  <tege@gmplib.org>

	* doc/gmp.texi (Reporting Bugs): Ask for configure's output.

	* mpn/ia64/divrem_2.asm: Don't clobber f16-f18.

2013-05-20  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/udiv.asm: Change spacing to work around binutils bug.

2013-05-16  Torbjorn Granlund  <tege@gmplib.org>

	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*): Bump version info.

	* tests/misc.c (tests_hardware_getround, tests_hardware_setround):
	Avoid assembly dependency unless WANT_ASSEMBLY.

	* configure.ac (WANT_ASSEMBLY): Conditionally define.

2013-05-14  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac (arm1156): Don't fall back to plain v6 compiler option.

2013-05-11  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/mul_1.asm: Handle n = 1 for DOS64.  Streamline.
	* mpn/x86_64/coreisbr/aorsmul_1.asm: Streamline.

2013-05-10  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/aorsmul_1.asm: Fix, then enable DOS64 support.
	* mpn/x86_64/coreisbr/mul_1.asm: Enable DOS64 support.

	* mpn/x86/p6/mmx/gmp-mparam.h: Set down SQR_TOOM2_THRESHOLD to parent
	directory value.

2013-05-09  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac (--enable-fake-cpuid): New option.
	* mpn/x86_64/fat/fat.c (WANT_FAKE_CPUID): Remove defaulting.
	* mpn/x86/fat/fat.c (WANT_FAKE_CPUID): Likewise.

	* mpn/x86_64/bd1/mul_1.asm: Fix typo.

2013-05-07  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fat/fat.c (fake_cpuid): Handle 0x80000001 request.
	(fake_cpuid_available): Remove unused function.

	* mpn/generic/mod_1_1.c: Cast constant udiv_rnnd_preinv arguments.
	* mpn/generic/mod_1_2.c: Likewise.
	* mpn/generic/mod_1_3.c: Likewise.
	* mpn/generic/mod_1_4.c: Likewise.
	* mpn/generic/divrem_2.c: Likewise.

2013-05-06  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess (power*): Handle all ppc970 variants.

2013-05-03  David S. Miller  <davem@davemloft.net>

	* tune/common.c (speed_mpn_addlsh1_n, speed_mpn_sublsh1_n,
	speed_mpn_rsblsh1_n, speed_mpn_addlsh2_n, speed_mpn_sublsh2_n,
	speed_mpn_rsblsh2_n): Don't define if these routines are macros.
	* tune/speed.c (routine): Likewise don't table if they are macros.

	* mpn/sparc64/ultrasparct3/addmul_1.asm: Add T4 and T3 timings.
	* mpn/sparc64/ultrasparct3/aormul_4.asm: Likewise.
	* mpn/sparc64/ultrasparct3/aorslsh_n.asm: Likewise.
	* mpn/sparc64/ultrasparct3/cnd_aors_n.asm: Likewise.
	* mpn/sparc64/ultrasparct3/submul_1.asm: Likewise.

2013-05-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/aorslsh_n.asm: Invoke INITCY where it has
	effect.

	* gmp-impl.h: Amend last change.
	* tests/devel/try.c (choice_array): Don't try to table addlsh1_n etc if
	a macro.

2013-05-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/copyd.asm: Suppress dead pointer update.
	* mpn/arm/copyi.asm: Likewise.
	* mpn/arm/neon/logops_n.asm: Likewise.
	* mpn/arm/neon/tabselect.asm: Likewise.
	* mpn/arm/rshift.asm: Likewise.
	* mpn/arm/tabselect.asm: Likewise.
	* mpn/arm/v6/dive_1.asm: Likewise
	* mpn/arm/v7a/cora15/neon/copyi.asm: Likewise.

	* mpn/arm/v7a/cora15/neon/com.asm: New file.

2013-05-01  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/aormul_4.asm: New file.

	* configure.ac (GMP_MULFUNC_CHOICES): Support mul_3 + addmul_3 and
	mul_4 + addmul_4.

	* mpn/sparc64/ultrasparct3/aormul_2.asm: Optimise lead-in code.

	* mpn/sparc64/ultrasparct3/missing.m4 (addxccc): Allow g2 as input.
	(umulxhi): Save and restore o7 to allow it as in/out parameter.

2013-04-29  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v7a/cora15/cnd_aors_n.asm: New file, was mis-named.

	* mpn/sparc64/ultrasparct3/addmul_1.asm: Rewrite.

	* mpn/sparc64/ultrasparct3/submul_1.asm: Rewrite.

	* mpn/sparc64/ultrasparct3/cnd_aors_n.asm: New file.

	* gmp-impl.h: Override mpn_addlsh1_n, mpn_addlsh2_n, mpn_sublsh1_n, etc
	with mpn_addlsh_n, etc when !HAVE_NATIVE the former but HAVE_NATIVE the
	latter.

	* mpn/sparc64/ultrasparct3/aorslsh_n.asm: New file.

	* configure.ac (sparc-*-*): Recognise t5 along with t3 and t4.
	Remove sparc64/ultrasparct1 from path_64 for T3, T3, and T5.

2013-04-27  Mike Frysinger  <vapier@gentoo.org>

	* configure.ac (arm*-*-*): Set up path also for plainest CPU variants.

2013-04-27  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v6/popham.asm: New file.

	* mpn/arm/v7a/cora15/cnd-aors_n.asm: New file.

2013-04-25  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/mod_34lsub1.asm: Clear carry smarter.

	* mpn/arm/v7a/cora15/logops_n.asm: Conditionally suppress conditionally
	used code.

	* mpn/arm/v7a/cora15/submul_1.asm: New file.

2013-04-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v7a/cora15/com.asm: New file.

	* mpn/arm/v7a/cora15/logops_n.asm: New file.

2013-04-19  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v7a/cora15/aors_n.asm: New file.

	* mpn/arm/v7a/cora15/addmul_1.asm: Rewrite.

2013-04-18  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/alpha/tabselect.asm: New file.

2013-04-17  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc32/tabselect.asm: New file.

	* longlong.h (arm64 count_trailing_zeros): New.

	* mpn/arm64/invert_limb.asm: New file.

	* mpn/generic/dive_1.c: Rewrite to use Hensel division also for
	size = 1.

	* mpn/generic/mod_1_1.c (add_mssaaaa): Provide VIS3 variant.

	* configure.ac: Remove "missing" from extra_functions_64 for coreibwl.

	* mpn/sparc64/ultrasparct3/mul_1.asm: Decrease loop alignment.
	* mpn/sparc64/ultrasparct3/aormul_2.asm: Likewise.

2013-04-16  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/alpha/invert_limb.asm: Generate table.
	* mpn/powerpc64/mode64/invert_limb.asm: Likewise.
	* mpn/s390_64/invert_limb.asm: Likewise.
	* mpn/sparc64/ultrasparct3/invert_limb.asm: Likewise.
	* mpn/x86_64/invert_limb_table.asm: Likewise.

2013-04-15  David S. Miller  <davem@davemloft.net>

	* mpn/sparc32/sparc-defs.m4 (LEA64): New macro.
	* mpn/sparc64/gcd_1.asm: Use it.
	* mpn/sparc64/ultrasparct3/dive_1.asm: Likewise.
	* mpn/sparc64/ultrasparct3/invert_limb.asm: Likewise.
	* mpn/sparc64/ultrasparct3/mode1o.asm: Likewise.

	* mpn/sparc64/gcd_1.asm: Use RODATA, TYPE, and SIZE.

2013-04-15  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/invert_limb.asm: Avoid addend for GOT entry,
	it is not portable.

	* mpn/sparc64/tabselect.asm: New file.

	* mpn/x86/mmx/tabselect.asm: New file.
	* configure.ac (x86): Add x86/mmx to path for relevant CPUs.

	* mpn/sparc64/gcd_1.asm: Use rdpc for PIC.
	* mpn/sparc64/ultrasparct3/mode1o.asm: Use rdpc for PIC.
	* mpn/sparc64/ultrasparct3/dive_1.asm: Use rdpc for PIC.
	* mpn/sparc64/ultrasparct3/invert_limb.asm: Handle PIC, use rdpc.

	* Revert remaining parts of recent sparc LEA changes.

2013-04-14  David S. Miller  <davem@davemloft.net>

	* mpn/sparc32/v9/sqr_diagonal.asm: Revert LEA and INT32 changes.
	* mpn/sparc64/gcd_1.asm: Likewise.

2013-04-13  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bd1/tabselect.asm: New file.
	* mpn/x86_64/coreisbr/tabselect.asm: New file.
	* mpn/x86_64/k10/tabselect.asm: New file.
	* mpn/x86_64/coreinhm/tabselect.asm: New file.
	* mpn/x86_64/core2/tabselect.asm: New file.
	* mpn/x86_64/pentium4/tabselect.asm: New file.

	* mpn/x86_64/fastsse/tabselect.asm: New file.
	* mpn/arm/neon/tabselect.asm: Rewrite.
	* mpn/arm/tabselect.asm: Rewrite.
	* mpn/powerpc64/tabselect.asm: Rewrite.
	* mpn/x86_64/tabselect.asm: Rewrite.

	* tune/speed.h (SPEED_ROUTINE_MPN_TABSELECT): Implement special code,
	making .r argument be table width.

2013-04-11  David S. Miller  <davem@davemloft.net>

	* mpn/sparc32/sparc-defs.m4 (LEA): Remove unused local label.
	(LEA_LEAF): Likewise.

2013-04-11  Niels Möller  <nisse@lysator.liu.se>

	* mpn/arm/v6/submul_1.asm: New file, using the corresponding
	addmul_1 loop + complement trick.

2013-04-10  David S. Miller  <davem@davemloft.net>

	* acinclude.m4 (GMP_ASM_SPARC_GOTDATA,
	GMP_ASM_SPARC_SHARED_THUNKS): New feature tests.
	* configure.ac: Call GMP_ASM_SPARC_GOTDATA and
	GMP_ASM_SPARC_SHARED_THUNKS on sparc.
	* mpn/sparc32/sparc-defs.m4 (LEA, LEA_LEAF, LEA_THUNK): New macros.
	* mpn/sparc32/udiv.asm: Convert over to LEA, LEA_LEAF, and LEA_THUNK.
	* mpn/sparc32/v8/addmul_1.asm: Likewise.
	* mpn/sparc32/v8/mul_1.asm: Likewise.
	* mpn/sparc32/v8/supersparc/udiv.asm: Likewise.
	* mpn/sparc32/v8/udiv.asm: Likewise.
	* mpn/sparc64/gcd_1.asm: Likewise.
	* mpn/sparc64/ultrasparct3/dive_1.asm: Likewise.
	* mpn/sparc64/ultrasparct3/invert_limb.asm: Likewise.
	* mpn/sparc64/ultrasparct3/mode1o.asm: Likewise.
	* mpn/sparc32/v9/sqr_diagonal.asm: Likewise and use INT32.

2013-04-09  Torbjorn Granlund  <tege@gmplib.org>

	* longlong.h (sparc64): Test __VIS__ instead of __sparc_vis3.

	* config.guess (sparc*): Invoke set_cc_for_build to get $dummy.

2013-04-08  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Rework tmp file names, make sure to remove tmp files.

	* mpn/arm/dive_1.asm: Rewrite count-trailing-zeros code, using private
	table.

	* mpn/arm: Canonicalise arm assembly to use old style "mov ... lsl" for
	shift ops.

2013-04-07  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/mod_34lsub1.asm: New file.

	* longlong.h (sparc64): Define umul_ppmm, add_ssaaaa, and
	count_leading_zeros conditionally under the symbol __sparc_vis3.

	* mpn/arm/dive_1.asm: New file.
	* mpn/arm/v6/dive_1.asm: New file.

	* mpn/arm/v6t2/mode1o.asm: Make trivial change to avoid v6t2...
	* mpn/arm/v6/mode1o.asm: ...instruction, move file accordingly.

	* mpn/powerpc64/mode64/invert_limb.asm: Put all multiplies low-limb first.

2013-04-04  David S. Miller  <davem@davemloft.net>

	* mpn/sparc64/ultrasparct3/add_n.asm: Rewrite.
	* mpn/sparc64/ultrasparct3/sub_n.asm: Rewrite.

	* mpn/sparc64/ultrasparct3/invert_limb.asm: Align table.

2013-04-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc32/sparc-defs.m4: Provide dummy lzcnt.

	* tests/mpn/logic.c: Seed using RANDS, then use mpz_rrandomb.

	* tests/mpn/t-div.c (random_word): Remove.  Let callers invoke urandom.

	* mpn/sparc64/ultrasparct3/mul_1.asm: Rewrite.

	* mpn/sparc64/ultrasparct3/bdiv_dbm1c.asm: New file.
	* mpn/sparc64/ultrasparct3/dive_1.asm: New file.
	* mpn/sparc64/ultrasparct3/invert_limb.asm: New file.
	* mpn/sparc64/ultrasparct3/mod_1_4.asm: New file.
	* mpn/sparc64/ultrasparct3/mode1o.asm: New file.

2013-04-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/aormul_2.asm: Reschedule for better speed.

2013-04-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/missing.m4: Misc tweaks.
	 (lzcnt): New.
	* mpn/sparc64/ultrasparct3/missing.asm (__gmpn_lzcnt): New function.

	* mpn/sparc32/sparc-defs.m4: Put FAKE_T3 stuff here...
	* mpn/sparc64/ultrasparct3/aormul_2.asm: ...moved from here.

	* mpn/sparc64/ultrasparc1234/lshift.asm: Remove.
	* mpn/sparc64/ultrasparc1234/rshift.asm: Remove.

2013-04-01  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/missing.m4 (umulxhi): Don't clobber retaddr,
	allowing use in functions that does not do save/restore.

	* mpn/sparc64/gcd_1.asm: Tweak for tighter loop.

2013-03-31  David S. Miller  <davem@davemloft.net>

	* mpn/sparc64/lshift.asm: New file.
	* mpn/sparc64/rshift.asm: New file.
	* mpn/sparc64/lshiftc.asm: New file.

2013-03-31  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct1/lshift.asm: Remove.
	* mpn/sparc64/ultrasparct1/rshift.asm: Remove.
	* mpn/sparc64/ultrasparct1/lshiftc.asm: Remove.

2013-03-29  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparct3/aormul_2.asm: Always do mulx before umulxhi.

2013-03-28  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/mod_1_4.c (mpn_mod_1s_4p): Make precomputed arg 'const'.
	(mpn_mod_1s_4p_cps): Update from generic code.

2013-03-27  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/trialdiv.c: Make variables 'const' to match tables.

	* mpn/generic/mod_1_1.c (mpn_mod_1_1p): Make precomputed arg 'const'.
	* mpn/generic/mod_1_2.c (mpn_mod_1s_2p): Likewise.
	* mpn/generic/mod_1_3.c (mpn_mod_1s_3p): Likewise.
	* mpn/generic/mod_1_4.c (mpn_mod_1s_4p): Likewise.
	* gmp-impl.h: Update prototypes.

	* mpn/x86_64/mulx/aorsmul_1.asm: New file.
	* mpn/x86_64/mulx/addmul_1.asm: Remove.

2013-03-26  Niels Möller  <nisse@lysator.liu.se>

	Make mpn_cnd_add_n and mpn_cnd_sub_n public.
	* doc/gmp.texi (Low-level Functions): Document mpn_cnd_add_n and
	mpn_cnd_sub_n.
	* gmp-h.in (mpn_cnd_add_n, mpn_cnd_sub_n): Moved prototypes
	here...
	* gmp-impl.h: ... from here.

2013-03-26  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86/pentium4/sse2/cnd_add_n.asm: New file.
	* mpn/x86/pentium4/sse2/cnd_sub_n.asm: New file.
	* mpn/x86/cnd_aors_n.asm: New file.

2013-03-25  David S. Miller  <davem@davemloft.net>

	* mpn/sparc64/ultrasparct3/hamdist.asm: New file.
	* mpn/sparc64/ultrasparct3/popcount.asm: New file.

2013-03-25  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/ia64/aorsorrlshC_n.asm: Generalised from aorslshC_n.asm.
	* mpn/ia64/aorsorrlsh1_n.asm: Generalised from aorslsh1_n.asm.
	* mpn/ia64/aorsorrlsh2_n.asm: Generalised from aorslsh2_n.asm.

2013-03-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v7a/cora15/neon/aorsorrlshC_n.asm: New file.
	* mpn/arm/v7a/cora15/neon/aorsorrlsh2_n.asm: New file.
	* mpn/arm/v7a/cora15/neon/aorsorrlsh1_n.asm: New file.
	* mpn/arm/v7a/cora15/neon/rsh1aors_n.asm: New file.

	* configure.ac (GMP_MULFUNC_CHOICES): Support add+sub+rsb lsh files.

	* tests/refmpn.c (refmpn_addlsh_nc, refmpn_sublsh_nc): Remove silly
	assert of mp_limb being non-negative.

2013-03-21  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/neon/lshiftc.asm: New file.

	* mpn/arm/v6/sqr_basecase.asm: Trim 'sqr_diag_addlsh1' loop.

	* gen-trialdivtab.c: Output just raw data, remove actual variables.
	* mpn/generic/trialdiv.c: Put variables from gen-trialdivtab.c here,
	and make them 'const'.

2013-03-20  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Rework arm CPU recognition.
	* config.sub: Corresponding updates.
	* configure.ac: Likewise.

	* mpn/x86_64/mulx/adx/addmul_1.asm: Let FAKE_MULXADX be off by default.

	* mpn/arm/v7a/cora15/neon/copyi.asm: Move from "..".
	* mpn/arm/v7a/cora15/neon/copyd.asm: Likewise.

	* config.guess: Tack on "neon" for appropriate arm CPUs.
	* configure.ac (arm*-*-*): Recognise neon suffix for a8, a9, and a15.

2013-03-19 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/fits_u.h: Accept numbers truncating to zero before checking the
	sign.
	* tests/mpf/t-fits.c: Check new edges.

2013-03-19  Torbjorn Granlund  <tege@gmplib.org>

	* tests/arm32check.c: Get printing of clobbered register right.

	* mpn/arm/neon/popcount.asm: New file.
	* mpn/arm/neon/hamdist.asm: New file.

	* tests/Makefile.am (EXTRA_libtests_la_SOURCES): Add arm32call.asm and
	arm32check.c.

2013-03-18  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac (arm*-*-*): Define CALLING_CONVENTIONS_OBJS.

	* tests/arm32call.asm: New file.
	* tests/arm32check.c: New file.

	* mpn/arm/arm-defs.m4 (LEA): Rewrite to properly handle repeated use.
	(EPILOGUE_cpu): Define.

	* mpn/arm/v6/addmul_3.asm: Make code work for PIC.

	* tests/x86call.asm: Modernise asm syntax.
	* tests/amd64call.asm: Likewise.

	* mpn/x86/darwin.m4 (m4append): Move definition from here...
	* mpn/asm-defs.m4: ...to here.

2013-03-18 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* doc/gmp.texi (--enable-fat): No quote in concept index.

	* mpf/swap.c: Reduce the number of variables.

2012-03-17  Marc Glisse  <marc.glisse@inria.fr>

	* tests/cxx/t-do-exceptions-work-at-all-with-this-compiler.cc: New file.
	* tests/cxx/Makefile.am: Add new file. Reorder the tests.

2013-03-17  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/mul_fft.c: Use TMP_BALLOC*, but combine several areas.

	* mpz/powm_ui.c (mod): Use TMP_BALLOC in mu code.

	* mpn/arm/v6/addmul_3.asm: New file.

	* mpn/arm/v7a/cora15/copyd.asm: Tweak.

	* mpn/arm64/copyi.asm: New file.
	* mpn/arm64/copyd.asm: New file.

2013-03-16  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v6/addmul_2.asm: Tweak for better A9 performance.

2013-03-14  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/ia64/cnd_aors_n.asm: New file.

	* mpn/arm64/cnd_aors_n.asm: New file.

	* mpn/arm64/aors_n.asm (ADDSUB): Remove unused definition.

	* mpn/ia64/aors_n.asm: Remove a redundant ASM_START.

	* mpn/arm/cnd_aors_n.asm: Avoid ARM conditional insn execution.

	* mpn/x86_64/missing.asm: Move from mulx/adx since we cannot currently
	prune missing.asm from path.
	* mpn/x86_64/mulx/adx/missing-call.m4: Likewise.
	* mpn/x86_64/mulx/adx/missing-inline.m4: Likewise.
	* mpn/x86_64/mulx/adx/addmul_1.asm: Update hardwired path.

2013-03-13 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/cong_2exp.c: Write loops in a cleaner way.
	* gmp-impl.h (mpz_zero_p): Likewise.

2013-03-12  Niels Möller  <nisse@lysator.liu.se>

	New names mpn_cnd_add_n and mpn_cnd_sub_n.
	* mpn/generic/cnd_add_n.c (mpn_cnd_add_n): Renamed file and
	function, from addcnd.c:mpn_addcnd_n.
	* mpn/generic/cnd_sub_n.c (mpn_cnd_sub_n): Renamed, from
	subcnd.c:mpn_subcnd_n.
	* mpn/arm/cnd_aors_n.asm: Renamed file, from aorscnd.asm, and
	renamed functions.
	* mpn/x86_64/cnd_aors_n.asm: Analogous renaming.
	* mpn/powerpc64/mode64/cnd_aors_n.asm: Analogous renaming.
	* gmp-impl.h (mpn_cnd_add_n, mpn_cnd_add_n): Updated prototypes
	with new names.
	* configure.ac: Updated for new names.
	* tests/refmpn.c (refmpn_cnd_add_n): Renamed, from refmpn_addcnd_n.
	(refmpn_cnd_sub_n): Renamed, from refmpn_subcnd_n.
	* tests/tests.h (refmpn_cnd_add_n, refmpn_cnd_sub_n): Updated
	prototypes with new names.
	* tune/common.c (speed_mpn_cnd_add_n): Renamed, from
	speed_mpn_addcnd_n, call mpn_cnd_add_n.
	(speed_mpn_cnd_sub_n): Renamed, from speed_mpn_subcnd_n, call
	mpn_cnd_sub_n.
	* tune/speed.h (speed_mpn_cnd_add_n, speed_mpn_cnd_sub_n): Updated
	prototypes with new names.
	* tune/speed.c (routine): Updated list with new names.
	* tests/devel/try.c: Updated for new mpn_cnd_* names.
	* mpn/generic/sbpi1_div_sec.c: Likewise.
	* mpn/generic/powm_sec.c: Likewise.

2013-03-12  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Add "missing" to extra_functions_64 for coreibwl.

	* mpn/x86_64/mulx/adx/addmul_1.asm: Simplify.  Make FAKE_MULXADX the
	default awaiting proper qemu behaviour.

2013-03-11  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/aorscnd_n.asm: Read 32 bits for 'n' arguments on DOS64.

	* tests/mpz/t-powm_ui.c: Test larger arguments.  General cleanup.

	* mpz/powm_ui.c (mod): Adhere to mpn_mu_div_qr's overlap requirements.

2013-03-10  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/sbpi1_div_sec.c: Update calls of mpn_addcnd_n and
	mpn_subcnd_n.
	* mpn/generic/powm_sec.c (MPN_REDC_1_SEC, MPN_REDC_2_SEC)
	(mpn_powm_sec): Update calls of mpn_subcnd_n.

	* tests/tests.h (refmpn_addcnd_n, refmpn_subcnd_n): Update
	declarations.
	* tests/refmpn.c (refmpn_addcnd_n, refmpn_subcnd_n): Similar
	reorder of arguments.
	* tests/devel/try.c (call): Pass condition first, for
	TYPE_ADDCND_N and TYPE_SUBCND_N.

	* tune/common.c (speed_mpn_addcnd_n, speed_mpn_subcnd_n): Update
	to pass condition as first argument.

	* gmp-impl.h (mpn_addcnd_n, mpn_subcnd_n): Updated declarations.

	* mpn/generic/addcnd_n.c (mpn_addcnd_n): Reordered arguments, make
	condition the first argument.
	* mpn/generic/subcnd_n.c (mpn_subcnd_n): Likewise.
	* mpn/arm/aorscnd_n.asm: Likewise.
	* mpn/x86_64/aorscnd_n.asm: Likewise.
	* mpn/powerpc64/mode64/aorscnd_n.asm: Likewise.

2013-03-10  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/mulx/adx/missing.asm: Simulate some mulx/adx insns.
	* mpn/x86_64/mulx/adx/missing-call.m4: Call variant.
	* mpn/x86_64/mulx/adx/missing-inline.m4: Inline variant.

	* mpn/sparc64/ultrasparct3/missing.asm: Simulate some v9-2011 insns.
	* mpn/sparc64/ultrasparct3/missing.m4: Inline or invoke missing.asm for
	v9-2011 insn.

	* configure.ac: Strip `haswell' from paths for now.

	* mpn/x86_64/mulx/addmul_1.asm: New.
	* mpn/x86_64/mulx/mul_1.asm: Rewrite file from `haswell' subdir.
	* mpn/x86_64/mulx/adx/addmul_1.asm: Likewise.
	* mpn/x86_64/haswell: Remove.

	* mpn/arm/v7a/cora15/mul_1.asm: New file.
	* mpn/arm/v7a/cora15/addmul_1.asm: New file.

2013-03-09 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/t-cong_2exp.c: Improve coverage.

2013-03-09  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/ultrasparc1234/add_n.asm: Use g5 instead of g4.
	* mpn/sparc64/ultrasparc1234/sub_n.asm: Likewise.

	* mpn/sparc64/ultrasparct3/aormul_2.asm: Fix a typo.

2013-03-07  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v7a/cora9/gmp-mparam.h: New file.

	* configure.ac (GMP_MULFUNC_CHOICES): Support mul_2 + addmul_2.

	* mpn/sparc64/ultrasparct3/aormul_2.asm: New file.

	* mpn/sparc64/ultrasparct3/submul_1.asm: Optimise out two carry
	propagating adds.

2013-03-06  David Miller  <davem@davemloft.net>

	* config.guess: Recognize UltraSparc T4 under Linux.
	* configure.ac: Add sparc64/ultrasparct3 to path_64 when T3 or T4.
	Append -xarch=v8plusd or -xarch=v9d to command line, as needed.
	* mpn/sparc64/ultrasparct3/mul_1.asm: New file.
	* mpn/sparc64/ultrasparct3/addmul_1.asm: New file.
	* mpn/sparc64/ultrasparct3/submul_1.asm: New file.
	* mpn/sparc64/ultrasparct3/add_n.asm: New file.
	* mpn/sparc64/ultrasparct3/sub_n.asm: New file.

	* mpn/sparc32/ultrasparct1/mul_1.asm: Unroll main loop one time, add
	T2/T3/T4 timings.
	* mpn/sparc32/ultrasparct1/addmul_1.asm: Likewise.
	* mpn/sparc32/ultrasparct1/submul_1.asm: Likewise.

2013-03-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/neon/lorrshift.asm: New file.

2013-03-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v7a/cora15/copyd.asm: New file.
	* mpn/arm/v7a/cora15/copyi.asm: New file.

	* mpn/arm64/logops_n.asm: New file.
	* mpn/arm64/gcd_1.asm: New file.
	* mpn/arm64/aorsmul_1.asm: New file.
	* mpn/arm64/addmul_1.asm: Remove.
	* mpn/arm64/aors_n.asm: Complete rewrite.

	* mpn/arm/tabselect.asm: New file.
	* mpn/arm/neon/tabselect.asm: New file.

	* mpn/arm/copyi.asm: Software pipeline.
	* mpn/arm/copyd.asm: Likewise.

	* config.guess: Rework tmp file handling to resemble configfsf.guess's.

2013-03-03  Niels Möller  <nisse@lysator.liu.se>

	* doc/gmp.texi (Integer Special Functions): Document
	mpz_limbs_read, mpz_limbs_write, mpz_limbs_modify,
	mpz_limbs_finish, mpz_roinit_n and MPZ_ROINIT_N.

	* mpz/roinit_n.c (mpz_roinit_n): Normalize the input.

2013-02-27  Niels Möller  <nisse@lysator.liu.se>

	* tune/common.c (speed_measure): Increase repetition count if we
	get a zero measurement.

2013-02-26  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpz/t-limbs.c (check_roinit): Test MPZ_ROINIT_N only if
	compiler supports c99.

2013-02-25  Niels Möller  <nisse@lysator.liu.se>

	* mpz/limbs_finish.c (mpz_limbs_finish): New file and function.
	* mpz/limbs_modify.c (mpz_limbs_modify): New file and function.
	* mpz/limbs_read.c (mpz_limbs_read): New file and function.
	* mpz/limbs_write.c (mpz_limbs_write): New file and function.
	* mpz/roinit_n.c (mpz_roinit_n): New file and function.
	* gmp-h.in: Declare new functions.
	(MPZ_ROINIT_N): New macro.
	* mpz/Makefile.am (libmpz_la_SOURCES): Added new files.
	* Makefile.am (MPZ_OBJECTS): Added new object files.

	* tests/mpz/t-limbs.c: New testcase.
	* tests/mpz/Makefile.am (check_PROGRAMS): Added t-limbs.

2013-02-22  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Fix typo in adx/mulx path stripping code.
	* config.sub: Match coreibwl.

2013-02-20  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpq/t-get_d.c (check_random): Rewrote to make test less
	dependent on float operations. Fixes problem with m68k-linux and
	extended float precision.

2013-02-20  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/haswell/mulx/adx/addmul_1.asm: New file.

	* configure.ac: Support coreibwl.  Use proper name for ADX extension.
	* acinclude.m4 (GMP_ASM_X86_ADX): Rename from GMP_ASM_X86_ADOX.

	* tests/tests.h (TESTS_REPS): Keep count >= 1.

2013-02-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmpxx.h (mpq_class, mpf_class) [init_ui, init_si, assign_si]:
	Optimise _si using _ui for positive arguments.
	(__gmp_hypot_function): Use _mul_ui to square an ui, abs for si.

	* mpz/remove.c: Delay allocation in the generic case; use swap
	instead of set.
	* mpn/generic/remove.c: Delay (possibly smaller) allocation.

2013-02-17  Marc Glisse  <marc.glisse@inria.fr>

	* cxx/osdoprnti.cc: Use <stdarg.h> and <string.h> rather than <cstdarg>
	and <cstring> (revert 2002-12-21).

	* tests/cxx/Makefile.am: Link with libm.
	* tests/cxx/t-ops2.cc: Comment about more tests. Use <math.h> rather
	than <cmath> and using namespace. Don't include <iostream>.

	* gmpxx.h (__GMPXX_BITS_TO_LIMBS, __GMPQ_NUM_DBL_LIMBS,
	__GMPQ_DEN_DBL_LIMBS, __GMPXX_TMPQ_D): New macros.
	(__gmp_binary_plus, __gmp_binary_minus, __gmp_binary_multiplies,
	__gmp_binary_divides, __gmp_binary_equal, __gmp_binary_less,
	__gmp_cmp_function): Use __GMPXX_TMPQ_D.
	* tests/cxx/t-ops2.cc: Test __GMPXX_TMPQ_D on DBL_MIN, DBL_MAX.

	* gmpxx.h (__gmp_binary_multiplies, __gmp_binary_divides): Use
	__GMPXX_CONSTANT_TRUE.

2013-02-16  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h: Include <algorithm>.

2013-02-16  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/Makefile.am (TARG_DIST): Add arm64.

	* mpn/x86_64/x86_64-defs.m4 (PROTECT): Emit '.hidden' instead of
	'.protected" to please Sun's assembler, but also for semantic reasons.

2013-02-15  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac (arm64*-*-*): Match this.

	* mpn/arm64/aors_n.asm: New file.
	* mpn/arm64/addmul_1.asm: New file.
	* mpn/arm64/mul_1.asm: New file.

2013-02-15  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__GMPXX_DEFINE_ARITHMETIC_CONSTRUCTORS,
	__GMPXX_DEFINE_ARITHMETIC_ASSIGNMENTS): New macros.
	(mpz_class, mpq_class, mpf_class) [init_ui, init_si, init_d,
	assign_ui, assign_si, assign_d]: New functions.
	(__gmp_expr::__gmp_expr, __gmp_expr::operator=): Replace with macros.
	(__GMPXX_CONSTANT_TRUE): New macro.

2013-02-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h (NEG_CAST, ABS_CAST): Use __GMP_CAST.
	* mpz/fits_s.h: Use NEG_CAST.

2013-02-14  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_binary_greater): Forward to __gmp_binary_less.
	(__gmp_binary_equal): Forward to itself after swapping operands.

2013-02-14 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mp_dv_tab.c (__gmp_digit_value_tab): Remove a line of unused values.
	* mpf/set_str.c: Update offset accordingly.
	* mpz/inp_str.c: Likewise.
	* mpz/set_str.c: Likewise.

	* gmp-h.in (mpq_cmp_ui): Optimise comparison with 1/1.
	* tests/mpq/t-cmp_ui.c: Test special comparisons: 0/1, 1/1.

	* mpz/clrbit.c: Reorganise branches.
	* mpz/setbit.c: Likewise.
	* mpz/combit.c: Same micro-optimisations as in set/clr.

	* mpz/aors_ui.h: No realloc if size was zero.
	* mpz/ior.c: Use macros: MPZ_REALLOC and MPN_INCR_U.

	* gmp-impl.h (NEG_CAST): New macro, used by ABS_CAST.
	* mpq/cmp_si.c: Use NEG_CAST.
	* mpz/cmp_si.c: Reorganise branches.

2013-02-13  Torbjorn Granlund  <tege@gmplib.org>

	* acinclude.m4 (GMP_ASM_X86_MULX, GMP_ASM_X86_ADOX): New feature tests.
	* configure.ac: Use new feature tests.

	* mpn/x86_64/haswell/mulx/mul_1.asm: File moved to cope with older
	assemblers.
	* configure.ac: Update haswell path to include "mulx".

2013-02-12  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Recognise haswell.
	* config.guess: Recognise haswell.
	* config.sub: Match haswell.

	* mpn/x86_64/haswell/mul_1.asm: New file, mainly for testing HNI.

2013-02-12 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h (MPZ_PROVOKE_REALLOC): Remove unused macro.
	* gen-fac.c (gen_consts): Remove obsolete code, use swap instead of set.

	* mpn/generic/mulmod_bnm1.c: Reorganise branches.

	* mpz/bin_ui.c: Avoid a copy when n < 0.
	* mpz/mfac_uiui.c: Reduce memory usage.
	* mpz/primorial_ui.c: Use MPZ_NEWALLOC.

	* mpz/import.c: Use BITS_TO_LIMBS and MPZ_NEWALLOC.
	* mpz/inp_raw.c: Likewise.
	* mpz/rrandomb.c: Likewise.
	* mpz/urandomb.c: Likewise.
	* mpn/generic/random2.c: Likewise.

	* mpn/generic/brootinv.c: Micro-optimisation.

	* mpf/set_str.c: Don't chech base==0 when base is strictly positive.

2013-02-10  Torbjorn Granlund  <tege@gmplib.org>

	* Version 5.1.1 released.

2013-02-07 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tune/speed.h (SPEED_ROUTINE_MPN_MUL): Use operands from struct s.
	* tune/README: Document new parameter syntax mpn_mul.<#> .

2013-02-06  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpz/t-jac.c (check_large_quotients): Rewrote. Now uses a
	more efficient method for generating the test inputs.

2013-02-05  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpn/t-div.c: Limit random dbits to avoid an infinite loop.

2013-02-03  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpz/reuse.c: Fix typo causing the same negation condition to be
	applied to all operands.  Fix condition for when to invoke mpz_remove.
	Make different-size random operands.

2013-02-02 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/remove.c: Correct the sign in case of reuse.

2013-02-01  Torbjorn Granlund  <tege@gmplib.org>

	* gmp-impl.h (DIGITS_IN_BASE_PER_LIMB): Add a cast.
	(LIMBS_PER_DIGIT_IN_BASE): Likewise.

	* tests/refmpn.c (refmpn_mul): Use toom6h instead of toom44 for the
	largest operands.

2013-01-31  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/toom44_mul.c: Revert last change in favour of a simple
	change (thanks Marco!).
	* mpn/generic/toom4_sqr.c: Likewise.

2013-01-30  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/toom44_mul.c (MAYBE_mul_toom44): Take toom6h and toom8h
	into account, using new macro MUL_NEXTALG_THRESHOLD.
	* mpn/generic/toom4_sqr.c (MAYBE_sqr_toom4): Likewise.

2013-01-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/remove.c: init+set=init_set, cast before shifting.

	* mpz/cmp_si.c: Use ABS_CAST.

2013-01-26  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpn/logic.c: Set things up to always test library logops, not
	gmp-impl.h's inlined variants.  Test also mpn_com.

	* tests/mpn/t-mod_1.c: Test also mpn_mod_1s_3p.

	* mpn/generic/mod_1_3.c: Swap some lines to make it similar to mod_4.c.

	* tests/mpz/reuse.c: Fix typo in last change.

2013-01-22  Torbjorn Granlund  <tege@gmplib.org>

	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*): Bump version info.
	* gmp-h.in: Bump version.

	* tests/mpz/reuse.c: Delete always zero 'failures' and code depending
	on it.  Replace rotating progress with real measure.

	* Makefile.am (check-mini-gmp): Fix typo in last change.

2013-01-20  Torbjorn Granlund  <tege@gmplib.org>

	* Makefile.am (check-mini-gmp): Set also DYLD_LIBRARY_PATH for the
	benefit of Darwin.

	* tests/mpn/t-div.c: Test mpn_sb_div_qr_sec and mpn_sb_div_r_sec.
	(main): Separate divisor into normalised (dnp) and unnormalised (dup),
	pass appropriate variant to each function.
	(main): Make negative `test' index value mean divisor bits, for better
	small operands coverage.
	(main): Put random junk at qp[] instead of zeroing.

	* tests/mpz/t-remove.c: Back out last change which left `divisor_size'
	uninitialised; achieve change's aim with a parameter tweak.

2013-01-20  Torbjorn Granlund  <tege@gmplib.org>

	* tests/memory.c (PTRLIMB): New macro, used for conformant casting.

2013-01-19 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/t-set_str.c: Check also failing conditions.

	* tests/mpz/t-remove.c: Test removal of 1.

2013-01-18  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/set_str.c (normalization_steps): Eliminate set-but-unused
	variable.

	* tests/tests.h (TESTS_REPS): Fix printf argument type clashes.

2013-01-15  Torbjorn Granlund  <tege@gmplib.org>

	From Mike Frysinger:
	* configure.ac: Add x32 ABI for x86_64.

2013-01-14 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* doc/gmp.texi (gmp_version): Remove "was used" repetition.
	(Upward compatibility): Mention mpn_bdivmod, GMP 4 -> GMP 5.

2013-01-13  Marc Glisse  <marc.glisse@inria.fr>

	* doc/gmp.texi: Let mpn_sqrtrem reference mpn_perfect_square_p instead
	of mpz_perfect_square_p.

2013-01-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/export.c: Less restrictive ASSERTs.

2013-01-10  Torbjorn Granlund  <tege@gmplib.org>

	* Makefile.am (check-mini-gmp): Set LD_LIBRARY_PATH to allow testing
	with dynamic main GMP build.

2013-01-05  Torbjorn Granlund  <tege@gmplib.org>

	* longlong.h (aarch64): Make add_ssaaaa and sub_ddmmss actually work.

2013-01-04  Torbjorn Granlund  <tege@gmplib.org>

	From Marko Lindqvist:
	* configure.ac: Use AC_CONFIG_HEADERS instead of the obsolete
	AM_CONFIG_HEADER.

2013-01-02 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/bit.c: Wider testing for mpz_combit.
	* tests/mpz/logic.c: Check the -2^n case.

	* mpz/ior.c: Fixed an allocation bug in the -2^n case.

2012-12-31  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/get_d.c: Minor reorg, add vax D code.

	* gmp-impl.h (double_extract): New union type for vax D floats.

	* tests/mpq/t-get_d.c (check_random): Limit exponents on vax.

2012-12-30 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/bit.c (check_clr_extend): Check _set shrink.

2012-12-29  Torbjorn Granlund  <tege@gmplib.org>

	* demos/calc/calc.c: Remove generated file from repo.
	* demos/calc/calc.h: Likewise.
	* demos/calc/calclex.c: Likewise.

2012-12-27  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/get_d.c: Complete rewrite of non-IEEE code.

	* tests/mpq/t-get_d.c (main): Suppress check_random for vax.

2012-12-25  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bdiv_q_1.asm: Use LEA for binvert_limb_table.

2012-12-23  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpz/t-get_d.c (check_onebit): Decrease vax limit to avoid
	overflow in last, unused 'want' value.

	* config.guess: Recognise AMD family 22 as a future bobcat.

2012-12-21  Torbjorn Granlund  <tege@gmplib.org>

	* configure.ac: Rename configure.in.

2012-12-17  Torbjorn Granlund  <tege@gmplib.org>

	* Version 5.1.0 released.

	* configure.in (none-*-*): Allow this again, but print a warning.

2012-12-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/n_pow_ui.c: Fix typos in an ASSERT.

2012-12-16  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/mu_div_qr.c (mpn_preinv_mu_div_qr): Explicitly use
	MPN_COPY_INCR for slightly overlapping copy.

2012-12-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpn/toom-sqr-shared.h: Skip ALLOCs if the test is skipped.

2012-12-13  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/dos64.m4 (PIC): Move definition early.
	(JMPENT): Remove PIC variant.

	* mpn/x86_64/darwin.m4 (JUMPTABSECT): Define to .text, instead of
	something sensible.

2012-12-12  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/x86_64-defs.m4 (JMPENT): New macro.
	* mpn/x86_64/dos64.m4: Likewise.
	* mpn/x86_64/darwin.m4: Likewise.
	* mpn/x86_64/mod_34lsub1.asm: Use JMPENT to properly support PIC.
	* mpn/x86_64/mullo_basecase.asm: Likewise.
	* mpn/x86_64/sqr_basecase.asm: Likewise.

2012-12-11  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/mod_34lsub1.asm: Try different jump table for the benefit
	of broken Apple linkers.

2012-12-09  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in: Make GMP_NONSTD_ABI ABI specific.

2012-12-08  Torbjorn Granlund  <tege@gmplib.org>

	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*): Bump version info.
	* gmp-h.in: Bump version.

2012-12-06 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpq/reuse.c: New test (adapted from mpf/reuse.c).
	* tests/mpq/Makefile.am (check_PROGRAMS): Add reuse.

	* mpz/abs.c: Use NEWALLOC.
	* mpz/neg.c: Likewise.
	* mpz/com.c: Reduce branches.

2012-12-05  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/brootinv.c (mpn_brootinv): Make valgrind happier, at
	the cost of a redundant MPN_ZERO.

	* mpz/jacobi.c (mpz_jacobi): Check for asize == 0 or bsize == 0
	before using the low limbs.

2012-12-05  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/set_str.c (mpn_dc_set_str): Work around a valgrind issue.

	* mpz/powm_ui.c: Don't assume >= 2 limbs in mod argument.

	* tests/tests.h (TESTS_REPS): Handle float GMP_CHECK_REPFACTOR.

	* longlong.h: Refine cpp test for vax.
	* tests/mpn/t-get_d.c: Likewise.
	* tests/mpz/t-get_d.c: Likewise.
	* tests/mpz/t-cmp_d.c: Likewise.
	* tests/mpz/t-get_d.c: Likewise.
	* tests/mpq/t-get_d.c: Likewise.
	* tests/mpf/t-get_d.c: Likewise.

2012-11-30  Torbjorn Granlund  <tege@gmplib.org>

	* gen-fac.c (gen_consts): Correct printf types.

	* mpn/arm/v7a/cora15/gmp-mparam.h: New file.

	* configure.in (arm*-*-*): New compiler optional "tune".  Pass value for
	selected processors.  Add more specific path components.

2012-11-29  Torbjorn Granlund  <tege@gmplib.org>

	From Andoni Morales Alastruey:
	* longlong.h: Conditionalise ARM asm on !__thumb__.

2012-11-28  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess (arm*-*-*): Support specific ARM processors.
	* config.sub: Match arm CPUs.
	* configure.in (arm*-*-*): Likewise.

	* mpz/powm.c: Move new_b out since it lives on through b.

	* configure.in (arm*-*-*): Pass -marm to deal with compilers defaulting
	to thumb code.

2012-11-26  Torbjorn Granlund  <tege@gmplib.org>

	* tests/cxx/t-ops2.cc (checkz): Reduce huge numbers to avoid vax
	overflow.

2012-11-25  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/get_d.c: Reinsert non-IEEE code.

	* mpn/vax/add_n.asm: New file.
	* mpn/vax/add_n.s: Remove.
	* mpn/vax/addmul_1.asm: New file.
	* mpn/vax/addmul_1.s: Remove.
	* mpn/vax/lshift.asm: New file.
	* mpn/vax/lshift.s: Remove.
	* mpn/vax/mul_1.asm: New file.
	* mpn/vax/mul_1.s: Remove.
	* mpn/vax/rshift.asm: New file.
	* mpn/vax/rshift.s: Remove.
	* mpn/vax/sub_n.asm: New file.
	* mpn/vax/sub_n.s: Remove.
	* mpn/vax/submul_1.asm: New file.
	* mpn/vax/submul_1.s: Remove.

	* mpn/vax/elf.m4: New file.
	* configure.in (vax*-*-*elf*): New case, grabbing vax/elf.m4.

	* tests/mpn/t-get_d.c (check_onebit): Get vax bounds right.
	(main): Switch off check_rand for vax.

2012-11-16  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/powm_sec.c (redcify): Use mpn_sb_div_r_sec.

	* mpn/generic/sb_div_sec.c: New file.
	* mpn/generic/sbpi1_div_sec.c: New file.
	* configure.in (gmp_mpn_functions): Add new files.
	* gmp-impl.h: Declare new functions.

2012-11-12  Torbjorn Granlund  <tege@gmplib.org>

	* longlong.h: Add ARM64 support.
	* longlong.h: Add AVR support.

	* mpn/powerpc64/mode64/divrem_1.asm: Tune, simplify.

	* mpq/md_2exp.c: Use MPN_COPY_INCR, not MPN_COPY_DECR.
	* tests/mpq/t-md_2exp.c (check_random): New function.

2012-11-10  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/remove.c (mpn_bdiv_qr_wrap): Make static.

2012-11-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpz/powm_ui.c: Rewrite.

2012-11-01  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/brootinv.c (mpn_brootinv): Input size in limbs
	rather than bits. Use single-precision iterations for the first
	limb.
	* mpn/generic/perfpow.c (is_kth_power): Update mpn_brootinv call.
	* tests/mpn/t-brootinv.c (main): Likewise.
	* tune/speed.h (SPEED_ROUTINE_MPN_BROOTINV): Likewise.
	* gmp-impl.h (mpn_brootinv): Updated prototype.

	* mpn/generic/hgcd2.c (mpn_hgcd2): Removed redundant loop exit
	tests in the single-precision loop.

	* mpz/combit.c (mpz_combit): Rewrite, optimizing for the common
	case.

2012-10-31  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpn/Makefile.am (check_PROGRAMS): Added t-brootinv.
	* tests/mpn/t-brootinv.c: New file

	* mpn/generic/broot.c (mpn_broot_invm1): Avoid a mullo_n in the
	loop, and do powering as a plain mpn_sqr followed by mpn_powlo.

	* tune/speed.c (routine): Added mpn_broot, mpn_broot_invm1,
	mpn_brootinv.

	* tune/common.c (speed_mpn_broot, speed_mpn_broot_invm1)
	(speed_mpn_brootinv): New functions.
	* tune/speed.h (SPEED_ROUTINE_MPN_BROOT)
	(SPEED_ROUTINE_MPN_BROOTINV): New macros.

	* mpn/generic/broot.c (mpn_broot_invm1): Made non-static (mainly
	for benchmarking).
	* gmp-impl.h (mpn_broot_invm1): Declare it.

2012-10-28  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in (gmp_mpn_functions): Add new files.
	* gmp-impl.h: Declare new functions.
	* mpn/generic/perfpow.c: Overhaul.
	(binv_root, binv_sqroot): Remove.
	* mpn/generic/brootinv.c: New file, code from overhauled binv_root.
	* mpn/generic/bsqrtinv.c: New file, code from overhauled binv_sqroot.
	* mpn/generic/bsqrt.c: New file.

	* tests/mpn/t-broot.c: Add a forgotten TMP_MARK.

2012-10-28  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/broot.c (mpn_broot): New file and function.
	* configure.in (gmp_mpn_functions): Add broot.
	* gmp-impl.h (mpn_broot): Declare.
	* tests/mpn/t-broot.c: New testcase.
	* tests/mpn/Makefile.am (check_PROGRAMS): Added t-broot.

2012-10-27  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/remove.c: Get remainder allocation right.

2012-10-25  Torbjorn Granlund  <tege@gmplib.org>

	* longlong.h: De-support old POWER asm syntax.

	* tests/mpz/t-remove.c: Run more tests, but use a tad smaller operands.

	* mpn/generic/remove.c (mpn_bdiv_qr_wrap): New function.
	(mpn_remove): Call mpn_bdiv_qr_wrap.
	* mpz/remove.c: Enable suppressed mpn_remove call.

2012-10-17  Torbjorn Granlund  <tege@gmplib.org>

	* mpz/powm_ui.c (mpz_powm_ui): Deflect to mpz_powm for large exponent.

2012-09-10  Torbjorn Granlund  <tege@gmplib.org>

	* demos/factorize.c: Rewrite no more current form.  Implement Lucas
	prime proving, and make its use the default.
	* demos/primes.h: New file.

2012-08-24  Torbjorn Granlund  <tege@gmplib.org>

	* demos/factorize.c: Overhaul.

2012-08-06 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* doc/gmp.texi (mpn_neg): Correctly document returned type.

	* gmp-impl.h (_mpz_newalloc, log_n_max): mark with inline (spotted by Niels).

2012-07-28  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (std::common_type): New partial specializations with builtin
	types.
	* tests/cxx/t-cxx11.cc: Test it.

2012-07-21  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc32/vmx/mod_34lsub1.asm: Fix r0 clobbering issue with
	"large" code affecting elf+darwin PIC.

2012-07-21  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__GMPXX_CONSTANT): Disable for g++-3.4.

2012-06-26  Torbjorn Granlund  <tege@gmplib.org>

	* Makefile.am (LIBMP_LT_*): Remove these.

2012-06-26  Marc Glisse  <marc.glisse@inria.fr>

	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*): Update comment for 5.1.0.

2012-06-24 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* configure.in (CALLING_CONVENTIONS_OBJS): Disable any use of
	assembly code with the --disable-assembly option.
	* mpz/oddfac_1.c: Use the ASSERT_CODE macro.
	* gen-trialdivtab.c (mpz_log2): Use mpz_sizeinbase (., 2).

	* gmp-impl.h (MPN_SIZEINBASE_16): Replace with MPN_SIZEINBASE_2EXP
	from mpz/export.c .
	* mpz/export.c (MPN_SIZEINBASE_2EXP): Removed.
	* mpn/generic/sizeinbase.c: Use MPN_SIZEINBASE.

	* mpz/nextprime.c: Use MPN_SIZEINBASE_2EXP to count bits.
	* mpn/generic/perfpow.c: Likewise.
	* mpn/generic/rootrem.c: Likewise.
	* mpz/get_d_2exp.c: Likewise.
	* mpn/generic/powm_sec.c: Likewise, nailify.
	* mpn/generic/powlo.c: Likewise.
	* mpn/generic/powm.c: Likewise.

2012-06-23  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (numeric_limits): Make content public.
	* cxx/limits.cc: New file, proper declarations.
	* Makefile.am: List new file.
	* cxx/Makefile.am: Likewise.
	* cxx/t-misc.cc: Add minimal test for numeric_limits.

2012-06-09  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (__gmp_resolve_expr::srcptr_type): New typedef.
	(__gmp_temp): Wrapper for mp*_class, the constructor copies the
	precision of its second argument for mpf_t.
	(__gmp_expr::eval(p, prec)): Remove.
	(__gmp_expr::eval(p)): Use __gmp_temp.
	(__gmp_set_expr): Never pass prec to eval().

2012-06-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h (__GMP_WITHIN_CONFIGURE): Use the same #if as in gmp-h.in.
	(MPN_NORMALIZE_NOT_ZERO): Tighter ASSERT.
	(MPZ_NEWALLOC): New macro.
	* mpq: Use the new macro when possible.
	* mpz/bin_uiui.c: Likewise.
	* mpz/oddfac_1.c: Likewise.
	* mpz/prodlimbs.c: Likewise.

2012-06-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/aix.m4 (ASM_START): Claim machine type "any".

2012-06-03  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcdext.c (mpn_gcdext): Deleted code for handling
	impossible case u1 == 0, Simplified test for unlikely case u0 == 0.

2012-06-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/lshiftc.asm: New file.

2012-06-01  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/aorslsh1_n.asm: Use cmp/cmn instead of subs/adds in more
	places.

	* mpz/get_str.c: Don't strip leading zeros since current mpn_get_str
	won't generate any.  Misc streamlining.
	* mpz/out_str.c: Analogous changes.

	* tests/mpz/io.c: Use a wider range of bases.

	* tests/mpz/t-cong.c (check_random): Rewrite random generation for
	exponentially distributed operand sizes.

2012-06-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpq: Use more macros and MPZ_REALLOC return value when possible.

	* gmp-impl.h (LIMBS): Removed, was an alias for PTR.
	* mpz/combit.c: Use PTR and CNST_LIMB.

	* tests/mpn/t-bdiv.c: Test also mpn_bdiv_qr.
	* mpn/generic/bdiv_qr.c: Add an ASSERT.

	* mpn/generic/remove.c: Add a zero limb to use bdiv_qr...

2012-05-31  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (mpq_class::mpq_class): Handle mpq_class(0,1).
	* tests/cxx/t-constr.cc: Test it.

2012-05-30  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64 (FUNC_ENTRY): New name for DOS64_ENTRY.
	* mpn/x86_64 (FUNC_EXIT): New name for DOS64_EXIT.

2012-05-29 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/remove.c: Optimise branches.

	* mpn/generic/toom6h_mul.c: less branches in the LIKELY balanced path.
	* mpn/generic/toom8h_mul.c: Likewise.

2012-05-29  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v5/mod_1_1.asm: New file.

2012-05-28  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcdext.c (compute_v): Simplified carry handling a
	bit, reduced stated scratch need from 2n+1 to 2n. Also comment and
	ASSERT improvements.

2012-05-27  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Add new x86 CPUs.
	* mpn/x86/fat/fat.c: Likewise.
	* mpn/x86_64/fat/fat.c: Likewise.

2012-05-27 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/x86_64/fat/fat.c: abort iff longmode-capable-bit is turned off.

	* mpn/generic/toom8h_mul.c: mark UNLIKELY branches.

2012-05-26  Torbjorn Granlund  <tege@gmplib.org>

	* mpz: Use MPZ_REALLOC return value when possible.

2012-05-25 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/scan1.c: Simplify, and add a shortcut for scan1(z, 0).

2012-05-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpz/n_pow_ui.c: Cast non-limb count_leading_zeros argument.

2012-05-24 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/remove.c: Support negative divisor.
	* tests/mpz/t-remove.c: Test negative divisor.

2012-05-23  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpz/reuse.c: Major rewrite.

2012-05-23 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/sqrt.c: Further simplify.
	* mpz/sqrtrem.c: Likewise.

	* Mark failing branches with UNLIKELY. Many files affected.

2012-05-22  Torbjorn Granlund  <tege@gmplib.org>

	* mpz/sqrt.c: Allocate less for overlapping operands, simplify.
	* mpz/sqrtrem.c: Likewise.

2012-05-21 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/toom8_sqr.c: Reduce branches for recursion.
	* mpn/generic/toom8h_mul.c: Likewise.

	* tests/mpn/t-toom8h.c: Don't use GMP_NUMB_BITS when not yet defined.

2012-05-20  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpz/t-gcd.c: Rewrite.

2012-05-19  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpz/t-gcd.c: Generate larger operands for better gcd code
	coverage; distribute size exponentially.

2012-05-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpf/pow_ui.c: Simplify.
	* tests/mpf/reuse.c (dsi_func): Exercise pow_ui.

	* tests/mpf/t-set_ui.c (check_data): LONG_HIGHBIT -> ULONG_HIGHBIT.
	* tests/mpf/t-set.c (check_random): New check, both set and init_set.

	* tests/cxx/t-ops.cc (check_mpq): Check squaring.
	* tests/mpq/t-equal.c (check_various): Check different den-size.

	* mpn/generic/mullo_n.c: Disable MAYBE_ if WANT_FAT_BINARY.
	* mpz/cmpabs_d.c: Remove an unused branch.

	* tests/mpz/t-get_d_2exp.c (check_zero): New check.
	* tests/mpz/t-inp_str.c: A few more cases.
	* tests/mpz/t-cmp_d.c: More bases and symbols, a few cases.

	* mpz/rootrem.c: Correctly handle odd roots of negatives.
	* tests/mpz/t-root.c: Test it.

2012-05-16  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpf/t-eq.c (check_random): New function, meat from old main().
	(check_data): New function.

2012-05-13  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/rsh1aors_n.asm: New file.
	* mpn/arm/v5/mod_1_2.asm: New file.

2012-05-11  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (explicit operator bool): New functions.
	* tests/cxx/t-cxx11.cc: Test the above.

2012-05-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gmp-impl.h (__gmpn_cpuvec_initialized): Was __gmpn_cpuvec.initialized
	* mpn/x86/fat/fat.c: Use separated _initialized variable.
	* mpn/x86_64/fat/fat.c: Likewise.
	* tests/mpn/t-fat.c: Likewise.

	* mpn/generic/toom2_sqr.c: Override global __gmpn_cpuvec_initialized.
	* mpn/generic/toom22_mul.c: Likewise.
	* mpn/generic/toom3_sqr.c: Likewise.
	* mpn/generic/toom33_mul.c: Likewise.

2012-05-09 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/sqrtrem.c (invsqrttab): Reduce size removing common byte.

	* mpz/bin_uiui.c (mul3, mul4, mul8): Remove unneeded shifts.
	(MAXFACS): Redefine, using the shared (safer) log_n_max.

2012-05-08  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/minithres/gmp-mparam.h (REDC_1_TO_REDC_N_THRESHOLD): Up to 9, for
	coherency with ASSERT in mpn/generic/redc_n.c.

2012-05-07 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/minithres/gmp-mparam.h: Updated TOOM6 and FAC_DSC.
	* tests/mpn/toom-sqr-shared.h: Don't test if no range.

	* mpz/oddfac_1.c: Add ASSERTs to warn about small threshold.
	* tune/tuneup.c: Update minimal threshold for FAC_DSC.

2012-05-06  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v6/sqr_basecase.asm: Simplify n=4 code.

2012-05-05 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/invert.c: Mark a branch UNLIKELY.
	* tune/tuneup.c (tune_fac_u): Update DSC_THRESHOLD minimum.
	* gmp-impl.h (FAC_???_THRESHOLD): Update default values.
	(ABOVE_THRESHOLD): New definition with __builtin_constant_p.

	* mpn/generic/toom22_mul.c: Disable MAYBE_ if WANT_FAT_BINARY.
	* mpn/generic/toom33_mul.c: Likewise.
	* mpn/generic/toom2_sqr.c: Likewise.
	* mpn/generic/toom3_sqr.c: Likewise.

2012-05-04  Torbjorn Granlund  <tege@gmplib.org>

	* tune/tuneup.c: Measure POWM_SEC_TABLE after the REDC thresholds.

2012-05-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/powm_sec.c: Use redc_2.
	(INNERLOOP): Use this mechanism, like plain powm.c.
	(WANT_CACHE_SECURITY): Remove, feature now unconditional.

2012-05-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpz/bin_uiui.c: Make use of CNST_LIMB.

2012-05-02 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/mfac_uiui.c: Support limb != ui.

2012-05-02  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/logops_n.asm: Work around register clobbering issue.

	* mpn/arm/aorscnd_n.asm: New file.

2012-05-01  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in: Put arm dirs in path in proper prio order.

	* mpn/arm/logops_n.asm: New file.

	* mpz/2fac_ui.c: Fix assumed typo.

	* mpn/arm/v6/gmp-mparam.h: New file.

	* mpn/arm/v5/gcd_1.asm: Hack for undefined BMOD_1_TO_MOD_1_THRESHOLD.
	* mpn/arm/v6t2/gcd_1.asm: Likewise.

2012-04-30  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v6/sqr_basecase.asm: New file.

2012-04-30 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/generic/comb_tables.c: New file.
	* configure.in: Add it.
	* gen-fac.c: Define table limits.
	* gmp-impl.h: Declare tables.
	(log_n_max): New static function.
	* mpz/2fac_ui.c: Use shared tables.
	* mpz/bin_uiui.c: Likewise.
	* mpz/oddfac_1.c: Likewise.
	* mpz/primorial_ui.c: Likewise.

	* mpz/mfac_uiui.c: New file.
	* Makefile.am: Compile it.
	* mpz/Makefile.am (libmpz_la_SOURCES): Add mpz_mfac_uiui.c
	* gmp-h.in (mpz_mfac_uiui): Declare.

	* tests/mpz/t-mfac_uiui.c: New file.
	* tests/mpz/Makefile.am: Run it.

	* doc/gmp.texi: Document mpz_mfac_uiui, collapsing with other factorial functions.

	* tests/mpz/t-lcm.c: Test zero too.

	* mpz/prodlimbs.c: Simplify threshold (should be tuned, not guessed).

2012-04-29  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/aors_n.asm: Tune for more stable performance.

	* mpn/arm/aorslsh1_n.asm: New file.

	* mpn/arm/mod_34lsub1.asm: New file.

	* mpn/arm/v6t2/divrem_1.asm: New file.

2012-04-28  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/thumb/add_n.asm: New file.
	* mpn/thumb/sub_n.asm: New file.
	* mpn/thumb/add_n.s: Remove broken code.
	* mpn/thumb/sub_n.s: Likewise.

	* mpn/arm/v6/addmul_1.asm: Rewrite for stable speed, smaller size.
	* mpn/arm/v6/mul_1.asm: Likewise.

2012-04-27  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in: Search arm/v6t2 for arm7.

	* mpn/arm/v5/gcd_1.asm: New file.
	* mpn/arm/v6t2/gcd_1.asm: New file.

	* mpn/arm/mode1o.asm: New file.
	* mpn/arm/v6t2/mode1o.asm: New file.

	* mpn/arm/arm-defs.m4 (LEA): New define.
	* mpn/arm/invert_limb.asm: Use LEA.

2012-04-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/bin_uiui.c (bc_bin_uiui): Nail support.
	* tests/cxx/t-ops2.cc: Test 0/3.
	* oddfac_1.c: assume n > 26.
	* tests/mpz/t-jac.c (mpn_jacobi_n): Enlarge tested sizes.

2012-04-24  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/v6/addmul_2.asm: New file.
	* mpn/arm/v6/mul_2.asm: New file.

2012-04-23  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/aorsmul_1.asm: Tweak loop control for a 6% speed increase.

2012-04-22  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in: Recognise ARM sub-architectures.

	* configfsf.guess: Update to current FSF version.
	* configfsf.sub: Likewise.

	* mpn/arm/bdiv_dbm1c.asm: New file.

	* mpn/arm/v6/mul_1.asm: New file.
	* mpn/arm/v6/addmul_1.asm: New file.

2012-04-22 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gen-fac.c: Renamed, was gen-fac_ui.c .
	* Makefile.am: Renamed gen-fac.c and fac_table.h .
	* gmp-impl.h: #include "fac_table.h".
	* mpz/oddfac_1.c: Use generated constant.
	* mpz/bin_ui.c: Small optimisations.

	* tune/common.c (speed_mpz_bin_ui): New function.
	* tune/speed.h: Declare it.
	* tune/speed.c: Use it.

2012-04-21  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/arm/mul_1.asm: Cleanup.
	* mpn/arm/copyi.asm: Cleanup, assume allocate-on-write cache.
	* mpn/arm/copyd.asm: Likewise.

	* mpn/arm/add_n.asm: Delete.
	* mpn/arm/sub_n.asm: Delete.
	* mpn/arm/aors_n.asm: New file, made from old files.

	* mpn/arm/addmul_1.asm: Delete.
	* mpn/arm/submul_1.asm: Delete.
	* mpn/arm/aorsmul_1.asm: New file, made from old files.

	* mpn/arm/com.asm: New file.
	* mpn/arm/lshift.asm: New file.
	* mpn/arm/rshift.asm: New file.

2012-04-20  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpq/io.c: New file.
	* tests/mpq/Makefile.am: Run it.

	* mpz/clrbit.c: Simplify along the lines of setbit.c.

2012-04-20 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/setbit.c: Simplify.

	* gmp-impl.h (LOG2C): Define.
	* mpz/fac_ui.c (LOG2C): Remove.
	* mpz/2fac_ui.c (LOG2C): Remove.
	* mpz/oddfac_1.c (LOG2C): Remove.
	* mpn/generic/binvert.c (LOG2C): Remove.
	* mpn/generic/invertappr.c (LOG2C): Remove.

	* mpz/bin_uiui.c (mpz_goetgheluck_bin_uiui): Move declarations,
	and assume that n and k are not small.

2012-04-19  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpz/Makefile.am (check_PROGRAMS): Add t-remove.

	* tests/mpz/t-remove.c: Clear out mpz variables.

	* tests/mpz/t-cong.c (check_random): Use much larger numbers.
	(check_data): Check congruences mod 0.

	* tests/mpz/t-divis.c: Test divisibility by zero.

	* tests/mpz/reuse.c: Test mpz_mod.

	* mpz/setbit.c: Remove dead code.  Use CNST_LIMB.
	* mpz/clrbit.c: Use CNST_LIMB.

2012-04-19 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* primesieve.c: New file, with functions from mpz/oddfac_1.c .
	* mpz/oddfac_1.c (bitwise_primesieve): Re-moved.
	* Makefile.am (libgmp_la_SOURCES): Add primesieve.c .
	* gmp-impl.h (gmp_primesieve): Declare.

	* mpz/bin_uiui.c (mpz_goetgheluck_bin_uiui): New, factor-based
	implementation.
	* tests/mpz/t-bin.c: Extend tests, to cover _goetgheluck.

	* mpz/primorial_ui.c: New file.
	* mpz/Makefile.am (libmpz_la_SOURCES): Add mpz/primorial_ui.c
	* Makefile.am (MPZ_OBJECTS): Add mpz/primorial_ui$U.lo
	* gmp-h.in (mpz_primorial_ui): Declare.
	* tests/mpz/t-primorial_ui.c: New test for the new function.
	* tests/mpz/Makefile.am (check_PROGRAMS): Add t-primorial_ui.
	* doc/gmp.texi: Short documentation for the new function.

2012-04-17  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/aorsmul_1.asm: Fix some DOS64 issues.
	* mpn/x86_64/coreisbr/mul_1.asm: Likewise.

	* mpn/x86_64/fastsse/lshiftc-movdqu2.asm: Adhere to DOS64 register
	partitioning rules.

	* mpn/x86_64/fastsse/copyi-palignr.asm: Implement temporary workaround
	to overlap issue.

2012-04-17 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/bin_uiui.c: Support small limbs (fallback on bin_ui).

	* tests/mpn/toom-sqr-shared.h: Use a restricted range.
	* tests/mpn/t-toom2-sqr.c: Specify correct range.
	* tests/mpn/t-toom3-sqr.c: Likewise.
	* tests/mpn/t-toom4-sqr.c: Likewise.
	* tests/mpn/t-toom6-sqr.c: Likewise.
	* tests/mpn/t-toom8-sqr.c: Likewise, but extended.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add t-toom?-sqr tests.

	* mpn/generic/sbpi1_bdiv_q.c: Move ASSERTs, to support qp = np.

2012-04-17  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/copyd.asm: Rewrite.
	* mpn/x86_64/copyi.asm: Rewrite.

2012-04-16  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/lshift-movdqu2.asm: Add DOS entry/exit sequences.
	* mpn/x86_64/fastsse/rshift-movdqu2.asm: Likewise.
	* mpn/x86_64/fastsse/lshiftc-movdqu2.asm: Likewise.

	* mpn/x86_64/x86_64-defs.m4 (palignr): New macro.
	(x86_opcode_regxmm, x86_opcode_regxmm_list): New, made from x86 mmx
	counterparts.
	(x86_lookup): Copy from x86/x86-defs.m4.
	* mpn/x86_64/fastsse/copyd-palignr.asm: Use palignr macro.
	* mpn/x86_64/fastsse/copyi-palignr.asm: Likewise.

2012-04-15 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* tests/mpz/t-bin.c: Add more tests on small values.
	* mpz/bin_uiui.c (mpz_bdiv_bin_uiui): Smaller temporary areas.

2012-04-15  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/copyd-palignr.asm: New file.
	* mpn/x86_64/fastsse/copyi-palignr.asm: New file.
	* mpn/x86_64/core2/copyd.asm: New file.
	* mpn/x86_64/core2/copyi.asm: New file.
	* mpn/x86_64/nano/copyd.asm: New file.
	* mpn/x86_64/nano/copyi.asm: New file.
	* mpn/x86_64/atom/copyd.asm: New file.
	* mpn/x86_64/atom/copyi.asm: New file.

2012-04-13 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/bin_uiui.c: Rewrite (some parts are Torbjorn's).
	* gen-fac_ui.c: Generate new constants for bin_uiui.

	* tests/mpz/t-fac_ui.c: Check Wilson's theorem on a big value.

	* mpn/generic/invert.c: Remove support for scratch == NULL.
	* tune/speed.h (SPEED_ROUTINE_MPN_MUPI_DIV_QR): Allocate scratch
	space for mpn_invert.

	* mpz/mul_i.h: Small clean-up.

	* tests/mpn/toom-sqr-shared.h: New file.
	* tests/mpn/t-toom2-sqr.c: New file.
	* tests/mpn/t-toom3-sqr.c: New file.
	* tests/mpn/t-toom4-sqr.c: New file.
	* tests/mpn/t-toom6-sqr.c: New file.
	* tests/mpn/t-toom8-sqr.c: New file.
	* tests/mpn/Makefile.am (EXTRA_DIST): Add toom-sqr-shared.h .

	* mpn/generic/toom62_mul.c: Use add_n, sub_n, when possible.

2012-04-12  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/lshift-movdqu2.asm: New file.
	* mpn/x86_64/fastsse/rshift-movdqu2.asm: New file.
	* mpn/x86_64/fastsse/lshiftc-movdqu2.asm: New file.
	* mpn/x86_64/coreisbr/lshift.asm: New file.
	* mpn/x86_64/coreisbr/rshift.asm: New file.
	* mpn/x86_64/coreisbr/lshiftc.asm: New file.
	* mpn/x86_64/k10/lshift.asm: New file.
	* mpn/x86_64/k10/rshift.asm: New file.
	* mpn/x86_64/k10/lshiftc.asm: New file.

	* mpn/x86_64/fastsse/lshift.asm: Simplify to very basic form.

2012-04-11  Niels Möller  <nisse@lysator.liu.se>

	* Makefile.am (check-mini-gmp): Pass -I../.. in EXTRA_CFLAGS, to
	locate gmp.h.

2012-04-10 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* Makefile.am (check-mini-gmp): Use $(MAKE).
	(clean-mini-gmp): New target.
	(clean-local, distclean-local): New automake targets. Depend on
	clean-mini-gmp.

	* gen-fac_ui.c (mpz_root): Remove.

2012-04-07  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/ia64/gcd_1.asm: Rewrite inner loop to use ctz table.

2012-04-05  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/p7/popcount.asm: Properly extend arg n for mode32.
	* mpn/powerpc64/p7/hamdist.asm: Likewise.

2012-04-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/powerpc64/p7/popcount.asm: New file.
	* mpn/powerpc64/p7/hamdist.asm: New file.

	* longlong.h (ARM count_leading_zeros): Enable for more arch versions.

	* mpn/x86_64/gcd_1.asm: Make room for DOS64 regparm shadow area.
	* mpn/x86_64/core2/gcd_1.asm: Likewise.

2012-04-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/aorrlsh_n.asm: Make it actually work for DOS64.

2012-04-02 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/oddfac_1.c: Initialize size for ASSERT.

2012-04-02  Torbjorn Granlund  <tege@gmplib.org>

	* gmp-h.in (_GMP_H_HAVE_FILE): Test also __STDIO_LOADED (for VMS).

	* gmp-impl.h (doprnt_format_t, etc): Remove bogus __GMP_DECLSPECs.

2012-03-30 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/x86_64/sqr_basecase.asm: Speed-up for small cases.

2012-03-29  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/sparc64/gcd_1.asm: New file.

2012-03-27  Torbjorn Granlund  <tege@gmplib.org>

	* config.guess: Fix typo in coreisbr recognition.

2012-03-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpn/x86_64/gcd_1.asm: Reduce latency.
	* mpn/x86_64/mul_basecase.asm: Save one jump.

	* mpz/iset_ui.c: Don't realloc.

2012-03-20 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mp_clz_tab.c: Add __clz_tab[128].
	* longlong.h (count_trailing_zeros): Use it in pure C variant.

2012-03-20  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in (x86 fat_path): Add many missing directories.
	* mpn/x86/fat/fat.c (__gmpn_cpuvec_init): Rewrite.
	(fake_cpuid_table): Add many more CPUs.

	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec_init): Minor spacing cleanup.

2012-03-19  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86/x86-defs.m4 (CALL, PIC_WITH_EBX): New macros.
	* mpn/x86/darwin.m4: Likewise.
	* mpn/x86/k7/gcd_1.asm: Use new macros to support PIC.
	* mpn/x86/p6/gcd_1.asm: Likewise.

2012-03-19 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* gen-fac_ui.c: Generate more constants (possible mini-mpz_root).
	* mpz/oddfac_1.c: Improve ASSERTs.
	(log_n_max): Use precomputed table.

	* longlong.h (_PROTO): Remove.

2012-03-18  Torbjorn Granlund  <tege@gmplib.org>

	* longlong.h (count_trailing_zeros): Write better pure C default
	variant.

	* mpn/x86/p6/gcd_1.asm: Remove forgotten x86_64 reference.

	* mpn/x86/p6/gmp-mparam.h: Update, to get BMOD_1_TO_MOD_1_THRESHOLD
	defined for fat binaries.

2012-03-17  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86/k7/gcd_1.asm: Rewrite.
	* mpn/x86/p6/gcd_1.asm: New file.

	* mpn/x86_64/core2/gcd_1.asm: Conditionally suppress reduction calls.
	* mpn/x86_64/gcd_1.asm: Rewrite.

2012-03-15  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/generic/gcd_1.c: Parameterise zerotab code.

	* mpn/x86_64/nano/gcd_1.asm: New file, grabbing core2 asm file.

	* mpn/x86_64/core2/gcd_1.asm: Speed up loop code, simplify non-loop
	code.

2012-03-13  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/core2/gcd_1.asm: Add hack to support fat builds.

	* mpn/x86_64/core2/gcd_1.asm: Shorten critical path.

2012-03-12  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/core2/gcd_1.asm: New file.
	* mpn/x86_64/k10/gcd_1.asm: New file, grabbing core2 asm file.
	* mpn/x86_64/bd1/gcd_1.asm: Likewise.

	* mpn/x86_64/bobcat/sqr_basecase.asm: New file.
	* mpn/x86_64/bobcat/mul_basecase.asm: Minor tuning.

2012-03-10  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in (fat_functions): Add addlsh1_n, addlsh2_n, addmul_2,
	mullo_basecase, redc_1, redc_2, sublsh1_n.

	* gmp-impl.h (struct cpuvec_t): Add fields for new fat functions.
	* gmp-impl.h: Adjust corresponding declarations.

	* mpn/generic/redc_2.c (mpn_addmul_2): Make static.

	* mpn/x86_64/fat/fat_entry.asm (FAT_INIT): Expand before fat_init to
	reduce branch offsets.  Pass plain 0,1,3... in %al since we'd else run
	out of 8-bit range.

	* mpn/x86_64/fat/fat_entry.asm (fat_init): Scale passed index value.
	* mpn/x86/fat/fat_entry.asm (fat_init): Use movzbl for expanding index
	value.

	* mpn/x86_64/x86_64-defs.m4 (CPUVEC_FUNCS_LIST): Add new fat functions.
	* mpn/x86/x86-defs.m4 (CPUVEC_FUNCS_LIST): Likewise.
	* mpn/x86_64/fat/fat.c (__gmpn_cpuvec): Likewise.
	* mpn/x86/fat/fat.c (__gmpn_cpuvec): Likewise.

	* mpn/x86_64/fat/redc_2.c: New file.
	* mpn/x86/fat/mullo_basecase.c: New file.
	* mpn/x86/fat/redc_1.c: New file.
	* mpn/x86/fat/redc_2.c: New file.

	* tests/mpn/t-fat.c: Test mullo_basecase.

2012-03-08  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/addmul_2.asm: Port to DOS64.

2012-02-29  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h: Ignore partial C++11 support in g++-4.6.
	* tests/cxx/t-cxx11.cc: Likewise.

	* gmpxx.h (operator""): New functions.
	* tests/cxx/t-cxx11.cc: Test the above.
	* doc/gmp.texi: Document the above.

2012-03-08 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* acinclude.m4 (GMP_H_ANSI): Remove.
	* configure.in: Don't use GMP_H_ANSI.
	* gmp-h.in (__GMP_HAVE_PROTOTYPES): Remove.

2012-03-08  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fat/fat.c (fake_cpuid_table): Recognise "bulldozer".
	(__gmpn_cpuvec_init): Overhaul to match configure.in.

	* configure.in: Adjust bulldozer path_64.

2012-03-07  Torbjorn Granlund  <tege@gmplib.org>

	* configure.in (x86_64 fat_path): List recently added AMD directories.

	* mpn/x86_64/bobcat/copyi.asm: New file.
	* mpn/x86_64/bobcat/copyd.asm: New file.

	* config.guess: Handle AMD 11h correctly.

	* tune/tuneup.c (tune_redc): Better handle situation where redc_2 is
	never faster.

2012-03-06  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bobcat/mul_basecase.asm: New file.

2012-03-04  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/bobcat/mul_1.asm: New file.
	* mpn/x86_64/bobcat/aorsmul_1.asm: New file.

2012-03-04 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/invert.c: Remove mod 0 branch.
	* tests/mpz/t-invert.c: Avoid testing mod 0.
	* doc/gmp.texi (mpz_invert): Specify mod 0 is not handled.

	* gmp-h.in (__gmp_signed, __gmp_const): Remove.
	(__GMP_HAVE_TOKEN_PASTE, __GMP_HAVE_CONST): Remove.
	* gmp-impl.h: Strip __GMP_HAVE_TOKEN_PASTE and __GMP_HAVE_CONST.
	* demos/expr/: Strip __gmp_const usage from all files.

	* tests/mpz/t-powm.c (allsizes_seen): Require unsigned*.

2012-03-03  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/k8/gmp-mparam.h: New file.
	* mpn/x86_64/k10/gmp-mparam.h: New file.

	* mpn/generic/hgcd_step.c (mpn_hgcd_step): Remove unused variables.
	* mpn/generic/hgcd_jacobi.c (hgcd_jacobi_step): Likewise.
	* mpn/generic/hgcd_reduce.c (hgcd_matrix_apply): Likewise.
	* mpn/generic/mu_bdiv_qr.c: Likewise.
	* mpz/jacobi.c: Likewise.
	* mpz/mod.c: Likewise.

	* mpn/generic/toom42_mul.c: Remove unread variable.
	* mpn/generic/set_str.c (mpn_set_str_compute_powtab): Likewise.
	* mpn/generic/rootrem.c (mpn_rootrem_internal): Likewise.
	* tests/refmpn.c (refmpn_mul): Likewise.
	* mpn/generic/hgcd_appr.c (mpn_hgcd_appr): Propagate mask computation
	into ASSERT, remove variable.

	* gmp-h.in (__GMP_PROTO): Remove.
	* Strip __GMP_PROTO usage from all files.
	* Strip prototype parameter names from all files.

2012-03-01 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* doc/gmp.texi (mpz_invert): Correctly document result range.
	* tests/mpz/t-invert.c: Small range correction.

2012-03-01  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/mullo_basecase.asm: New file.

2012-02-29  Marc Glisse  <marc.glisse@inria.fr>

	* gmpxx.h (std::numeric_limits): New partial specialization.

2012-02-29  Niels Möller  <nisse@lysator.liu.se>

	* Makefile.am (check-mini-gmp): Use $(MAKE).
	(clean-mini-gmp): New target.
	(clean-local, distclean-local): New automake targets. Depend on
	clean-mini-gmp.

2012-02-28  Niels Möller  <nisse@lysator.liu.se>

	* Makefile.am (check-mini-gmp): New target, for running the
	mini-gmp testsuite.

2012-02-27  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/fastsse/lshiftc.asm: New file.
	* mpn/x86_64/fastsse/com.asm: New file.

	* mpn/x86_64/bd1/popcount.asm: New file.
	* mpn/x86_64/bd1/hamdist.asm: New file.

	* mpn/x86_64/fastsse/copyi.asm: New file.
	* mpn/x86_64/fastsse/copyd.asm: New file.
	* mpn/x86_64/fastsse/lshift.asm: New file.

2012-02-26  Torbjorn Granlund  <tege@gmplib.org>

	* mpn/x86_64/coreisbr/addmul_2.asm: New file.

	* tests/devel/try.c (param_init): Don't require addmul_N to handle
	overlap.

	* mpn/x86_64/bd1/mul_1.asm: New file.
	* mpn/x86_64/bd1/aorsmul_1.asm: New file.

2012-02-26 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/2fac_ui.c: New file: implements n!!.
	* Makefile.am (MPZ_OBJECTS): Add mpz/2fac_ui.
	* gmp-h.in: Declare mpz_2fac_ui.
	* tests/mpz/t-fac.c: Test mpz_2fac_ui.
	* doc/gmp.texi: Document mpz_2fac_ui.
	* mpz/Makefile.am (libmpz_la_SOURCES): Add 2fac_ui.c.

	* mpz/oddfac_1.c (mpz_oddfac_1): Use umul_ppmm when size = 2.

2012-02-26  Niels Möller  <nisse@lysator.liu.se>

	* bootstrap.c: New file, replacing dumbmp.c. Uses mini-gmp for the
	standard GMP functions, and then defines the few functions
	particular for the bootstrap.
	* dumbmp.c: Deleted file. A few functions moved to bootstrap.c.

	* gen-bases.c: Include bootstrap.c, not dumbmp.c.
	* gen-fac_ui.c: Likewise.
	* gen-trialdivtab.c: Likewise.
	* gen-fib.c: Include bootstrap.c, not dumbmp.c. Use assert rather
	than ASSERT. Deleted casts of xmalloc return value.
	* gen-psqr.c: Likewise.
	(COLLAPSE_ELEMENT): Use memmove rather than mem_copyi.

	* Makefile.am: Replaced all uses of dumbmp.c by bootstrap.c.
	(EXTRA_DIST, dist-hook): Arrange for distribution of the mini-gmp
	files.

2012-02-24 Marco Bodrato <bodrato@mail.dm.unipi.it>

	* mpz/invert.c: Use ABSIZ, MPZ_EQUAL_1_P.
	* mpz/abs.c: Collapse MPZ_REALLOC(x,.) and PTR(x).
	* mpz/aors_ui.h: Likewise.
	* mpz/com.c: Likewise.
	* mpz/neg.c: Likewise.

	* mpz/invert.c: Reply "no-inverse" when modulus is zero.
	* tests/mpz/t-invert.c: Add more checks.
	* doc/gmp.texi (mpz_invert): Inverse can not be zero.

2012-02-24  Torbjorn Granlund  <tege@gmplib.org>

	* tests/mpn/logic.c: New file.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add logic.

	* tests/mpz/t-invert.c: New file.
	* tests/mpz/Makefile.am (check_PROGRAMS): Add t-invert.

2012-02-24  Marc Glisse  <marc.glisse@inria.fr>

	* tests/mpq/t-cmp.c: Move NUM and DEN macros...
	* tests/mpq/t-cmp_ui.c: Likewise...
	* gmp-impl.h: ... to here.

	* mpq/abs.c: Use NUM, DEN, SIZ, ALLOC, PTR, MPZ_REALLOC.
